#include "e_lib.h"
#include "patch.h"
#include "myarg.h"

static void UsagePrint(void);

static void UsagePrint(void)
{
  fprintf(stderr, "\nUsage: cubic filename [options]\n");
  fprintf(stderr, "\nOptions:\n");
  fprintf(stderr, "\t-h\tPrint help, this screen\n");
  fprintf(stderr, "\t-v\tVisualise geometric definition.\n");
  fprintf(stderr, "\t\tSimple MDF mesh is generated.\n");
  fprintf(stderr, "\t\tEntities are NOT subdivided.\n");
  fprintf(stderr,"\n\n");
}


int main(int argc, char *argv[])
{
  GEN   *Structure;
  char  *FileName;
  int    Visual;

  if(argc < 2)
  {
    UsagePrint();
    exit(-1);
  }

  if(GetSimpleArg(argc, argv, "-h"))
  {
    UsagePrint();
    exit(0);
  }

  if(GetSimpleArg(argc, argv, "-v"))
  {
    Visual = TRUE;
  }
  else
  {
    Visual = FALSE;
  }

  FileName = e_alloc_c_vect(strlen(argv[1])+1);

  strcpy(FileName, argv[1]);

  if(e_GetGenData(&Structure, FileName) == 0)
  {
    exit(-1);
  }

  if(Visual)
  {
/*    e_VisualGenFile(Structure, FileName); */
  }
  else
  {
    e_Generate_Mesh(Structure, FileName);
  }

  return 1;	/* to keep compiler happy */
}






