#include "e_lib.h"
#include "patch.h"

/* Visualise the GEN file */
void e_VisualGenFile(GEN *Structure, char *filename)
{

#if 0
  int i_coord, i_bloc, i_con;
  int patchID, xpos, ypos, n1, n2;
  int type, i_node, iw, ip, node;
  double weight, tw;
  double p1[3], p2[3];

  INTERNAL_MESH mesh;

  /* process nodes */
  mesh.Coords = 
    e_alloc_cont_d_matr(Structure.NNodes + (Structure.NConnections * 2), 3);
  for(i_coord = 0; i_coord < Structure.NNodes; i_coord++)
  {
    mesh.Coords[i_coord][0] = Structure.Coords[i_coord][0];
    mesh.Coords[i_coord][1] = Structure.Coords[i_coord][1];
    mesh.Coords[i_coord][2] = Structure.Coords[i_coord][2];
  }
  mesh.NPoints = Structure.NNodes;

  /* process patches */
  mesh.Quads      = e_alloc_cont_i_matr(Structure.NPatches, 4);
  mesh.Triangles  = e_alloc_cont_i_matr(Structure.NPatches, 3);
  mesh.NQuads     = 0;
  mesh.NTriangles = 0;
  for(i_bloc = 0; i_bloc < Structure.NPatches; i_bloc++)
  {
    if(Structure.Patches[i_bloc].PatchType == 4)
    {
      if(Structure.Patches[i_bloc].Definition == LINEAR)
      {
        mesh.Quads[mesh.NQuads][0] = Structure.Patches[i_bloc].Nodes[0];
        mesh.Quads[mesh.NQuads][1] = Structure.Patches[i_bloc].Nodes[1];
        mesh.Quads[mesh.NQuads][2] = Structure.Patches[i_bloc].Nodes[2];
        mesh.Quads[mesh.NQuads][3] = Structure.Patches[i_bloc].Nodes[3];
        mesh.NQuads++;
      }
      else
        e_GeneralError("Other definition is not yet implemented !");
    }
    else
    {
      e_GeneralError("Triangle is not yet supported !");
    }
  }

  /* process connections as well */
  mesh.Links[0] = e_alloc_cont_i_matr(Structure.NConnections, 2);
  mesh.Links[1] = e_alloc_cont_i_matr(Structure.NConnections, 2);
  mesh.Links[2] = e_alloc_cont_i_matr(Structure.NConnections, 2);
  mesh.Links[3] = e_alloc_cont_i_matr(Structure.NConnections, 2);
  mesh.Links[4] = e_alloc_cont_i_matr(Structure.NConnections, 2);

  mesh.NLinks[0] = 0;
  mesh.NLinks[1] = 0;
  mesh.NLinks[2] = 0;
  mesh.NLinks[3] = 0;
  mesh.NLinks[4] = 0;

  for(i_con = 0; i_con < Structure.NConnections; i_con++)
  {
    type = Structure.Connections[i_con].Type-1;
    for(i_node = 0; i_node < 2; i_node++)
    {
      if(Structure.Connections[i_con].Node[i_node] != 0)
      {
        node = Structure.Connections[i_con].Node[i_node]-1;
        mesh.Coords[mesh.NPoints][0] = Structure.Coords[node][0];
        mesh.Coords[mesh.NPoints][1] = Structure.Coords[node][1];
        mesh.Coords[mesh.NPoints][2] = Structure.Coords[node][2];
        mesh.NPoints++;

        mesh.Links[type][mesh.NLinks[type]][i_node] = mesh.NPoints;
      }
      else
      {
        patchID = Structure.Connections[i_con].PatchID[i_node]-1;
        xpos    = Structure.Connections[i_con].Position[i_node][0];
        ypos    = Structure.Connections[i_con].Position[i_node][1];
        if(Structure.Patches[patchID].PatchType == 4)
        {
          /* interpolate in 'x' direction */
          tw = 0;
          weight = 0;
          for(iw = 0; iw < Structure.Patches[patchID].XDivision; iw++)
          {
            if(Structure.Patches[patchID].XDivWeight[iw] == 0)
              Structure.Patches[patchID].XDivWeight[iw] = 1.0;
            tw += Structure.Patches[patchID].XDivWeight[iw];
            if(iw < xpos)
            {
              weight += Structure.Patches[patchID].XDivWeight[iw];
            }
          }
          weight /= tw;

          /* calculate two nodes on 'x' sides */
          n1 = Structure.Patches[patchID].Nodes[0]-1;
          n2 = Structure.Patches[patchID].Nodes[1]-1;
          for(ip = 0; ip < 3; ip++)
          {
            p1[ip] = (Structure.Coords[n1][ip] * (1 - weight)) +
                     (Structure.Coords[n2][ip] * weight);
          }

          n1 = Structure.Patches[patchID].Nodes[3]-1;
          n2 = Structure.Patches[patchID].Nodes[2]-1;
          for(ip = 0; ip < 3; ip++)
          {
            p2[ip] = (Structure.Coords[n1][ip] * (1 - weight)) +
                     (Structure.Coords[n2][ip] * weight);
          }
          
          /* interpolate in 'y' direction */
          tw = 0;
          weight = 0;
          for(iw = 0; iw < Structure.Patches[patchID].YDivision; iw++)
          {
            if(Structure.Patches[patchID].YDivWeight[iw] == 0)
              Structure.Patches[patchID].YDivWeight[iw] = 1.0;
            tw += Structure.Patches[patchID].YDivWeight[iw];
            if(iw < ypos)
            {
              weight += Structure.Patches[patchID].YDivWeight[iw];
            }
          }
          weight /= tw;

          /* calculate final nodes */
          for(ip = 0; ip < 3; ip++)
          {
            mesh.Coords[mesh.NPoints][ip] = (p1[ip] * (1 - weight)) +
                                            (p2[ip] * weight);
          }
          mesh.NPoints++;
          mesh.Links[type][mesh.NLinks[type]][i_node] = mesh.NPoints;

        }
        else
          e_GeneralError("No Triangles !");
      }
    }
    mesh.NLinks[type]++;
  }

  /* finalise numbers */
  mesh.FNQuads     = mesh.NQuads;
  mesh.FNTriangles = mesh.NTriangles;

  mesh.FNLinks[0]  = mesh.NLinks[0];
  mesh.FNLinks[1]  = mesh.NLinks[1];
  mesh.FNLinks[2]  = mesh.NLinks[2];
  mesh.FNLinks[3]  = mesh.NLinks[3];
  mesh.FNLinks[4]  = mesh.NLinks[4];

  mesh.Mark      = e_alloc_i_vect(mesh.NPoints);
  mesh.Translate = e_alloc_i_vect(mesh.NPoints);
  for(i_coord = 0; i_coord < mesh.NPoints; i_coord++)
    mesh.Translate[i_coord] = i_coord+1;

  mesh.Duplicate = 0;

  p_OutputFinalMesh(&mesh, Structure, "GEN visualisation", filename);

#endif

}

