/* 
 * Configuration parameters during compile time
 */

#ifndef __CONFIG_H__
#define __CONFIG_H__

/* uncomment one of these for parallel version of DR */
 #define DD_TYPE_COMM 
/* #define AL_TYPE_COMM */
/* #define BU_TYPE_COMM */

/* logging MPI function calls for profiling */
/*
#define COMM_LOG
*/

/* uncomment for time profiling element calculation */
/*
#define __TIME_ELEM_CALC__
*/

/* 
 * The level of output information for debugging.
 * It can be printing or mesh or other data structure written into files.
 */
/* #define __DEBUG_1__ */ /* only a little bit more than normal output */
/* #define __DEBUG_2__ */ /* lots of info, maybe useful, maybe not */
/* #define __DEBUG_3__ */ /* you can check everything, with this output */

/* ##################################################### */
/* ##################################################### */
/* If you know what you are doing, change values below   */
/* ##################################################### */
/* ##################################################### */

/* Comment it out when boundary conditions are given as
 * displacement constraints. When commented large mass is
 * assigned for fixity.
 */
/* #define DISPLACEMENT_BC */

/* we always send only one vector, 
   no need to allocate too large memory */
#define MAX_VECTOR_COMM  1

/* uncomment and change for other prestressing of g-strings */
/*
#define E_G_STRING_DIV 3.0
*/

#define DR_ZERO         1e-14              /* how close we are to a value 
                                              (approx. for equality) */
#define DR_BIG_MASS     1e+50              /* for fixed boundary condition */
#define DR_TAN90        1.570796326794897  /* tan(90 degree) */

#define DR_MAX_ENERGY   1e+30              /* max energy value for divergence */


#define ALLOC_SIZE      16                 /* incremental allocation by this size */

/* all communication are symmetric, leave this option */
#define  __SYMMETRIC__

#endif



