#ifndef __DR_COMM__
#define __DR_COMM__

#include "config.h" /* configuration options */

#include "e_lib.h"  /* MESH definition */
#include "dr.h"     /* DR_DATA definition */

/* related functions */
#ifdef DD_TYPE_COMM
#include "dr_comm_dd.h"
#endif

#ifdef AL_TYPE_COMM
#include "dr_comm_al.h"
#endif

#ifdef BU_TYPE_COMM
#include "dr_comm_bu.h"
#endif


void SetupSubdomains(int ProcID, int NSubdomains,
                     DR_DATA *Gdata, MESH *Gmesh, 
                     DR_DATA **data, MESH **mesh);

/* should be defined for the user */
#ifndef COMM_NAME
#error "COMM_NAME is not defined !!!"
#endif

#endif






/* thrown away for the time being */
#if 0

#ifdef  DR_MAIN
#define X_MAIN
#else
#define X_MAIN  extern
#endif



X_MAIN int   GV_procID;
X_MAIN int   GV_total_no_subdomains;


#ifdef J_PM_COMM

#define MULTI 200
#define PAIR 300

X_MAIN int       GV_PM_NoISDNodes;
X_MAIN int       GV_PM_alloc_NoISDNodes;
X_MAIN int     **GV_PM_comm_info_buf;

struct comm_str
{
  double **comm_buf;     /* the buffer reserved for the comm.              */
  int     *localN;       /* the local node numbers of the Interface Nodes  */
};

X_MAIN int        Gco_NoSDp;    /*  the number of SubDoms this SD is connected to
                                    for pair communication */
X_MAIN int      **Gco_ListSDp;  /*  [Gco_NoSDp][2]
                                    list of SubDoms for pair communication */
X_MAIN struct comm_str *Gco_pcomm_admin;  /*  [Gco_NoSDp]
                                              comm structures for all pair comms */
X_MAIN MPI_Request     *Gco_pcomm_chanvec; /* channel ptr vector for receiving
                                              in pair communication */
X_MAIN int  *Gco_pcomm_chanadm;  /*  list of SD indexes in ListSDp receiving from
                                     in pair communication */
X_MAIN int   Gco_NoSDm_sml,Gco_NoSDm_grt; /* the number of Interface Nodes this SD is
                                             connected to for multi communication */
X_MAIN int   **Gco_ListSDm_sml,**Gco_ListSDm_grt;  /*  [Gco_NoSDm][3]
                                                       list of SubDoms (or Nodes) for 
                                                       multi communication */
X_MAIN struct comm_str *Gco_mcomm_admin_sml,*Gco_mcomm_admin_grt;    
/*  [Gco_NoSDm_...]
    mcomm structures for all multi comms              */
X_MAIN MPI_Request *Gco_mcomm_chanvec;    /* channel ptr vector for receiving
                                             in multi communication */
X_MAIN int    *Gco_mcomm_chanadm;   /* list of SD indexes in ListSDp receiving from
                                       in multi communication */

#endif /* J_PM_COMM */

#endif


