#ifndef __DR_COMM_AL_H__
#define __DR_COMM_AL_H__

#include "stdlib.h"

#ifndef __E_MPI__
#error "__E_MPI__ is not defined for dr_comm_al.h"
#endif

/* notify user about the communication type */
#define COMM_NAME "AL"

#ifndef MAX_VECTOR_COMM
#define MAX_VECTOR_COMM  6
#endif

/* data structure for communication */
typedef struct
{
  int       Par_ProcID;
  int       Par_NSubdomains;

  /* members below are handled by "Init" functions */
  int       Par_TotalNElem;
  int       Par_NElem;
  int      *Par_Elems;
  int      *Par_ElemPos;
  
  /* members below are handled by "Final" function */
  double   *Par_BufSend;
  double   *Par_BufRecv;

  double   *Values[MAX_VECTOR_COMM];
}
REDUCE_VECTOR_DATA;


void SetupSymCommDataInit(int dimension, int NSubdomains, int i_subdom,
                          int NInterSubDomNodes, int *InterSubDomNodes,
                          int *NNodeSubDoms, int **NodeSubDoms,
                          REDUCE_VECTOR_DATA **data);
void FreeSymCommDataInit(int NSubdomains, REDUCE_VECTOR_DATA *data);
void ConvertSymCommDataInit(MESH *mesh, REDUCE_VECTOR_DATA *data, 
                            int dimension);

void SendCommDataInit(int NSubdomains, REDUCE_VECTOR_DATA *data, int i_subdom);
void RecvCommDataInit(int NSubdomains, REDUCE_VECTOR_DATA **data, int i_subdom);
void SetupCommDataFinal(REDUCE_VECTOR_DATA *data);
void CommunicateData(int n, REDUCE_VECTOR_DATA *data);

#endif


