#ifndef __DR_DATA__
#define __DR_DATA__

#include "config.h"

#include "e_lib.h"  /* MESH definition */
#include "dr.h"     /* DR_DATA definition */

#define E_MAS  "mas"

#define E_KW_MAS_GLOBAL  "GLOBAL_MASS_MULT"
#define E_KW_MAS_LOCAL   "N_ADD_MASSES"


void GetDrDataInit(char *FileName, DR_DATA **data);
void SetupDrDataFinal(DR_DATA *data, MESH *mesh);
void FreeDrDataInit(DR_DATA *data);

#ifdef __E_MPI__
void SendDrDataInit(DR_DATA *data, MESH *mesh, int subdom);
void RecvDrDataInit(DR_DATA **data, MESH *mesh, int subdom);
void CreateSubDrDataInit(DR_DATA *Gdata, MESH *Gmesh,
                         DR_DATA **data, MESH *mesh,
                         int i_subdom, int NInterSubDomNodes, 
                         int *InterSubDomNodes, int *NNodeSubDoms, 
                         int **NodeSubDoms);
#endif

void GetMassData(DR_DATA *data, int NNodes);

#endif



