#ifndef __DR_IO_H__
#define __DR_IO_H__

#include "config.h"

#include "e_lib.h"   /* MESH definition */
#include "dr.h"      /* DR_DATA definition */

#define E_RES "res"
#define E_VEL "vel"

#ifdef __E_MPI__

void InitDR(int argc, char **argv, 
            DR_DATA **Gdata, MESH **Gmesh,
            DR_DATA **data,  MESH **mesh);
void WriteResultOut(DR_DATA *Gdata, MESH *Gmesh, 
                    DR_DATA *data,  MESH *mesh);


#else

void InitDR(int argc, char **argv, 
            DR_DATA **data, MESH **mesh);
void WriteResultOut(DR_DATA *data, MESH *mesh);

#endif

int PutDataPerNodes(double **result, char *keyword, char *extension, 
                    char *name, MESH *mesh, int dimension);


#endif




