#ifndef __DR_LEN_H__
#define __DR_LEN_H__

#include "config.h"

#include "e_lib.h" /* MESH definition */

#define E_LEN  "len"

#define E_KW_LEN_LENGTH_LINK1    "INIT_LENGTH_LINK1"
#define E_KW_LEN_LENGTH_LINK2    "INIT_LENGTH_LINK2"
#define E_KW_LEN_LENGTH_LINK3    "INIT_LENGTH_LINK3"
#define E_KW_LEN_LENGTH_LINK4    "INIT_LENGTH_LINK4"
#define E_KW_LEN_LENGTH_LINK5    "INIT_LENGTH_LINK5"

#define E_KW_LEN_LENGTH_TRIANG3  "INIT_LENGTH_TRIANG3"
#define E_KW_LEN_LENGTH_TRIANG4  "INIT_LENGTH_TRIANG4"
#define E_KW_LEN_LENGTH_TRIANG5  "INIT_LENGTH_TRIANG5"

#define E_KW_LEN_END             "END"

/* geodesic string initial length is divided by this factor,
   this ensures high pre-stress immediately */
#ifndef E_G_STRING_DIV
#define E_G_STRING_DIV 1.5
#endif

typedef struct
{
  double    *InitLength;         /* initial or slack length data per element */
  double    *InitLengthLink1;
  double    *InitLengthLink2;
  double    *InitLengthLink3;
  double    *InitLengthLink4;
  double    *InitLengthLink5;

  double   **InitLengthTriang3;  /* per element per side */
  double   **InitLengthTriang4;
  double   **InitLengthTriang5;
}
INIT_LENGTH_DATA;


void SetupInitLengthData(INIT_LENGTH_DATA **data, MESH *mesh);
void GetInitLengthData(char *Projectname, INIT_LENGTH_DATA **data, MESH *mesh);

void GenInitLengthData(INIT_LENGTH_DATA *data, MESH *mesh, 
                       int *treated, int triang3, int triang4, int triang5);
void PutInitLengthData(char *Projectname, INIT_LENGTH_DATA *data, MESH *mesh);
void FreeInitLengthData(INIT_LENGTH_DATA *data);

#ifdef __E_MPI__
void SendInitLengthData(INIT_LENGTH_DATA *data, MESH *mesh, int subdom);
void RecvInitLengthData(INIT_LENGTH_DATA **data, MESH *mesh, int subdom);
void CreateSubInitLengthData(INIT_LENGTH_DATA *Gdata, MESH *Gmesh,
                             INIT_LENGTH_DATA **data, MESH *mesh);
#endif


#endif


