#ifndef DR_STRESS__
#define DR_STRESS__

#include "e_lib.h"
#include "dr_data.h"

void Unstress_GenTriangInitLength(int *Nodes, double **Coords, 
                                  double YoungMod, double PoissonRatio,
                                  double SigmaX, double SigmaY, double TauXY,
                                  double *TriangLength);
INIT_LENGTH_DATA *Unstress_GenMeshInitLength(DR_DATA *data, MESH *mesh);
MESH *Unstress_GenMesh(MESH *mesh);
void WriteAnalysisFile(char *ProjectName, DR_DATA *data, MESH *mesh);
/* void WriteForceFile(char *ProjectName, DR_DATA *data, MESH *mesh); */

void LinkForce(int NElems, int **Nodes, 
               double **Coords, MAT **Material, double *InitLength,
               int negative, double ***LinkStresses);
void TriangForce(int NElems, int **Nodes,
                 double **Coords, MAT **Material, 
                 double **InitLength, double ***TriangStresses);
void CheckTriangForce(int NElems, int **Nodes, double **Coords, 
                      MAT **Material, double **InitCoords, 
                      double ***TriangStresses);
void SetupStressStruct(MESH *mesh);




#endif
