#ifndef GA_H__
#define GA_H__

/*
   - maximum number is limited by the type "long" otherwise
   there are no limitations for the size of a chromosome or
   population or anything
   - fitness value from objective function should be always greater
   or equal than zero
*/

/* GA input data file extension */
#define E_GA "ga"

/* input data for the GA */
typedef struct
{
  long          GA_Popsize;
  long          GA_MaxGen;
  double        GA_CrossProb;
  double        GA_MutationProb;
  unsigned int  GA_Seed;
  int           GA_LinScale;
  int           GA_Printing;
}
GA_DATA;


/* a chromosome will be an array of the below defined type variable */
#define CHROM_TYPE char

typedef struct
{
  long lparam;
  double parameter;
  double minparam;
  double maxparam;
} PARAM;

typedef PARAM *DESIGNPARAMS;

/* ga.c */
double objective_function(long npars, DESIGNPARAMS vars);
void genetic_algorithm(long popsize, double pcross, double pmutation,
                 long npars, DESIGNPARAMS param, long maxgen, 
                 int scaling, int printing);

/* gaio.c */
int GetGAParam(char *name, GA_DATA **data);

#endif
