/*
 * Functions for measuring elapsed time
 */

#include "timer.h"

/* internal variable for storing time value */
static unsigned long StartTimeValue;


/* start the timer */
void StartTimer(void)
{
  StartTimeValue = GetTime();
}

/* provide the elapsed time for user */
long ElapsedTime(void)
{
  return ( GetTime() - StartTimeValue );
}

/* get timer value */
long GetTime(void)
{
   struct timeval tv;
   struct timezone tz;

   gettimeofday( &tv, &tz );

   return( tv.tv_usec/1000+tv.tv_sec*1000 );
}



