/* ////////////////////////////////////////////////////////////////////////// */
/*                                                                            */
/*                    e_GetDecompData(), e_PutDecompData()                    */
/*                                Header File                                 */
/*                                                                            */
/* ////////////////////////////////////////////////////////////////////////// */


static int AllCompulsoryKeywordsSet(void);
static int Initialise(MESH *mesh);
static int IsAKeyword(char *word);
static int WordMatchesKeyword(char *Keyword, char *word);

static int GetData(MESH *mesh);
static int GetNSubDoms(void);
static int GetSubDoms(int NElements, int *SubDoms);

static void DeallocateAllMemory(void);
static void SetMeshData(MESH *mesh);


/* ////////////////////////////////////////////////////////////////////////// */
/* Mesh data */

static int NElemsLink1;                 /* number of LINK1 elements */
static int NElemsLink2;                 /* number of LINK2 elements */
static int NElemsLink3;                 /* number of LINK3 elements */
static int NElemsLink4;                 /* number of LINK4 elements */
static int NElemsLink5;                 /* number of LINK5 elements */
static int NElemsTriang1;               /* number of TRIANG1 elements */
static int NElemsTriang2;               /* number of TRIANG2 elements */
static int NElemsTriang3;               /* number of TRIANG3 elements */
static int NElemsTriang4;               /* number of TRIANG4 elements */
static int NElemsTriang5;               /* number of TRIANG5 elements */
static int NElemsQuad1;                 /* number of QUAD1 elements */
static int NElemsQuad3;                 /* number of QUAD3 elements */
static int NElemsTetrah1;               /* number of TETRAH1 elements */
static int NElemsBlock1;                /* number of BLOCK1 elements  */
static int TotalNElems;                 /* total number of elements */


/* ////////////////////////////////////////////////////////////////////////// */
/* Decomposition data */

static int NSubDoms;                    /* number of subdomains  */
static int *SubDoms;                    /* subdomain indices */
static int *SubDomsLink1;               /* LINK1 subdomain indices */
static int *SubDomsLink2;               /* LINK2 subdomain indices */
static int *SubDomsLink3;               /* LINK3 subdomain indices */
static int *SubDomsLink4;               /* LINK4 subdomain indices */
static int *SubDomsLink5;               /* LINK5 subdomain indices */
static int *SubDomsTriang1;             /* TRIANG1 subdomain indices */
static int *SubDomsTriang2;             /* TRIANG2 subdomain indices */
static int *SubDomsTriang3;             /* TRIANG3 subdomain indices */
static int *SubDomsTriang4;             /* TRIANG4 subdomain indices */
static int *SubDomsTriang5;             /* TRIANG5 subdomain indices */
static int *SubDomsQuad1;               /* QUAD1 subdomain indices */
static int *SubDomsQuad3;               /* QUAD3 subdomain indices */
static int *SubDomsTetrah1;             /* TETRAH1 subdomain indices */
static int *SubDomsBlock1;              /* BLOCK1 subdomain indices */


/* ////////////////////////////////////////////////////////////////////////// */

static int LineNumber;                  /* current line number */

static char AllCompKeywordsSet;         /* whether compulsory keywords set */
static char *FullPathName;              /* io-file full pathname */
static char line[E_LINE_MAX + 1];       /* file line */

static FILE *fp;                        /* io-file pointer */
