/* ////////////////////////////////////////////////////////////////////////// */
/*                                                                            */
/*                     e_GetGeomModel(), e_PutGeomModel()                     */
/*                                Header File                                 */
/*                                                                            */
/* ////////////////////////////////////////////////////////////////////////// */


static int IsAKeyword(char *word);
static int WordMatchesKeyword(char *Keyword, char *word);

static int GetData(void);
static int GetNEndPoints(void);
static int GetEndPointCoords(void);
static int GetNurbsCurveIndex(void);
static int GetNurbsCurveDegree(NURBSCURVE *NurbsCurve);
static int GetNurbsCurveCntlPoints(NURBSCURVE *NurbsCurve);
static int GetNurbsCurveWeights(NURBSCURVE *NurbsCurve);
static int GetFixity(NURBSCURVE *NurbsCurve);
static int GetLoad(double **Load);
static int GetPointLoadParam(NURBSCURVE *NurbsCurve);
static int GetEnd(char *word);

static void DeallocateAllMemory(void);
static void Initialise(MESH *mesh);
static void SetGeomData(MESH *mesh);


/* ////////////////////////////////////////////////////////////////////////// */
/* Geometric model data */

static GEOM *Geom;                   /* GEOM structure */


/* ////////////////////////////////////////////////////////////////////////// */

static int LineNumber;               /* current line number */

static char *FullPathName;           /* io-file full pathname */
static char line[E_LINE_MAX + 1];    /* file line */

static FILE *fp;                     /* io-file pointer */
