/* ////////////////////////////////////////////////////////////////////////// */
/*                                                                            */
/*                              e_GetMaterials()                              */
/*                                Header File                                 */
/*                                                                            */
/* ////////////////////////////////////////////////////////////////////////// */


static int GetCompPropsType1Index(char *CompMaterialName);
static int GetPropsIndex(char *string);
static int GetPropsKeywordIndex(char *word);
static int Initialise(MESH *mesh);
static int IsAKeyword(char *word);
static int WordMatchesKeyword(char *Keyword, char *word);
static int WordMatchesPropKeyword(int i, char *Keyword, char *word);

static int GetCompMaterialsType1(void);
static int GetCompMatPropsType1(COMPMAT1 *CompPropsType1);
static int GetNLayers(COMPMAT1 *CompPropsType1);
static int GetLayerMaterials(COMPMAT1 *CompPropsType1);
static int GetLayerThicknesses(COMPMAT1 *CompPropsType1);

static int GetUsedMaterials(void);
static int GetMaterialProperties(MAT *Props);
static int GetKeywordData(int i, MAT *Props);
static int GetMatType(int *MatType);
static int GetDensity(double *Density);
static int GetYMod(double *YMod);
static int GetYMod_x(double *YMod_x);
static int GetYMod_y(double *YMod_y);
static int GetYMod_z(double *YMod_z);
static int GetPoissonsRatio(double *PoissonsRatio);
static int GetThickness(double *thickness);
static int GetiParam(int *iParam, int iParamNumber, char *iParamName);
static int GetdParam(double *dParam, int dParamNumber, char *dParamName);

static void DeallocateAllMemory(void);
static void SetMeshData(MESH *mesh);


/* ////////////////////////////////////////////////////////////////////////// */
/* Mesh data */

static int NMats;                       /* number of materials XXXXXX */
static int NMdfMats;                    /* number of ".mdf" declared mats */
static int NCompMatsType1;              /* number of TYPE1 composite mats. */

static MAT *Props;                      /* material properties */
static COMPMAT1 *CompPropsType1;        /* TYPE1 composite properties */

static int **KeywordSet;                /* material keyword set Booleans */


/* ////////////////////////////////////////////////////////////////////////// */

static int CurrentNMats;                /* current number of materials */
static int CurrentNCompMatsType1;       /* current number of TYPE1 composite
                                           materials read from material file */
static int CurrentPropsIndex;           /* current material properties index */
static int LineNumber;                  /* current line number */

static char Keyword[E_NMAT_PROP_KEYWORDS][E_KEYWORD_MAX + 1];
                                        /* property keyword strings */
static char *FullPathName;              /* io-file full pathname */
static char line[E_LINE_MAX + 1];       /* file line */
static char word[E_LINE_MAX + 1];       /* potential keyword */

static char *MaterialDefined;           /* whether materials has been defined */
static char *CompMatDefinedType1;       /* whether composite materials have
                                           been defined                     */

static FILE *fp;                        /* io-file pointer */
