/* ////////////////////////////////////////////////////////////////////////// */
/*                                                                            */
/*                    e_GetMeshParams(), e_PutMeshParams()                    */
/*                                Header File                                 */
/*                                                                            */
/* ////////////////////////////////////////////////////////////////////////// */


static int IsAKeyword(char *word);
static int WordMatchesKeyword(char *Keyword, char *word);

static int GetData(MESH *mesh);
static int GetNodalMeshParams(int NMeshPoints);
static int GetElemMeshParams(int NElements, double *ElemMeshParams);

static void DeallocateAllMemory(void);
static void Initialise(void);
static void SetMeshData(MESH *mesh);


/* ////////////////////////////////////////////////////////////////////////// */
/* Mesh parameters data */

double *NodalMeshParams;                /* nodal mesh parameters */
double *ElemMeshParams;                 /* element mesh parameters */
double *ElemMeshParamsLink1;            /* LINK1 mesh parameters */
double *ElemMeshParamsLink2;            /* LINK2 mesh parameters */
double *ElemMeshParamsLink3;            /* LINK3 mesh parameters */
double *ElemMeshParamsLink4;            /* LINK4 mesh parameters */
double *ElemMeshParamsLink5;            /* LINK5 mesh parameters */
double *ElemMeshParamsTriang1;          /* TRIANG1 mesh parameters */
double *ElemMeshParamsTriang2;          /* TRIANG2 mesh parameters */
double *ElemMeshParamsTriang3;          /* TRIANG3 mesh parameters */
double *ElemMeshParamsTriang4;          /* TRIANG4 mesh parameters */
double *ElemMeshParamsTriang5;          /* TRIANG5 mesh parameters */
double *ElemMeshParamsQuad1;            /* QUAD1 mesh parameters */
double *ElemMeshParamsQuad3;            /* QUAD3 mesh parameters */
double *ElemMeshParamsTetrah1;          /* TETRAH1 mesh parameters */
double *ElemMeshParamsBlock1;           /* BLOCK1 mesh parameters */

int NodalMeshParamsSet;                 /* nodal mesh parameters set? */
int ElemMeshParamsSet;                  /* element mesh parameters set? */


/* ////////////////////////////////////////////////////////////////////////// */

static int LineNumber;                  /* current line number */

static char *FullPathName;              /* io-file full pathname */
static char line[E_LINE_MAX + 1];       /* file line */

static FILE *fp;                        /* io-file pointer */
