/* ////////////////////////////////////////////////////////////////////////// */
/*                                                                            */
/*                       Miscellaneous E-Lib Functions                        */
/*                                Header File                                 */
/*                                                                            */
/* ////////////////////////////////////////////////////////////////////////// */


/* ////////////////////////////////////////////////////////////////////////// */
/*                                                                            */
/*                              e_SetAdjElems()                               */
/*                                                                            */
/* ////////////////////////////////////////////////////////////////////////// */


static int GetAdjElem(int NVpE, int NVpI, int **Vertices,
                      int *InterfVertices, int Degree, int *AdjElems,
                      char *ElemFound                                );


/* ////////////////////////////////////////////////////////////////////////// */
/*                                                                            */
/*                           e_SetNodalMeshParams()                           */
/*                                                                            */
/* ////////////////////////////////////////////////////////////////////////// */


static void SetElemTypeNodalMeshParams(MESH *mesh, int ElemType,
                                       int NVpE, int NElems,
                                       int **Nodes, int *NNeighElems);


/* ////////////////////////////////////////////////////////////////////////// */
/*                                                                            */
/*                          e_GetNInterSubDomNodes()                          */
/*                                                                            */
/* ////////////////////////////////////////////////////////////////////////// */


static int SetElemTypeNInterSubDomNodes(MESH *mesh,
                                        int ElemType, int NNpE,
                                        int NElems, int **Nodes,
                                        int *NAdjacentElements,
                                        int **AdjacentElements  );


/* ////////////////////////////////////////////////////////////////////////// */
/*                                                                            */
/*                          e_GetInterSubDomNodes()                           */
/*                                                                            */
/* ////////////////////////////////////////////////////////////////////////// */


static void SetElemTypeInterSubDomNodes(MESH *mesh, int ElemType,
                                        int NNpE, int NElems,
                                        int **Nodes, int **NodeSubs);


/* ////////////////////////////////////////////////////////////////////////// */
/*                                                                            */
/*                       e_SubDomBoundaries2PolyPolygon()                     */
/*                                                                            */
/* ////////////////////////////////////////////////////////////////////////// */


static int CalcDpA(void);
static int GetNewStartingInterface(void);
static int GetSubdomainBoundary(int *NConnectedRegions, int **NBoundaryPoints,
                                     int ***BoundaryPoints, int SubdomainIndex);
static int IsABoundaryInterface(int k, int j, int SubdomainIndex);
static int UpdateDpA(int ElementIndex, int vertex1, int vertex2);

static void FreeCalcDpA(void);
static void UpdateBoundary(int StartPoint, int *CurrentEndPoint,
                           int NConnectedRegions, int *NBoundaryPoints,
                                                   int **BoundaryPoints);


static int **g_Adjacency;           /* adjacency matrix */
static int  *g_Degree;              /* element degree vector */
static int **g_InterfaceElements1;  /* 1st els. adjacent to each interface */
static int **g_InterfaceElements2;  /* 2nd els. adjacent to each interface */
static int **g_InterfaceMeshPoints; /* mesh-points adjacent to each MP */ 
static int  *g_NAdjacentMeshPoints; /* number of MPs adjacent to each MP */
static int  *g_BoundaryMeshPoints1; /* first inter-subdomain element vertex */
static int  *g_BoundaryMeshPoints2; /* second inter-subdomain element vertex */
static int   g_NBoundaryInterfaces; /* number of inter-subdomain interfaces */
static int   g_TotalNElems;         /* total number of elements */ 
static int   g_NMeshPoints;         /* number of mesh-points */
static int   g_NVpE;                /* number of vertices per element */

static char *g_InterfaceNotStored;  /* whether an interface has been stored */

static MESH *g_Mesh;                /* MESH pointer */


/* ////////////////////////////////////////////////////////////////////////// */


#define NVECTOR_MAX  10             /* (initial) maximum vector length */
