/* ////////////////////////////////////////////////////////////////////////// */
/*                                                                            */
/*                       e_GetStresses(), e_PutStresses()                     */
/*                                Header File                                 */
/*                                                                            */
/* ////////////////////////////////////////////////////////////////////////// */


static int IsAKeyword(char *word);
static int WordMatchesKeyword(char *Keyword, char *word);

static int GetData(MESH *mesh);

static int GetStresses(int NElements, int NGauss_points, double ***ElemStresses);
static int GetStressesPerLayer(int NElements,  COMPMAT1 **Material, 
                               int NGauss_points,double ****ElemStresses);

static void DeallocateAllMemory(MESH *mesh);
static int Initialise(MESH *mesh);
static void SetMeshData(MESH *mesh);

/* ////////////////////////////////////////////////////////////////////////// */
/* Stress data */


   double  ***StressesLink1;           /* LINK1 stresses */
   double  ***StressesLink2;           /* LINK2 stresses */
   double  ***StressesLink3;           /* LINK3 stresses */
   double  ***StressesLink4;           /* LINK4 stresses */
   double  ***StressesLink5;           /* LINK5 stresses */
   double  ***StressesTriang1;         /* TRIANG1 stresses */
   double ****StressesTriang2;         /* TRIANG2 stresses */
   double  ***StressesTriang3;         /* TRIANG3 stresses */
   double  ***StressesTriang4;         /* TRIANG4 stresses */
   double  ***StressesTriang5;         /* TRIANG5 stresses */
   double  ***StressesQuad1;           /* QUAD1 stresses */
   double ****StressesQuad3;           /* QUAD3 stresses */
   double  ***StressesTetrah1;         /* TETRAH1 stresses */
   double  ***StressesBlock1;          /* BLOCK1 stresses */

   int maxNLayerTriang2, maxNLayerQuad3;

/* ////////////////////////////////////////////////////////////////////////// */

static int LineNumber;                  /* current line number */

static char *FullPathName;              /* io-file full pathname */
static char line[E_LINE_MAX + 1];       /* file line */

static FILE *fp;                        /* io-file pointer */
