#include "e_pltfrm.h"
#include <stdlib.h>   
#include <stdio.h>
#include <math.h>   
#include <time.h>   

#include <e_lib.h>

#include "elibtest.h"


/* ////////////////////////////////////////////////////////////////////////// */


int main(int argc, char *argv[])
{
   int k,l;

   int Subdomains1[9] = { 1, 1, 2, 1, 2, 2, 1, 2, 1 };
   int Subdomains2[5] = { 1, 1, 2, 2, 1 };
   int Subdomains3[9] = { 1, 1, 2, 1, 2, 3, 2, 3, 3 };
   int Subdomains4[3] = { 1, 2, 2 };
   int *SubDoms;

   int NCutInterfaces;
   int NInterSubDomNodes;
   int WeightedNInterSubDomNodes;
   int *InterSubDomNodes;
   int *NNodeSubDoms;
   int **NodeSubDoms;

   MESH *mesh, *nametest;
   MESH *SubMesh1 = NULL;
   MESH *SubMesh2 = NULL;
   MESH *SubMesh3 = NULL;
   MESH *SubMesh11 = NULL;
   MESH *SubMesh12 = NULL;


   if ((g_fp = fopen("data/test.cmp","w")) == NULL)
   {
      e_FileError("data/test.cmp","cannot open file");
      return 0;
   }

   e_GetMeshData(&nametest, "data/name");
   e_FreeMeshData(nametest);

   e_GetMeshData(&mesh,"data/new");
   e_PutMeshData(mesh,"data/newout");
   e_FreeMeshData(mesh);

   e_GetMeshData(&mesh,"data/test");
   e_PutMeshData(mesh,"data/out");

   e_GetGeomModel(mesh,"data/test");
   e_PutGeomModel(mesh,"data/out");

   e_GetMaterials(mesh,"data/test");
   e_PutMaterials(mesh,"data/out");

   e_GetDecompData(mesh,"data/test");
   e_PutDecompData(mesh,"data/out");

   e_GetMeshParams(mesh,"data/test");
   e_FreeNodalMeshParams(mesh);
   e_SetNodalMeshParams(mesh);
   e_FreeElemMeshParams(mesh);
   e_PutMeshParams(mesh,"data/nodes");
   e_FreeMeshParams(mesh);

   e_GetMeshParams(mesh,"data/test");
   e_PutMeshParams(mesh,"data/out");

   e_GetStresses(mesh,"data/test");

/*
{
  int i, k ,j, l, n;

  e_SetupStresses(mesh);
  n = 1;

  for (k = 0; k < mesh->NElemsTriang1; k++)
    for(i = 0; i < mesh->NStressPointsTriang1; i++)
      for(j = 0; j < 6; j++)
        mesh->Stresses.StressesTriang1[k][i][j] = n++;

  n *= 100;

  for (k = 0; k < mesh->NElemsTriang2; k++)
    for(l = 0; l < mesh->CompMatsTriang2[k]->NLayers; l++)
      for(i = 0; i < mesh->NStressPointsTriang2; i++)
        for(j = 0; j < 6; j++)
          mesh->Stresses.StressesTriang2[k][l][i][j] = n++;
}
*/

   e_PutStresses(mesh,"data/out");

   e_GetFEErrors(mesh,"data/test");
   e_PutFEErrors(mesh,"data/out");
 
   WriteGlobalData(mesh,"data/out.gbl");
   WriteDOF(mesh,"data/out.dof");

   e_free(mesh->Decomp.SubDoms);

   SubDoms = e_alloc_i_vect(mesh->TotalNElems);
   memcpy(SubDoms,Subdomains1,mesh->TotalNElems*sizeof(int));
   mesh->Decomp.NSubDoms = 2;
   mesh->Decomp.SubDoms = SubDoms;
   mesh->Decomp.SubDomsTriang1 = SubDoms;
   mesh->Decomp.SubDomsTriang2 = SubDoms + mesh->NElemsTriang1;

   e_CreateSubMesh(mesh,&SubMesh1,"Subdomains Test 1",1);
   e_PutMeshData(SubMesh1,"data/submesh1");
   e_PutGeomModel(SubMesh1,"data/submesh1");
   e_PutMaterials(SubMesh1,"data/submesh1");
   e_PutMeshParams(SubMesh1,"data/submesh1");

   e_PutStresses(SubMesh1,"data/submesh1");

   e_PutFEErrors(SubMesh1,"data/submesh1");
   WriteGlobalData(SubMesh1,"data/submesh1.gbl");
   WriteDOF(SubMesh1,"data/submesh1.dof");

   e_CreateSubMesh(mesh,&SubMesh2,"Subdomains Test 2",2);
   e_PutMeshData(SubMesh2,"data/submesh2");
   e_PutGeomModel(SubMesh2,"data/submesh2");
   e_PutMaterials(SubMesh2,"data/submesh2");
   e_PutMeshParams(SubMesh2,"data/submesh2");

   e_PutStresses(SubMesh2,"data/submesh2");

   e_PutFEErrors(SubMesh2,"data/submesh2");
   WriteGlobalData(SubMesh2,"data/submesh2.gbl");
   WriteDOF(SubMesh2,"data/submesh2.dof");

   SubDoms = e_alloc_i_vect(SubMesh1->TotalNElems);
   memcpy(SubDoms,Subdomains2,SubMesh1->TotalNElems*sizeof(int));
   SubMesh1->SubStructSet[E_SS_NUM_DECOMP] = TRUE;
   SubMesh1->Decomp.NSubDoms = 2;
   SubMesh1->Decomp.SubDoms = SubDoms;
   SubMesh1->Decomp.SubDomsTriang1 = SubDoms;
   SubMesh1->Decomp.SubDomsTriang2 = SubDoms + SubMesh1->NElemsTriang1;

   e_CreateSubMesh(SubMesh1,&SubMesh12,"Subdomains Test 12",2);
   e_PutMeshData(SubMesh12,"data/submesh12");
   e_PutGeomModel(SubMesh12,"data/submesh12");
   e_PutMaterials(SubMesh12,"data/submesh12");
   e_PutMeshParams(SubMesh12,"data/submesh12");

   e_PutStresses(SubMesh12,"data/submesh12");

   e_PutFEErrors(SubMesh12,"data/submesh12");
   WriteGlobalData(SubMesh12,"data/submesh12.gbl");
   WriteDOF(SubMesh12,"data/submesh12.dof");

   e_FreeMeshData(mesh);
   e_FreeMeshData(SubMesh1);
   e_FreeMeshData(SubMesh2);
   e_FreeMeshData(SubMesh12);

   e_GetMeshData(&mesh,"data/test");
   e_GetDecompData(mesh,"data/test");
   e_CreateSubMesh(mesh,&SubMesh3,"Remeshing data with no geometric model",1);
   e_PutMeshData(SubMesh3,"data/submesh3");
   e_FreeMeshData(mesh);
   e_FreeMeshData(SubMesh3);

   e_GetMeshData(&mesh,"data/tri2");
   SubDoms = e_alloc_i_vect(mesh->TotalNElems);
   memcpy(SubDoms,Subdomains3,mesh->TotalNElems*sizeof(int));
   mesh->SubStructSet[E_SS_NUM_DECOMP] = TRUE;
   mesh->Decomp.NSubDoms = 3;
   mesh->Decomp.SubDoms = SubDoms;
   mesh->Decomp.SubDomsTriang2 = SubDoms;

   e_PutDecompData(mesh,"data/tri2");

   e_GetNInterSubDomNodes(mesh,&NInterSubDomNodes,&WeightedNInterSubDomNodes);
   NCutInterfaces = e_GetNCutInterfaces(mesh);

   fprintf(g_fp,"\n         number of inter-subdomain nodes: ");
   fprintf(g_fp,"%d\n",NInterSubDomNodes);                         /* = 7 */
   fprintf(g_fp,"weighted number of inter-subdomain nodes: ");
   fprintf(g_fp,"%d\n",WeightedNInterSubDomNodes);                 /* = 8 */
   fprintf(g_fp,"                number of cut interfaces: ");
   fprintf(g_fp,"%d\n",NCutInterfaces);                            /* = 3 */

   e_FreeMeshData(mesh);

   e_GetMeshData(&mesh,"data/tri_link");
   e_GetDecompData(mesh,"data/tri_link");
   e_PutDecompData(mesh,"data/tl_out");
   e_GetMeshParams(mesh,"data/tri_link");
   e_SetNodalMeshParams(mesh);
   e_PutMeshParams(mesh,"data/tl_out");

   e_GetNInterSubDomNodes(mesh,&NInterSubDomNodes,&WeightedNInterSubDomNodes);

   fprintf(g_fp,"\n         number of inter-subdomain nodes: ");
   fprintf(g_fp,"%d\n",NInterSubDomNodes);
   fprintf(g_fp,"weighted number of inter-subdomain nodes: ");
   fprintf(g_fp,"%d\n",WeightedNInterSubDomNodes);

   e_GetInterSubDomNodes(mesh,&NInterSubDomNodes,&InterSubDomNodes,
                                         &NNodeSubDoms,&NodeSubDoms);


   fprintf(g_fp,"\n");

   for (k = 0; k < NInterSubDomNodes; k++)
   {
      fprintf(g_fp,"%d  ",InterSubDomNodes[k]);

      for (l = 0; l < NNodeSubDoms[k]; l++)
         fprintf(g_fp,
                 (l < NNodeSubDoms[k] - 1) ? "%d  " : "%d\n",NodeSubDoms[k][l]);
   }

   fprintf(g_fp,"\n");

   e_CreateSubMesh(mesh,&SubMesh1,"tri_link Subdomains Test 1",1);
   e_CreateSubMesh(mesh,&SubMesh2,"tri_link Subdomains Test 2",2);
   e_PutMeshData(SubMesh1,"data/tl_sub1");
   e_PutMeshData(SubMesh2,"data/tl_sub2");

   e_FreeMeshData(mesh);
   e_FreeMeshData(SubMesh1);
   e_FreeMeshData(SubMesh2);
   e_free(InterSubDomNodes);
   e_free(NNodeSubDoms);
   e_free_frag_i_matr(NInterSubDomNodes,NodeSubDoms);

   TestAllocIncrem();
   Test3DAlloc();
   Test4DAlloc();
   TestMathsLib();
/*
   e_beep();
   printf("\n");
*/

   fclose(g_fp);

   return 0;
}


/* ////////////////////////////////////////////////////////////////////////// */


int WriteGlobalData(MESH *mesh, char *OutputFile)
{
   int i;

   FILE *fp;


   if ((fp = fopen(OutputFile,"w")) == NULL)
   {
      e_FileError(OutputFile,"cannot open file");
      return 0;
   }

   fprintf(fp,"%s\n","Global Node Indices");

   for (i = 0; i < mesh->NNodes; i++)
   {
      fprintf(fp,"%5d   ",i + 1);
      fprintf(fp,"%5d\n",mesh->GNIs[i]);
   }

   fprintf(fp,"\n%s\n","Global Element Indices - Triangular1");

   for (i = 0; i < mesh->NElemsTriang1; i++)
   {
      fprintf(fp,"%5d   ",i + 1);
      fprintf(fp,"%5d\n",mesh->GEIsTriang1[i]);
   }

   fprintf(fp,"\n%s\n","Global Element Indices - Triangular2");

   for (i = 0; i < mesh->NElemsTriang2; i++)
   {
      fprintf(fp,"%5d   ",i + 1);
      fprintf(fp,"%5d\n",mesh->GEIsTriang2[i]);
   }

   fclose(fp);
   return 1;
}


/* ////////////////////////////////////////////////////////////////////////// */


int WriteDOF(MESH *mesh, char *OutputFile)
{
   int i;

   FILE *fp;


   if ((fp = fopen(OutputFile,"w")) == NULL)
   {
      e_FileError(OutputFile,"cannot open file");
      return 0;
   }

   fprintf(fp,"Total nodal degrees of freedom = %d\n\n",mesh->TotalNodalDOF);
   fprintf(fp,"Degrees of freedom\n");

   for (i = 0; i < mesh->NNodes; i++)
      fprintf(fp,"%d  %d\n",i + 1,mesh->NodalDOF[i]);

   fclose(fp);
   return 1;
}


/* ////////////////////////////////////////////////////////////////////////// */


void TestAllocIncrem()
{
   int i,j;

   double **A;
   double error;


   error = 0.0;
   A = NULL;

   for (i = 0; i < 5*N_MAX; i++)
   {
      A = e_incr_frag_d_matr(i,A,7);
      A[i] = e_alloc_d_vect(N_MAX);

      for (j = 0; j < N_MAX; j++)
         A[i][j] = 0.1*(i + 1)*(j + 1);
   }

   for (i = 0; i < 5*N_MAX; i++)
   {
      for (j = 0; j < N_MAX; j++)
         error += E_SQUARE(A[i][j] - 0.1*(i + 1)*(j + 1));
   }

   e_free_frag_d_matr(N_MAX,A);

   fprintf(g_fp,"2D incremented fragmented memory allocation error = %f\n", error);

   error = 0.0;
   A = NULL;

   for (i = 0; i < 5*N_MAX; i++)
   {
      A = e_incr_cont_d_matr(i,N_MAX,A,7);

      for (j = 0; j < N_MAX; j++)
         A[i][j] = 0.1*(i + 1)*(j + 1);
   }

   for (i = 0; i < 5*N_MAX; i++)
   {
      for (j = 0; j < N_MAX; j++)
         error += E_SQUARE(A[i][j] - 0.1*(i + 1)*(j + 1));
   }

   e_free_cont_d_matr(N_MAX,A);

   fprintf(g_fp,"2D incremented contiguous memory allocation error = %f\n\n", error);

}


/* ////////////////////////////////////////////////////////////////////////// */


void Test3DAlloc()
{
   int i,j,k,l,r;
   int ni,nj,nk;
   int error;
   int ***A;
   void ****pA;


   nk = 2;
   ni = 3;
   nj = 4;
   l = 0;

   A = e_alloc_frag_i_3D_matr(nk,ni,nj);
   pA = e_alloc_frag_vp_3D_matr(nk,ni,nj);

   for (k = 0; k < nk; k++)
   {
      for (i = 0; i < ni; i++)
      {
         for (j = 0; j < nj; j++)
         {
            A[k][i][j] = ++l;
            pA[k][i][j] = &A[k][i][j];
         }
      }
   }

   error = 0;

   for (k = 0; k < nk; k++)
   {
      for (i = 0; i < ni; i++)
      {
         for (j = 0; j < nj; j++)
            error += E_SQUARE(*(int *)pA[k][i][j] - A[k][i][j]);
      }
   }

   fprintf(g_fp,"3D fragmented memory allocation error = %d\n", error);

   e_free_frag_i_3D_matr(nk,ni,A);
   e_free_frag_vp_3D_matr(nk,ni,pA);

   l = 0;

   A = e_alloc_cont_i_3D_matr(nk,ni,nj);
   pA = e_alloc_cont_vp_3D_matr(nk,ni,nj);

   for (k = 0; k < nk; k++)
   {
      for (i = 0; i < ni; i++)
      {
         for (j = 0; j < nj; j++)
            A[k][i][j] = ++l;
      }
   }

   l = 0;
   error = 0;

   for (r = 0; r < ni*nj*nk; r++)
   {
      l++;
      error += E_SQUARE(A[0][0][r] - l);
   }

   fprintf(g_fp,"3D contiguous memory allocation error = %d\n", error);

   l = 0;

   for (k = 0; k < nk; k++)
   {
      for (i = 0; i < ni; i++)
      {
         for (j = 0; j < nj; j++)
            pA[k][i][j] = &A[k][i][j];
      }
   }

   l = 0;
   error = 0;

   for (r = 0; r < ni*nj*nk; r++)
   {
      l++;
      error += E_SQUARE(*(int *)pA[0][0][r] - l);
   }

   fprintf(g_fp,"3D contiguous memory allocation error = %d\n\n", error);

   e_free_cont_vp_3D_matr(nk,ni,pA);
   e_free_cont_i_3D_matr(nk,ni,A);
}


/* ////////////////////////////////////////////////////////////////////////// */


void Test4DAlloc()
{
   int i,j,k,l,m,r;
   int ni,nj,nk,nl;
   int error;
   int ****A;
   void *****pA;


   nk = 2;
   nl = 3;
   ni = 4;
   nj = 5;
   m = 0;

   A = e_alloc_frag_i_4D_matr(nk,nl,ni,nj);
   pA = e_alloc_frag_vp_4D_matr(nk,nl,ni,nj);

   for (k = 0; k < nk; k++)
   {
      for (l = 0; l < nl; l++)
      {
         for (i = 0; i < ni; i++)
         {
            for (j = 0; j < nj; j++)
            {
               A[k][l][i][j] = ++m;
               pA[k][l][i][j] = &A[k][l][i][j];
            }
         }
      }
   }

   error = 0;

   for (k = 0; k < nk; k++)
   {
      for (l = 0; l < nl; l++)
      {
         for (i = 0; i < ni; i++)
         {
            for (j = 0; j < nj; j++)
               error += E_SQUARE(*(int *)pA[k][l][i][j] - A[k][l][i][j]);
         }
      }
   }

   fprintf(g_fp,"4D fragmented memory allocation error = %d\n", error);

   e_free_frag_i_4D_matr(nk,nl,ni,A);
   e_free_frag_vp_4D_matr(nk,nl,ni,pA);

   m = 0;

   A = e_alloc_cont_i_4D_matr(nk,nl,ni,nj);
   pA = e_alloc_cont_vp_4D_matr(nk,nl,ni,nj);

   for (k = 0; k < nk; k++)
   {
      for (l = 0; l < nl; l++)
      {
         for (i = 0; i < ni; i++)
         {
            for (j = 0; j < nj; j++)
               A[k][l][i][j] = ++m;
         }
      }
   }

   m = 0;
   error = 0;

   for (r = 0; r < ni*nj*nk*nl; r++)
   {
      m++;
      error += E_SQUARE(A[0][0][0][r] - m);
   }

   fprintf(g_fp,"4D contiguous memory allocation error = %d\n", error);

   m = 0;

   for (k = 0; k < nk; k++)
   {
      for (l = 0; l < nl; l++)
      {
         for (i = 0; i < ni; i++)
         {
            for (j = 0; j < nj; j++)
               pA[k][l][i][j] = &A[k][l][i][j];
         }
      }
   }

   m = 0;
   error = 0;

   for (r = 0; r < ni*nj*nk*nl; r++)
   {
      m++;
      error += E_SQUARE(*(int *)pA[0][0][0][r] - m);
   }

   fprintf(g_fp,"4D contiguous memory allocation error = %d\n\n", error);

   e_free_cont_i_4D_matr(nk,nl,ni,A);
   e_free_cont_vp_4D_matr(nk,nl,ni,pA);
}


/* ////////////////////////////////////////////////////////////////////////// */


void TestMathsLib()
{
   int i,j,k;
   int n = N_MAX;
   int *pivot;

   unsigned long l;

   double **A,**B,**C;
   double *b;
   double **LU;
   double residual;
   double *x;
   double *y;
   double z;


   fprintf(g_fp,"\nE_ABS(1) = %d\n",E_ABS(1));
   fprintf(g_fp,"E_ABS(-1)  = %d\n",E_ABS(-1));
   fprintf(g_fp,"E_ABS(1.0)  = %f\n",E_ABS(1.0));
   fprintf(g_fp,"E_ABS(-1.0) = %f\n",E_ABS(-1.0));
   fprintf(g_fp,"E_MIN(1.0*1.0,2.0*2.0)  = %f\n",E_MIN(1.0*1.0,2.0*2.0));
   fprintf(g_fp,"E_MAX(-1.0*1.0,1.0*1.0) = %f\n",E_MAX(-1.0*1.0,1.0*1.0));
   fprintf(g_fp,"E_MIN(1,2)  = %d\n",E_MIN(1,2));
   fprintf(g_fp,"E_MAX(-1,1) = %d\n",E_MAX(-1,1));
   fprintf(g_fp,"E_MIN(1,2.0)  = %f\n",E_MIN(1,2.0));
   fprintf(g_fp,"E_MAX(-1.0,1) = %f\n",E_MAX(-1.0,1));
   fprintf(g_fp,"E_MIN3(1,3,2) = %d\n",E_MIN3(1,3,2));
   fprintf(g_fp,"E_MAX3(1,3,2) = %d\n",E_MAX3(1,3,2));
   fprintf(g_fp,"E_MIN4(4,1,3,2) = %d\n",E_MIN4(4,1,3,2));
   fprintf(g_fp,"E_MAX4(1,3,4,2) = %d\n",E_MAX4(1,3,4,2));

   A = e_alloc_frag_d_matr(n,n);
   B = e_alloc_frag_d_matr(n,n);
   C = e_alloc_frag_d_matr(n,n);
   LU = e_alloc_frag_d_matr(n,n);
   b = e_alloc_d_vect(n);
   x = e_alloc_d_vect(n);
   y = e_alloc_d_vect(n);
   pivot = e_alloc_i_vect(n);

   InitMaths(n,A,b);

   for (i = 0; i < n; i++)
   {
      for (j = 0; j < n; j++)
         LU[i][j] = A[i][j];

      x[i] = b[i];
   }

   if (e_LUFact(n,LU,pivot))
   {
      e_LUSolve(n,LU,x,pivot);
      residual = GetResidual(n,A,b,x);
      fprintf(g_fp,"\nresidual = %e\n",residual);               /* = 0.0 */
   }
   else
      e_exit(1);


   for (i = 0; i < n; i++)
   {
      for (j = 0; j < n; j++)
         LU[i][j] = A[i][j];

      x[i] = b[i];
   }

   if (e_LUFact(n,LU,NULL))
   {
      e_LUSolve(n,LU,x,NULL);
      residual = GetResidual(n,A,b,x);
      fprintf(g_fp,"residual = %e\n",residual);               /* = 0.0 */
   }
   else
      e_exit(1);

   for (i = 0; i < n; i++)
      x[i] = 1;

   e_VectScale(n,2.0,x,x);

   fprintf(g_fp,"\nscaled vector magnitude = %f\n",
            sqrt(e_VectDotProd(n,x,x)/(4.0*n)));        /* = 1.0 */


   A[0][0] =  1.0;  A[0][1] =  2.0;  A[0][2] =  3.0;  A[0][3] =  4.0;
   A[1][0] =  5.0;  A[1][1] =  6.0;  A[1][2] =  7.0;  A[1][3] =  8.0;
   A[2][0] =  9.0;  A[2][1] = 10.0;  A[2][2] = 11.0;  A[2][3] = 12.0;
   A[3][0] = 13.0;  A[3][1] = 14.0;  A[3][2] = 15.0;  A[3][3] = 16.0;

   x[0] = 1.0;  x[1] = 2.0;  x[2] = 3.0;  x[3] = 4.0;
   y[0] = 1.0;  y[1] = 2.0;  y[2] = 3.0;  y[3] = 4.0;


   e_MatrTranspNS(2,3,A,B);

   fprintf(g_fp,"\ne_MatrTranspNS\n");
   fprintf(g_fp,"%3.6f %3.6f\n",B[0][0]/A[0][0],B[0][1]/A[1][0]);
   fprintf(g_fp,"%3.6f %3.6f\n",B[1][0]/A[0][1],B[1][1]/A[1][1]);
   fprintf(g_fp,"%3.6f %3.6f\n",B[2][0]/A[0][2],B[2][1]/A[1][2]);

                                                        /* = 1, 1
                                                             1, 1
                                                             1, 1 */
   e_MatrVectMult(4,A,x,y);
   fprintf(g_fp,"\ne_MatrVectMult\n");
   fprintf(g_fp,"%f %f %f %f\n",
          y[0]/30.0,y[1]/70.0,y[2]/110.0,y[3]/150.0);   /* = 1, 1, 1, 1 */

   e_VectMatrMult(4,x,A,y);
   fprintf(g_fp,"\ne_VectMatrMult\n");
   fprintf(g_fp,"%f %f %f %f\n",
          y[0]/90.0,y[1]/100.0,y[2]/110.0,y[3]/120.0);  /* = 1, 1, 1, 1 */


   e_MatrTransp(4,A,B);
   e_MatrMult(4,A,B,C);

   fprintf(g_fp,"\ne_MatrMult\n");
   fprintf(g_fp,"%3.6f %3.6f %3.6f %3.6f\n",
          C[0][0]/30.0,C[0][1]/70.0,C[0][2]/110.0,C[0][3]/150.0);
   fprintf(g_fp,"%3.6f %3.6f %3.6f %3.6f\n",
          C[1][0]/70.0,C[1][1]/174.0,C[1][2]/278.0,C[1][3]/382.0);
   fprintf(g_fp,"%3.6f %3.6f %3.6f %3.6f\n",
          C[2][0]/110.0,C[2][1]/278.0,C[2][2]/446.0,C[2][3]/614.0);
   fprintf(g_fp,"%3.6f %3.6f %3.6f %3.6f\n",
          C[3][0]/150.0,C[3][1]/382.0,C[3][2]/614.0,C[3][3]/846.0);
    
                                                        /* = 1, 1, 1, 1
                                                             1, 1, 1, 1
                                                             1, 1, 1, 1
                                                             1, 1, 1, 1 */

   e_free_frag_d_matr(n,C);
   C = e_alloc_frag_d_matr(n,n);

   e_MatrMultNS(2,3,4,A,B,C);

   fprintf(g_fp,"\ne_MatrMultNS\n");
   fprintf(g_fp,"%3.6f %3.6f %3.6f %3.6f\n",
          C[0][0]/14.0,C[0][1]/38.0,C[0][2]/62.0,C[0][3]/86.0);
   fprintf(g_fp,"%3.6f %3.6f %3.6f %3.6f\n",
          C[1][0]/38.0,C[1][1]/110.0,C[1][2]/182.0,C[1][3]/254.0);

                                                        /* = 1, 1, 1, 1
                                                             1, 1, 1, 1 */
   x[0] = 1.0;  x[1] = 2.0;  x[2] = 3.0;  x[3] = 4.0;

   e_MatrVectMultNS(4,2,A,x,y);

   fprintf(g_fp,"\ne_MatrVectMultNS\n");
   fprintf(g_fp,"%3.6f %3.6f %3.6f %3.6f\n",
           y[0]/5.0,y[1]/17.0,y[2]/29.0,y[3]/41.0);     /* = 1, 1, 1, 1 */

   e_VectMatrMultNS(4,2,x,A,y);

   fprintf(g_fp,"\ne_VectMatrMultNS\n");
   fprintf(g_fp,"%3.6f %3.6f\n",y[0]/90.0,y[1]/100.0);  /* = 1, 1 */

   fprintf(g_fp,"\ne_Factorial, e_FactorialDP\n");
   fprintf(g_fp,"%d  %ld  %e\n",0,e_Factorial(0),e_FactorialDP(0));

   l = 1UL;
   z = 1.0;

   for (k = 1; k <= 12; k++)
   {
      l *= k ;
      z *= k;
      fprintf(g_fp,"%d  %ld  %e\n",
             k,e_Factorial(k)/l,e_FactorialDP(k)/z);    /* 13 x (1  1.0) */
   }

   fprintf(g_fp,"\n");

   e_free_frag_d_matr(n,A);
   e_free_frag_d_matr(n,B);
   e_free_frag_d_matr(n,C);
   e_free_frag_d_matr(n,LU);
   e_free(b);
   e_free(x);
   e_free(y);
   e_free(pivot);
}


void InitMaths(int n, double **A, double *b)
{
   int i,j,k;

/* double **A0; */


/* SeedRandomNumberGenerator(); */

   for (i = 0; i < n; i++)
   {
      for (j = 0; j < n; j++)
         A[i][j] = RandomDouble(n);

      b[i] = RandomDouble(n);
   }

/*
   A0 = e_alloc_frag_d_matr(n,n);

   for (i = 0; i < n; i++)
   {
      for (j = 0; j < n; j++)
      {
         A0[i][j] = 0.0;

         for (k = 0; k < n; k++)
            A0[i][j] += A[k][i]*A[k][j];
      }
   }

   for (i = 0; i < n; i++)
   {
      for (j = 0; j < n; j++)
         A[i][j] = A0[i][j];
   }

   e_free_frag_d_matr(n,A0);
*/
}


void SeedRandomNumberGenerator()
{  
   int SecondsSinceMidNight;
   time_t timer;
   struct tm *LocalTime;

   
   time(&timer);
   LocalTime = localtime(&timer);
   SecondsSinceMidNight = (int)((long int)(3600)*LocalTime->tm_hour
                                             + 60*LocalTime->tm_min
                                                + LocalTime->tm_sec);
   srand(SecondsSinceMidNight);
}


double RandomNumber()
{
   return (rand() % RAND_MAX)/((double)RAND_MAX);       /* 0.0 <= x < 1.0 */
}


double RandomDouble(double NumberMax)
{
   return (2.0*RandomNumber() - 1.0)*NumberMax;
}


double GetResidual(int n, double **A, double *b, double *x)
{
   int i;

   double delta;
   double *z;



   z = e_alloc_d_vect(n);

   e_MatrVectMult(n,A,x,z);

   delta = 0.0;

   for (i = 0; i < n; i++)
      delta += E_SQUARE(z[i] - b[i]);

   e_free(z);

   return sqrt(delta/e_VectDotProd(n,b,b));
}
