#include <stdlib.h>   
#include <stdio.h>
#include <math.h>   

#define __E_MPI__

#include <mpi.h>

#include <e_lib.h>


int main(int argc, char *argv[])
{
  MESH *mesh;
  MESH *SubMesh = NULL;
  MESH *Rev_mesh = NULL;
  int i, GV_procID, no;
  char name[E_LINE_MAX];

  MPI_Init(&argc,&argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&GV_procID);
  GV_procID += 1;
  MPI_Comm_size(MPI_COMM_WORLD, &no);
  if(no > 2)
    MPI_Finalize();

  if(GV_procID == 1)
  {
    e_GetMeshData(&mesh,"../data/test");
    e_GetMaterials(mesh,"../data/test");
    e_GetDecompData(mesh,"../data/test");
    e_GetMeshParams(mesh,"../data/test");
    e_GetStresses(mesh,"../data/test");
    e_GetFEErrors(mesh,"../data/test");

    e_MPI_Send_MeshData(mesh, 1);
    e_MPI_Send_DecompData(mesh, 1);
    e_MPI_Send_MeshParams(mesh, 1);
    e_MPI_Send_FEErrorData(mesh, 1);
    e_MPI_Send_Stresses(mesh, 1);

  }
  else
  {
    e_MPI_Recv_MeshData(&Rev_mesh, 0);
    e_MPI_Recv_DecompData(Rev_mesh, 0);
    e_MPI_Recv_MeshParams(Rev_mesh, 0);
    e_MPI_Recv_FEErrorData(Rev_mesh, 0);
    e_MPI_Recv_Stresses(Rev_mesh, 0);

    Rev_mesh->KeywordSet[E_KW_NUM_REMESH_DATA] = FALSE;

    e_PutMeshData(Rev_mesh,"slave");
    e_PutMaterials(Rev_mesh,"slave");
    e_PutDecompData(Rev_mesh,"slave");
    e_PutMeshParams(Rev_mesh,"slave");
    e_PutStresses(Rev_mesh,"slave");
    e_PutFEErrors(Rev_mesh,"slave");
  }
  MPI_Finalize();
}
