/********************************************************************
 eg_math.c  --
     Originally Eg-Lib was using some math routines from E-Lib.
     The ones below are copied form E-Lib.

 Jelle Muylle <jelle@sect.mce.hw.ac.uk>
 Roman Putanowicz <romek@sect.mce.hw.ac.uk>
 SECT Research Group, Heriot-Watt University, Edinburgh    
 ********************************************************************/

/* $Id: eg_math.c,v 1.1 2002/10/16 19:05:04 peteri Exp $ */

double eg_VectDotProd(unsigned int n, double *x, double *y)
{
   register unsigned int i;
   register double DotProduct;


   DotProduct = 0.0;

   for (i = 0; i < n; i++)
      DotProduct += x[i]*y[i];

   return DotProduct;
}

void eg_VectCrossVect(double *a, double *b, double *c)
{
   c[0] = a[1]*b[2] - a[2]*b[1];
   c[1] = a[2]*b[0] - a[0]*b[2];
   c[2] = a[0]*b[1] - a[1]*b[0];
}

/* Modifications:
 * $Log: eg_math.c,v $
 * Revision 1.1  2002/10/16 19:05:04  peteri
 * - dependence on e_lib is removed
 *
 * Revision 1.1  2002/10/16 09:28:11  putanowr
 * Dependency on E-Lib removed. Missing functions added in eg_error.c and eg_math.c
 *
 */

