#include <stdio.h>
#include "eg_lib.h"

int main()
{
    double lb1[3],le1[3],lb2[3],le2[3];
    double mu1,mu2;
    
    double t1[3],t2[3],t3[3],t4[3],lb[3],le[3];
    int gennum=999;
    double is[3];
    double mu=9.99;
    double tricrds[3];
    double circumcenter[3];
    
    eg_Init();
    /* testing of eg_LineLineIntersect3D 
    lb1[0]=0.0;		lb1[1]=0.0;		lb1[2]=-1.0;
    le1[0]=0.0;		le1[1]=0.0;		le1[2]=1.0;
    lb2[0]=1.0;		lb2[1]=0.0;		lb2[2]=0.0;
    le2[0]=0.0;		le2[1]=1.0;		le2[2]=0.0;
   
    if (eg_LineLineIntersect3D(lb1,le1,lb2,le2,&mu1,&mu2)!=EG_SKEWED)
        eg_GeneralError("eg_LineLineIntersect3D doesn't work (1)");
    printf("mu1=%1.2lf mu2=%1.2lf\n",mu1,mu2);
    
    lb2[0]=1.0;		lb2[1]=1.0;		lb2[2]=-1.0;
    le2[0]=1.0;		le2[1]=1.0;		le2[2]=1.0;
    
    if (eg_LineLineIntersect3D(lb1,le1,lb2,le2,&mu1,&mu2)!=EG_PARALLEL)
        eg_GeneralError("eg_LineLineIntersect3D doesn't work (2)");
    printf("parallel\n");
    
    lb2[0]=1.0;		lb2[1]=1.0;		lb2[2]=-1.0;
    le2[0]=-1.0;	le2[1]=-1.0;	le2[2]=1.0;
        
    if (eg_LineLineIntersect3D(lb1,le1,lb2,le2,&mu1,&mu2)!=EG_INTERSECT)
        eg_GeneralError("eg_LineLineIntersect3D doesn't work (3)");
    printf("mu1=%1.2lf mu2=%1.2lf\n",mu1,mu2);
    
    le2[0]=1.0;		le2[1]=1.0;		le2[2]=-1.0;
    
    if (eg_LineLineIntersect3D(lb1,le1,lb2,le2,&mu1,&mu2)!=EG_INVALID)
        eg_GeneralError("eg_LineLineIntersect3D doesn't work (4)");
    printf("invalid\n"); */
    
    /* testing of eg_TriangLineIntersect3D */
    t1[0]=0.0;	t1[1]=0.0;	t1[2]=0.0;
    t2[0]=1.0;	t2[1]=0.0;	t2[2]=0.0;
    t3[0]=0.0;	t3[1]=1.0;	t3[2]=0.0;
    lb[0]=0.2;	lb[1]=0.0;	lb[2]=1.0;
    le[0]=0.0;	le[1]=0.0;	le[2]=2.0;
    
    printf("result=%d\n",
        eg_TriangLineIntersect3D (t1,t2,t3,lb,le,is,&gennum,tricrds,&mu));
    printf("gennum=%d\n",gennum);
    printf("tricrds=(%lf,%lf,%lf)\n",tricrds[0],tricrds[1],tricrds[2]);
    printf("triintp=(%lf,%lf,%lf)\n",tricrds[0]*t1[0]+tricrds[1]*t2[0]+tricrds[2]*t3[0],
        							 tricrds[0]*t1[1]+tricrds[1]*t2[1]+tricrds[2]*t3[1],
                                     tricrds[0]*t1[2]+tricrds[1]*t2[2]+tricrds[2]*t3[2]);
    printf("is=(%lf,%lf,%lf)\n",is[0],is[1],is[2]);
    printf("mu=%lf\n",mu);
    
    /* testing circumcenter functions */
    t1[0]=0.21;	t1[1]=0.2;	t1[2]=5.0;
    t2[0]=1.0;	t2[1]=0.34;	t2[2]=0.11;
    t3[0]=-1.0;	t3[1]=-0.11;	t3[2]=-0.5;
    t4[0]=-0.7;  t4[1]=2.0;      t4[2]=1.0;

    eg_TetCircumcenter (t1, t2, t3, t4, circumcenter, NULL, NULL, NULL);
    circumcenter[0]+=t1[0];
    circumcenter[1]+=t1[1];
    circumcenter[2]+=t1[2];
    printf ("Tetrahedron circumcenter\n");
    printf ("radius = %f\n", eg_PointDist3D (circumcenter, t1));
    printf ("radius = %f\n", eg_PointDist3D (circumcenter, t2));
    printf ("radius = %f\n", eg_PointDist3D (circumcenter, t3));
    printf ("radius = %f\n", eg_PointDist3D (circumcenter, t4));
    printf ("3D triangle circumcenter\n"); 
    eg_TriCircumcenter3D (t2, t3, t4, circumcenter, NULL, NULL);
    circumcenter[0]+=t2[0];
    circumcenter[1]+=t2[1];
    circumcenter[2]+=t2[2];
    printf ("radius = %f\n", eg_PointDist3D (circumcenter, t2));
    printf ("radius = %f\n", eg_PointDist3D (circumcenter, t3));
    printf ("radius = %f\n", eg_PointDist3D (circumcenter, t4));

    exit(0);
}
