typedef double j_3Dvector[3];
typedef double j_3Drot_matrix[3][3];
typedef int BOOL;

#include "eps.h"

#ifdef  J_GRAPHICS
#define X_MAIN
#else
#define X_MAIN  extern
#endif

X_MAIN j_3Drot_matrix G_cpm, G_cpim;
X_MAIN double G_dTC;
X_MAIN double G_pixel_ratio;
X_MAIN double G_Xscrorigin, G_Yscrorigin;
X_MAIN j_3Dvector G_Target;
X_MAIN j_3Dvector G_Center;
X_MAIN double G_Twist;
X_MAIN double G_Azim, G_Elev;
X_MAIN double G_scale, G_initscale;
X_MAIN j_3Dvector OO, OX, OY, OZ;
X_MAIN j_3Dvector SO, SX, SY, SZ;
X_MAIN double w_dGlobCoordL,
  w_dGlobCoordR, w_dGlobCoordT, w_dGlobCoordB, w_dGlobCoordU, w_dGlobCoordD;
X_MAIN double w_maxsize;
X_MAIN double w_Element_Size_percent;
X_MAIN double w_Link_Size_percent;
X_MAIN BOOL wDisplElemNo, wDisplPointNo, wTileElems, wTileLinks, wDisplScale,
  wHN;
X_MAIN BOOL wHidden, wClipPlane, wNoBorders, wRemove, wAdvHidden, wZC,
  wAltCols;
X_MAIN int wPlotSelect, wSelection;
X_MAIN double wZeta;
X_MAIN char mdfname[E_LINE_MAX];
X_MAIN int *order;

X_MAIN int wEPS_plotplan;
X_MAIN double wEPS_sizex;
X_MAIN double wEPS_sizey;
X_MAIN double wEPS_margin;
X_MAIN int wEPS_bcolor;
X_MAIN int wEPS_color;
X_MAIN int wEPS_subdom_style;
X_MAIN double wEPS_subdom_b_width;
X_MAIN double wEPS_subdom_t_size;

X_MAIN Widget wg_Plain, wg_Subdom, wg_TL, wg_TE, wg_NB, wg_HN;

/* other constants */
#define INIT_ZETA     0.00
#define ELEMENT_SIZE   1.00
#define INIT_AZIMUTH    18.00
#define INIT_ELEVATION   27.00
/*  percent / num. of pixel (in mouse movement)  */
#define j3D_AZIMUTH_INCREMENT       5.00 / 10.00
#define j3D_ELEVATION_INCREMENT     5.00 / 10.00
#define j3D_DISTANCE_MULTIPLIER     5.00 / 20.00
#define j3D_SCALEFACT_MULTIPLIER    5.00 / 20.00
#define j3D_DISPLMAG_MULTIPLIER    15.00 / 20.00
#define j3D_STRESSCOL_PC_INCREMENT  1.00 /  5.00
#define j3D_ZETA_INCREMENT          0.02 / 10.00

#define PS_PLAINMESH	0
#define PS_SUBDOM   	1
#define PS_STRESS   	2
#define PS_MESHPARAM	3
#define PS_ERROR    	4

#define DS_AZIM_ELEV	0
#define DS_TCDIST_SCALE 1
#define DS_SCRORIGIN	2
#define DS_TARGETCOORDS 3
#define DS_TARGETELEV	4

#define MAXCOLS 16
#define MAXALTCOLS 6

/* function declarations */
void j_3Dworld_to_screen(j_3Dvector screen, j_3Dvector world);
void j_3Drecalc_rot_matrix(void);
void j_load_font(Display * dspl, XFontStruct ** font_info);
void j_init_colors(Display * display, Colormap cmp);
void j_init_perspective(void);
int j_do_projection(POLYGON * polygons, int NPoly, double *zmin,
                    double *zmax);
void j_sort_polygons(int *order, POLYGON * polygons, int Npoly);
int j_compare_polygons(const void *i, const void *j);
double j_getavsl(j_3Dvector node1, j_3Dvector node2);
void j_paint_polygons(Display * dspl, Window wnd, GC gcx, Colormap cmp,
                      POLYGON * polygons, int Npoly);
void graphics_info(void);
void load_graphics_info(void);
void save_graphics_info(void);
void EPS_export(POLYGON * polygons, int Npoly);

/* Macros to accelerate */
#define XDIR 0
#define YDIR 1
#define ZDIR 2
#define M_Add_vec(result,a,b)\
      ((result)[XDIR] = (a)[XDIR] + (b)[XDIR],\
       (result)[YDIR] = (a)[YDIR] + (b)[YDIR],\
       (result)[ZDIR] = (a)[ZDIR] + (b)[ZDIR])
#define M_Subtr_vec(result,a,b)\
      ((result)[XDIR] = (a)[XDIR] - (b)[XDIR],\
       (result)[YDIR] = (a)[YDIR] - (b)[YDIR],\
       (result)[ZDIR] = (a)[ZDIR] - (b)[ZDIR])
#define M_Dot_product(a,b)\
       ((a)[XDIR] * (b)[XDIR] + (a)[YDIR] * (b)[YDIR] + (a)[ZDIR] * (b)[ZDIR])
#define M_Length(v) sqrt((double) M_Dot_product(v,v))
#define M_Vec_dot_matrix(c,a,b)\
      (c)[XDIR] = (a)[XDIR] * *(b)   + (a)[YDIR] * *(b+3) + (a)[ZDIR] * *(b+6),\
      (c)[YDIR] = (a)[XDIR] * *(b+1) + (a)[YDIR] * *(b+4) + (a)[ZDIR] * *(b+7),\
      (c)[ZDIR] = (a)[XDIR] * *(b+2) + (a)[YDIR] * *(b+5) + (a)[ZDIR] * *(b+8)
/* #define M_PI 3.1415926 */
