/* FILE chkmdf.h
 * validity checking for e_lib files */

#include "e_lib.h"
#include "eg_lib.h"

#define VERSION	"1.0"
#define E_SMALL 1e-6

typedef struct
{
    double x;
    double y;
    double z;
    int n;
}   NDC;
typedef struct
{
    int a;
    int b;
    int c;
    int n;
}   TRE;
typedef struct
{
    int a;
    int b;
    int n;
}   LNE;

void statistics(MESH *mesh);
static int nodecompare(const void *e1, const void *e2);
int nc_equal(NDC e1, NDC e2);
int duplicate_node_chk(MESH *mesh);
int duplicate_elem_chk(MESH *mesh);
int dupl_elems(int **elems, int nelems, int nnodes, char *type);
static int nthlowest(int *el, int nnodes, int prev_low, int max);
static int compne(const void *e1, const void *e2, int nnodes);
static int comp2ne(const void *e1, const void *e2);
static int comp3ne(const void *e1, const void *e2);
static int comp4ne(const void *e1, const void *e2);
static int comp8ne(const void *e1, const void *e2);
double dCCW(double *A, double *B, double *C);
int elem_valid_chk(MESH *mesh);
int chk_invalid_elem_def(int **elems, int nelems, int nnodes, char *type);
int ccw_check(double **coords, int **elems, int nelems, char *type);
