/* ////////////////////////////////////////////////////////////////////////// */
/*                                                                            */
/*                            Finite Element Analysis()                       */
/*                                                                            */
/* ////////////////////////////////////////////////////////////////////////// */

#define Simple_Error		    TRUE
#define Displacement_scale	    10.0
#define ADJ_MESH_POINTS_MEM_INCREM  10

void J_Calculate_Stresses(MESH *mesh, double *Force);
void J_Calculate_Errors_and_MeshParams(MESH *mesh, double perm_error, int mprtype);

void B_clockwise_check(MESH *mesh,int ElemType);

int B_Q_right(double x1,double y1,double x2,double y2,double x3,
                     double y3);


void B_Assemble_matrix_TRIANG1(MESH *mesh,double *KV, int *ind,double *Force);

void B_numint(double *s,double *wt);

void B_fmtri3(double **der,double *fun,double *samp);

void B_Assemble_matrix_QUAD1(MESH *mesh,double *KV, int *ind,double *Force);

void B_formln(double **Der, double *Fun, double **Guass_samp, int i,int j );						     
void B_gauss_Quad1(double **Guass_samp);

void B_Assemble_matrix_TETRAH1(MESH *mesh,double *KV, int *ind,double *Force);

void B_numint_TETRAH1(double **s,double *wt);

void B_formD_TETRAH1(double **Dee, double e, double v);

void B_treex3_TETRAH1(double **Jac,int ijac, double **Jack1,double *Det);

void B_formb3_TETRAH1(double **Bee, double **Deriv,int nod);


void B_form_dia(MESH *mesh,int *ind, int N_displacement_Per_node);

void B_form_loads(MESH *mesh, double *force, int Ndisps);

void B_GetElemMaterial(MAT **material,int elem_no, double *e, 
                              double *v,  double *t);
void B_Fmdsig(double **D,double e, double v);

void fmdeps(double **dee, double e, double v);

void B_Elem_cord(MESH *mesh, int NElem, double **Coord);

void B_twoby2(double **jac, double **Jac1, double *Det);

void B_form_Bee(double **Bee, double **Deriv,int Nod);

void B_Fsparv(MESH *mesh, int NElem, double *Kv, double **Km, int *ind);

void B_BoundaryConditions(MESH *mesh, double *kv,double *Force, int *ind, int Ndisp);

void B_Matmul(double **A, double **B, double **C, int Nrow,int Nmultiple, int Ncolumn);

void B_Matran(double **A, double **B, int Nrow, int Ncolumn);

void B_Msmult(double **A, int Nrow, int Ncolumn, double scaler);

void B_Matadd(double **A, double **B, int Nrow, int Ncolumn);

void B_null(double **Km, int Nrow, int Ncolumn);

void B_deformationMesh(MESH *mesh,double *Force,double scale, 
                         int N_displacement_Per_node);


int ConGradSolve(int n, double *A, int *index, double *b, double *x, double tolerance);

int AllocateMemory(int n, double **p, double **r, double **w);

double DotProduct(int n, double *a, double *b);

void AddVectors(int n, double alpha, double *a, double *b, double *c);
void PreMultiply(int n, double *A, int *ind, double *b, double *c);
double Matrix_retrive(int n, double *A, int *index,  int row, int column);

void debu_B_Fsparv(MESH *mesh, int NElem, float Kv[12][12], double **Km, int *ind, int NNodesPElem);

/**********************************************************************/

void B_Calculate_Stress_Error(MESH *mesh, double *Force, char *string, float error);

void  B_get_Eleme_Stress_AtCenter(MESH *mesh, double *Force,
                                 double *Ele_Non_Average_Strain, 
                                 double  *Ele_Non_Average_Stress,
				 int NstressPNode,int NDisplPNode);


void B_form_strain(int **nodes, int Temp_E_NNPE_ELEMs, double **Bee, 
      double *Force, double *temp_node_strain, int NElem, int NstressPNode,
      int NDisplPNode);

void B_form_stress(double **Dee, double *temp_node_strain, 
double *temp_node_stress, int NstressPNodee);


void B_get_nodal_stress_Quad1(MESH *mesh, double *Force,
         double  *Ele_Non_Average_Strain,  double *Ele_Non_Average_Stress, 
         double  *Nodal_Average_Strain,    double *Nodal_Average_Stress);


void B_form_coner(double **der, double *fun,int i,int j);

void B_Calculate_Norm_e_Quad1(MESH *mesh, double *Force, double *Average_Nodal_Stress,
double *Ele_Error_Stress_Norm, double *Ele_displacement_Enegy_Norm);

void B_energy_norm_stress_eDe(double **Dee, double Error_stress_x, 
                    double Error_stress_y, double Error_stress_xy, double *eDe);

void B_Matinversion(double **A, int Size_matrix, double **B);

void B_Error_ElemSize_NodalSize(MESH *mesh, 
				double *Ele_Error_Stress_Norm,
 				double *Ele_displacement_Enegy_Norm, 
			 	double *Grobal_Error_Stress_Norm, 
 				double *Grobal_displacement_Enegy_Norm, 
 				double Permiss_Error, 
 				double *Elem_Error, 
 				double *Nodal_Size_Param);

void B_Cal_Quad_Elem_Size_Quad1(MESH *mesh, double *Elem_Size);

int SetAdjPointsElems(MESH *mesh, int **NAdjMeshPointsElems,
                                         int ***AdjMeshPointsElems);

int UpdateMeshPointsElems(int k1, int k2, int *NAdjMeshPoints,
                                             int **AdjMeshPoints);

void FreeAdjMeshPointsElems(MESH *mesh, int *NAdjMeshPoints,
                                           int **AdjMeshPoints);



void B_get_nodal_stress_Triang1(MESH *mesh,  
                  double  *Ele_Non_Average_Strain,   
                  double *Ele_Non_Average_Stress,  
                  double  *Nodal_Average_Strain,    
                  double *Nodal_Average_Stress);

void B_Calculate_Norm_e_Triang1(MESH *mesh, 
                                       double  *Ele_Non_Average_Strain, 
			               double  *Ele_Non_Average_Stress, 
         			       double  *Nodal_Average_Strain,    
			               double  *Nodal_Average_Stress,
                                       double  *Ele_Error_Stress_Norm, 
                                       double  *Ele_displacement_Enegy_Norm);
void B_elem_area_Triang1(MESH *mesh,int NElem,double *area);
void B_Calculate_Norm_e_QUAD1_average(MESH *mesh, 
                                       double  *Ele_Non_Average_Strain, 
			               double  *Ele_Non_Average_Stress, 
         			       double  *Nodal_Average_Strain,    
			               double  *Nodal_Average_Stress,
                                       double  *Ele_Error_Stress_Norm, 
                                       double  *Ele_displacement_Enegy_Norm);
void B_Cal_Quad_Elem_Size_Triang1(MESH *mesh, double *Elem_Size);
void B_bandv(int Order, double *O_kv, double *O_force, int *O_ind);
