#include "e_lib.h"

#define OFFSET 10000

int main(int argc, char **argv)
{
  MESH *m;
  int n=0;
  int i,j;
  int **nodes;
  int nnpe;
  
  if (argc!=3)
  {
    fprintf(stderr, "\nConverts and MDF file to an LS-DYNA keyword file\n");
    fprintf(stderr, "describing only the geomtery of the mesh.\n");
    fprintf(stderr, "\nUsage: mdf2k file(.mdf) n > out.k\n");
    fprintf(stderr, "   n : the numbering of the nodes and "
            "elements starts at n*10000+1\n\n");
    exit(1);
  }
  
  e_GetMeshData(&m,argv[1]);
  if(sscanf(argv[2],"%d",&n) != 1)
      e_GeneralError("Cannot read integer number");
  
  printf("$---------------------------------------------------------\n");
  printf("*NODE\n");
  for (i=0;i<m->NNodes;i++)
      printf("%d,%1.5lf,%1.5lf,%1.5lf\n",
             n*OFFSET+i+1,
             m->MeshPointCoords[i][0],
             m->MeshPointCoords[i][1],
             m->MeshPointCoords[i][2]);
  printf("$---------------------------------------------------------\n");
  printf("*ELEMENT_XXXX\n");
  nodes=e_GetNodes(m);
  nnpe=e_GetNNodesPerElement(m);
  for (i=0;i<m->TotalNElems;i++)
  {
    printf("%d,%d",n*OFFSET+i+1,n);
    for (j=0;j<nnpe;j++)
        printf(",%d",n*OFFSET+nodes[i][j]);
    printf("\n");
  }
  printf("$---------------------------------------------------------\n");
  printf("*END\n");
  
  e_FreeMeshData(m);

  return 0;
}
