/* FILE mpr2emp.c
 *
 * to convert nodal mesh params in element mesh params
 *
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "e_lib.h"

int main(int argc, char *argv[])
{
  /* variable declarations */
  MESH    *mesh;
  int	    t;
  
  if(argc == 3)
  {
    mesh=NULL;
    if (!e_GetMeshData(&mesh, argv[1]))
        e_GeneralError("Mesh file contains faults; execution halted!");
    e_GetMeshParams(mesh, argv[1]);

    if (!mesh->MeshParam.NodalMeshParamsSet)
    {
      e_FreeMeshParams(mesh);
      e_FreeMeshData(mesh);
      e_GeneralError("This program converts FROM nodal mpr TO element mpr");
    }
    mesh->MeshParam.ElemMeshParamsTriang1=e_alloc_d_vect(mesh->NElemsTriang1);
    for (t=0;t<mesh->NElemsTriang1;t++)
        mesh->MeshParam.ElemMeshParamsTriang1[t]=(
            mesh->MeshParam.NodalMeshParams[mesh->NodesTriang1[t][0]-1]+
            mesh->MeshParam.NodalMeshParams[mesh->NodesTriang1[t][1]-1]+
            mesh->MeshParam.NodalMeshParams[mesh->NodesTriang1[t][2]-1] )/3.0;
    e_free(mesh->MeshParam.NodalMeshParams);
    mesh->MeshParam.ElemMeshParamsSet=TRUE;
    mesh->MeshParam.NodalMeshParamsSet=FALSE;

    e_PutMeshParams(mesh, argv[2]);

    e_FreeMeshParams(mesh);
    e_FreeMeshData(mesh);
  }
  else
  {
    /* show the usage of the program */
    printf("\nConvert nodal mesh parameters to element mesh prameters\n");
    printf("by averaging all nodal mesh parameters of an element.\n");
    printf("\nUsage: mpr2emp input output\n");
    printf("   input  : name of input mesh file and mesh parameter file\n");
    printf("   output : name of output mesh parameter file\n");
    printf("All files should be specified without extension!\n\n");
    e_exit(1);
  }
  
  return 0;
}

/* end of file */
