#include <stdio.h>
#include <e_lib.h>
#include "graph.h"



void SetDualAdjacency(MESH *mesh, int *degree, int **adjacency,
                      int *no_node_elem, int **node_elem)
{
  int i;

  for(i = 0; i < mesh->TotalNElems; i++)
  {
    adjacency[i] = e_alloc_i_vect(GRAPH_ALLOC);
  }

  SetTriangAdjacencyMatrix(mesh, degree, adjacency,
                           mesh->NElemsTriang3, 
                           mesh->NodesTriang3, 
                           mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG3],
                           no_node_elem, node_elem);

  SetTriangAdjacencyMatrix(mesh, degree, adjacency,
                           mesh->NElemsTriang4, 
                           mesh->NodesTriang4, 
                           mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG4],
                           no_node_elem, node_elem);


  SetTriangAdjacencyMatrix(mesh, degree, adjacency,
                           mesh->NElemsTriang5, 
                           mesh->NodesTriang5, 
                           mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG5],
                           no_node_elem, node_elem);

  SetLinkAdjacencyMatrix(mesh, degree, adjacency,
                         mesh->NElemsLink1, 
                         mesh->NodesLink1, 
                         mesh->FirstNetIndex[E_ELEM_TYPE_LINK1],
                         no_node_elem, node_elem);

  SetLinkAdjacencyMatrix(mesh, degree, adjacency,
                         mesh->NElemsLink2, 
                         mesh->NodesLink2, 
                         mesh->FirstNetIndex[E_ELEM_TYPE_LINK2],
                         no_node_elem, node_elem);

  SetLinkAdjacencyMatrix(mesh, degree, adjacency,
                         mesh->NElemsLink3, 
                         mesh->NodesLink3, 
                         mesh->FirstNetIndex[E_ELEM_TYPE_LINK3],
                         no_node_elem, node_elem);

  SetLinkAdjacencyMatrix(mesh, degree, adjacency,
                         mesh->NElemsLink4,
                         mesh->NodesLink4, 
                         mesh->FirstNetIndex[E_ELEM_TYPE_LINK4],
                         no_node_elem, node_elem);

  SetLinkAdjacencyMatrix(mesh, degree, adjacency,
                         mesh->NElemsLink5,
                         mesh->NodesLink5, 
                         mesh->FirstNetIndex[E_ELEM_TYPE_LINK5],
                         no_node_elem, node_elem);

}
