/* ////////////////////////////////////////////////////////////////////////// */
/*                                                                            */
/*                                  farhat()                                  */
/*                                Header File                                 */
/*                                                                            */
/* ////////////////////////////////////////////////////////////////////////// */


static int GetMinWeightMeshPoint(int NStartMinNode, int NFrontElements, 
                                 int *FrontElements);
static int Initialise(MESH *mesh, int NSubdomains, int LinkGrab);

static int AdvanceFront(int SubdomainIndex, int NElementsPerSubdomain,
                                   int *NElements, int *NFrontElements,
                                                    int **FrontElements);
static int CreateInitialFront(int SubdomainIndex, int NElementsPerSubdomain,
                                    int *NFrontElements, int **FrontElements,
                                                       int MinWeightMeshPoint);
static void DecreaseVertexWeights(int i);
static void FreeGlobalVariables(void);
static void FreeLocalVariables(int *NElementsPerSubdomain);
static int  InitialiseFront(int NStartMinNode, int SubdomainIndex, 
                            int *NElementsPerSubdomain,
                            int *NFrontElements, int **FrontElements);

static void PartitionNeighbouringElements(int i, int SubdomainIndex,
                                          int NElementsPerSubdomain,
                                          int *NElements,
                                          int *NNewFrontElements,
                                          int *NewFrontElements     );
static int  e_sort_function(const void *a, const void *b);


static int **g_AdjacentElements;     /* elements adjacent to each mesh-point */
static int  *g_NAdjacentElements;    /* no. elements adjacent to each MP */
static int **g_SingularElements;
static int  *g_NSingularElements;
static int   g_NMeshPoints;          /* number of mesh-points */
static int  *g_NVpE;                 /* number of vertices per element */
static int  *g_SubdomainIndices;     /* element subdomain indices */
static int   g_TotalNElems;          /* total number of elements */
static int **g_Vertices;             /* vertex node indices */
static int  *g_Weights;              /* mesh-point weights */

static char g_FirstFrontHasBeenCreated;
                                     /* whether the first front has been
                                        created                          */

#define NADJACENT_MAX  10            /* (initial) maximum number of elements
                                        adjacent to each mesh-point OR
                                        (initial) maximum number of mesh-
                                        points adjacent to each mesh-point   */
