/* ////////////////////////////////////////////////////////////////////////// */
/*                                                                            */
/*                              GetParameters()                               */
/*                                Header File                                 */
/*                                                                            */
/* ////////////////////////////////////////////////////////////////////////// */


static int GetKeyword(char *line, char *word, int *LineNumber,
                                  char *FullPathName, FILE *fp);
static int IsAKeyword(char *word);
static int WordMatchesKeyword(char *Keyword, char *word);

static int GetSubdomainData(int *NSubdomains);
static int GetMinNodeNumber(int *NStartMinNode);
static int GetLinkGrabOption(int *LinkGrab);
static int GetIfUniformOption(int TotalNElems, int NSubdomains,
                              int **ElemsPerSubdomain);
static int GetNSubdomains(int *NSubdomains);
static int GetStartMinNode(int *NStartMinNode);
static int GetLinkGrab(int *LinkGrab);
static int GetIfUniform(int TotalNElems, int NSubdomains,
                        int **ElemsPerSubdomain);

static char *OpenInputFile(char *FileName, char *extension, FILE **fp);


#define  KW_NSUBDOMAINS   "NSUBDOMAINS"
#define  KW_STARTMINNODE  "STARTMINNODE"
#define  KW_LINKGRAB      "LINKGRAB"
#define  KW_UNIFORM       "UNIFORM"

/* ////////////////////////////////////////////////////////////////////////// */

static int LineNumber = 0;             /* current line number */

static char *FullPathName;             /* input file full pathname */
static char line[E_LINE_MAX + 1];      /* file line */

static FILE *fp;                       /* input file pointer */
