/* ////////////////////////////////////////////////////////////////////////// */
/*                                                                            */
/*                                  Input()                                   */
/*                                                                            */
/* ////////////////////////////////////////////////////////////////////////// */

#include "e_pltfrm.h"

#ifndef __E_T800SAL__
#include <stdio.h>
#endif

#ifdef __E_T800__
#include <chan.h>
#endif

#include <string.h>
#include <e_lib.h>

#include "input.h"


/* ////////////////////////////////////////////////////////////////////////// */
/* "Input": To read in the input data. The return value is 1 if the data are
   read successfully, else 0.                                                 */


int Input(MESH **mesh, 
          int *NSubdomains, int *NStartMinNode, int *LinkGrab,
          int **ElemsPerSubdomain, char **DomFile, char **DomStatsFile,
          int argc, char *argv[])
{
   char **InputFileName;        /* input filenames */
   char **OutputFileName;       /* output filenames */


   if (!GetFiles(&InputFileName,NINPUT_FILES,&OutputFileName,
                    NOUTPUT_FILES,"filenames file:",argc,argv))
   {
      return 0;
   }
   else if (   !e_GetMeshData(mesh,InputFileName[1])
            || !GetParameters((*mesh)->TotalNElems, NSubdomains, NStartMinNode, 
                              LinkGrab, ElemsPerSubdomain,
                              InputFileName[0]))
   {
      e_free_frag_c_matr(NINPUT_FILES,InputFileName);
      e_free_frag_c_matr(NOUTPUT_FILES,OutputFileName);
      return 0;
   }

   *DomFile = NULL;
   *DomStatsFile = NULL;

   if (   (*DomFile
               = e_alloc_c_vect(strlen(OutputFileName[0]) + 1)) == NULL
       || (*DomStatsFile
               = e_alloc_c_vect(strlen(OutputFileName[1]) + 1)) == NULL)
   {
      e_FreeMeshData(*mesh);
      e_free_frag_c_matr(NINPUT_FILES,InputFileName);
      e_free_frag_c_matr(NOUTPUT_FILES,OutputFileName);
      e_free(*DomFile);
      e_free(*DomStatsFile);
      return 0;
   }

   strcpy(*DomFile,OutputFileName[0]);
   strcpy(*DomStatsFile,OutputFileName[1]);

   e_free_frag_c_matr(NINPUT_FILES,InputFileName);
   e_free_frag_c_matr(NOUTPUT_FILES,OutputFileName);

   return 1;
}
