#include "nodelem.h"

#define GRAPH_ALLOC   6

/* --------------------------------------------------------------------- */

#ifdef __COMM_GRAPH__
void SetCommAdjacency(MESH *mesh, int *degree, int **adjacency,
                      int *no_node_elem, int **node_elem);
#endif

/* --------------------------------------------------------------------- */

#ifdef __DUAL_GRAPH__

/* one side can be shared with max 'n' number of elements */
#define MAX_SHARED_TRIANGLES  2

void SetDualAdjacency(MESH *mesh, int *degree, int **adjacency,
                      int *no_node_elem, int **node_elem);

void SetTriangAdjacencyMatrix(MESH *mesh, int *Degree, int **Adjacency,
                              int NElements, int **Vertices, int StartIndex,
                              int *no_node_elem, int **node_elem);
void SetLinkAdjacencyMatrix(MESH *mesh, int *Degree, int **Adjacency,
                           int NElements, int **Vertices, int StartIndex,
                           int *no_node_elem, int **node_elem);
#endif

/* --------------------------------------------------------------------- */
/* This is a dual graph as well, but if there is a link which cannot be
   placed next to a triangle that is an error !                          */

#ifdef __DUAL_PLANE_GRAPH__

/* one side can be shared with max 'n' number of elements */
#define MAX_SHARED_TRIANGLES  1

void SetDualAdjacency(MESH *mesh, int *degree, int **adjacency,
                      int *no_node_elem, int **node_elem);

void SetTriangAdjacencyMatrix(MESH *mesh, int *Degree, int **Adjacency,
                              int NElements, int **Vertices, int StartIndex,
                              int *no_node_elem, int **node_elem);
void SetLinkAdjacencyMatrix(MESH *mesh, int *Degree, int **Adjacency,
                           int NElements, int **Vertices, int StartIndex,
                           int *no_node_elem, int **node_elem);
#endif

/* --------------------------------------------------------------------- */

#ifdef __CIRC_GRAPH__

/* one side can be shared with max 'n' number of elements */
#define MAX_SHARED_TRIANGLES  2

int *GV_handled;

void SetCircAdjacency(MESH *mesh, int *degree, int **adjacency,
                      int *no_node_elem, int **node_elem);

void SetDualAdjacency(MESH *mesh, int *degree, int **adjacency,
                      int *no_node_elem, int **node_elem);
void SetTriangAdjacencyMatrix(MESH *mesh, int *Degree, int **Adjacency,
                              int NElements, int **Vertices, int StartIndex,
                              int *no_node_elem, int **node_elem);
void SetLinkAdjacencyMatrix(MESH *mesh, int *Degree, int **Adjacency,
                           int NElements, int **Vertices, int StartIndex,
                           int *no_node_elem, int **node_elem);

#endif


