#include <stdio.h>
#include <math.h>
#include <e_lib.h>

#include "graph.h"
#include "strip_create.h"
#include "subdom_graph.h"
#include "ga.h"

MESH           *G_fem1;
MESH           *G_master;
char            G_projectname[E_LINE_MAX];

double          GA_j_gamma;
long            GA_popsize;
double          GA_pcross;
double          GA_pmutation;
long            GA_maxgen;
int             GA_printing;
int             GA_linear;
double          GA_seed;
int             GA_nvar;
int             GA_Maxstep;
int             G_total_recursions;
int             G_total_no_subdomains; /* no of required subdomains */
int             GA_aspect; /* the aspect ratio should be considered */
int             GA_Pareto_method; /* using Pareto optimum */

/* Dual graph of the mesh */
int            *NoNodeElem;
int           **NodeElem;
int            *Degree;
int           **Adjacency;

/* Subdomain graph of the mesh */
int            *SubdomGraphDegree;
int           **SubdomGraph;
int           **SubdomGraphRef;

/* multi */
int            *G_act_subdom;          /* the subdom where the strip is */
int            *G_no_elems_in_subdom;  /* number of elems in the subdomain */
int            *G_no_elems_in_strip;   /* no of elem in the strip */

/* linear - bisection */
int             G_proc_subdom;         /* the currently processed subdom */
double        **G_center;              /* the center of the strips */
int            *G_proc_strip;          /* storing the processed strips */


/* ---------------------------------------------------- */
/*  multi.c */

double    multi_objective(long nvars, DESIGNPARAMS vars);
void      do_multi_decomposition();


/* ---------------------------------------------------- */
/*  linear.c */

double    linear_objective(long nvars, DESIGNPARAMS vars);
int       dirnode(double x1, double y1, double x2, double y2,
                  double x3, double y3);
void      do_linear_decomposition();

