#include "e_lib.h"
#include "subdom_graph.h"
#include "graphio.h"


main(int argc, char *argv[])
{
  MESH      *mesh;
  char       line[E_LINE_MAX];
  char       filename[E_LINE_MAX];
  char       out_file[E_LINE_MAX];
  char      *check;
  FILE      *fp;
  
  int       *Degree;
  int      **Graph;
  int      **GraphRef;
  int       *Weights;

  int        i, j, edges;

  strcpy(filename, "");
  if(argc > 1)
  {
    strcpy(filename, argv[1]);
  }

  if (!strlen(filename))
  {
    printf("\n\nType in the input filename (.mdf) !");
    printf("\nGive no extension : ");
    check = fgets(line, E_LINE_MAX, stdin);
    if(   (check == NULL)
       || (sscanf(line, "%s", &filename) != 1))
      e_GeneralError("Can not read graph filename!");
  }

  /* read in the mesh */
  e_GetMeshData(&mesh, filename);
  e_GetDecompData(mesh, filename);

  Degree   = e_alloc_i_vect(mesh->Decomp.NSubDoms);
  Weights  = e_alloc_i_vect(mesh->Decomp.NSubDoms);
  Graph    = e_alloc_cont_i_matr(mesh->Decomp.NSubDoms, mesh->Decomp.NSubDoms);
  GraphRef = e_alloc_cont_i_matr(mesh->Decomp.NSubDoms, mesh->Decomp.NSubDoms);

  Create_Subdomain_Graph(mesh, Degree, Graph, GraphRef);

  sprintf(out_file, "%s.part", filename);

  /* create the weights for the nodes representing a subdomain */
  for(i = 0; i < mesh->TotalNElems; i++)
    Weights[mesh->Decomp.SubDoms[i]-1]++;

  /* make it a full matrix */
  for(i = 0; i < mesh->Decomp.NSubDoms; i++)
  {
    for(j = 0; j < Degree[i]; j++)
    {
      if(Graph[i][j]-1 > i)
      {
        Graph[Graph[i][j]-1][Degree[Graph[i][j]-1]] = i+1;
        GraphRef[Graph[i][j]-1][Degree[Graph[i][j]-1]] = 
          GraphRef[i][j];
        Degree[Graph[i][j]-1]++;
      }
    }
  }

  e_WriteGraphFile(out_file, 11, mesh->Decomp.NSubDoms, 
                   Degree, Graph, Weights, GraphRef);

}




