#include "e_lib.h"
#include "graphio.h"


main(int argc, char *argv[])
{
  MESH      *mesh;
  char       line[E_LINE_MAX];
  char       filename[E_LINE_MAX];
  char       ptn_file[E_LINE_MAX];
  char       out_file[E_LINE_MAX];
  char      *check;
  FILE      *fp;
  
  int       *Subdoms;

  int        i, NSubdoms;

  strcpy(filename, "");
  if(argc > 1)
  {
    strcpy(filename, argv[1]);
  }

  if (!strlen(filename))
  {
    printf("\n\nType in the input filename (.mdf) !");
    printf("\nGive no extension : ");
    check = fgets(line, E_LINE_MAX, stdin);
    if(   (check == NULL)
       || (sscanf(line, "%s", &filename) != 1))
      e_GeneralError("Can not read graph filename!");
  }

  /* read in the mesh */
  e_GetMeshData(&mesh, filename);
  e_GetDecompData(mesh, filename);

  sprintf(ptn_file, "%s.part", filename);

  Subdoms = e_alloc_i_vect(mesh->Decomp.NSubDoms);
  e_ReadPTNFile(ptn_file, mesh->Decomp.NSubDoms, 
                &NSubdoms, Subdoms);

  for(i = 0; i < mesh->TotalNElems; i++)
  {
    mesh->Decomp.SubDoms[i] = Subdoms[mesh->Decomp.SubDoms[i]-1];
  }
  mesh->Decomp.NSubDoms = NSubdoms;

  sprintf(out_file, "%sout", filename);

  e_PutDecompData(mesh, out_file);

}
