#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "e_lib.h"



main(int argc, char *argv[])
{
  char        GV_filename[E_LINE_MAX];
  MESH       *GV_mesh;

  int         GV_NInterSubDomNodes, *GV_InterSubDomNodes;
  int        *GV_NNodeSubDoms, **GV_NodeSubDoms;
  char        line[E_LINE_MAX];
  char       *check;
  int        *elems;
  int        *weights;
  int         i;

  strcpy(GV_filename, "");
  if(argc > 1)
  {
    strcpy(GV_filename, argv[1]);
  }

  if (!strlen(GV_filename))
  {
    printf("\n\nType in the input filename (.mdf) !");
    printf("\nGive no extension : ");
    check = fgets(line, E_LINE_MAX, stdin);
    if(   (check == NULL)
       || (sscanf(line, "%s", &GV_filename) != 1))
      e_GeneralError("Can not read filename!");
  }

  e_GetMeshData(&GV_mesh, GV_filename);
  e_GetDecompData(GV_mesh, GV_filename);

  e_GetInterSubDomNodes(GV_mesh, &GV_NInterSubDomNodes, &GV_InterSubDomNodes,
                        &GV_NNodeSubDoms, &GV_NodeSubDoms);

  elems = e_alloc_i_vect(GV_mesh->Decomp.NSubDoms);
  for(i = 0; i < GV_mesh->TotalNElems; i++)
  {
    elems[GV_mesh->Decomp.SubDoms[i]-1]++;
  }


  weights = e_alloc_i_vect(GV_mesh->Decomp.NSubDoms);
  for(i = 0; i < GV_mesh->NElemsLink1; i++)
  {
    weights[GV_mesh->Decomp.SubDomsLink1[i]-1]++;
  }
  for(i = 0; i < GV_mesh->NElemsLink2; i++)
  {
    weights[GV_mesh->Decomp.SubDomsLink2[i]-1]++;
  }
  for(i = 0; i < GV_mesh->NElemsLink3; i++)
  {
    weights[GV_mesh->Decomp.SubDomsLink3[i]-1]++;
  }
  for(i = 0; i < GV_mesh->NElemsLink4; i++)
  {
    weights[GV_mesh->Decomp.SubDomsLink4[i]-1]++;
  }
  for(i = 0; i < GV_mesh->NElemsLink5; i++)
  {
    weights[GV_mesh->Decomp.SubDomsLink5[i]-1]++;
  }

  for(i = 0; i < GV_mesh->NElemsTriang3; i++)
  {
    weights[GV_mesh->Decomp.SubDomsTriang3[i]-1] += 7;
  }
  for(i = 0; i < GV_mesh->NElemsTriang4; i++)
  {
    weights[GV_mesh->Decomp.SubDomsTriang4[i]-1] += 7;
  }
  for(i = 0; i < GV_mesh->NElemsTriang5; i++)
  {
    weights[GV_mesh->Decomp.SubDomsTriang5[i]-1] += 7;
  }

  printf("\n---------------------------------------------------");
  printf("\n---------------- Statistics -----------------------");
  printf("\n---------------------------------------------------\n");
  printf("\nNo of communication nodes: %d\n", GV_NInterSubDomNodes);
  for(i = 0; i < GV_mesh->Decomp.NSubDoms; i++)
  {
    printf("\n%d of elements and %d weights in %d. subdomain: ", 
           elems[i], weights[i], i+1);
  }
  printf("\n\n");

  e_free(elems);

}
