/* ////////////////////////////////////////////////////////////////////////// */
/*                                                                            */
/*                      e_GetFEErrors(), e_PutFEErrors()                      */
/*                                Header File                                 */
/*                                                                            */
/* ////////////////////////////////////////////////////////////////////////// */


static int AllCompulsoryKeywordsSet(void);
static int Initialise(MESH *mesh);
static int IsAKeyword(char *word);
static int WordMatchesKeyword(char *Keyword, char *word);

static int GetData(MESH *mesh);
static int GetFEErrors(int NElements, double *FEErrors);

static void DeallocateAllMemory(void);
static void SetMeshData(MESH *mesh);


/* ////////////////////////////////////////////////////////////////////////// */
/* Mesh data */

static int NElemsLink1;                 /* number of LINK1 elements */
static int NElemsLink2;                 /* number of LINK2 elements */
static int NElemsLink3;                 /* number of LINK3 elements */
static int NElemsLink4;                 /* number of LINK4 elements */
static int NElemsLink5;                 /* number of LINK5 elements */
static int NElemsTriang1;               /* number of TRIANG1 elements */
static int NElemsTriang2;               /* number of TRIANG2 elements */
static int NElemsTriang3;               /* number of TRIANG3 elements */
static int NElemsTriang4;               /* number of TRIANG4 elements */
static int NElemsTriang5;               /* number of TRIANG5 elements */
static int NElemsQuad1;                 /* number of QUAD1 elements */
static int NElemsQuad3;                 /* number of QUAD3 elements */
static int NElemsTetrah1;               /* number of TETRAH1 elements */
static int NElemsBlock1;                /* number of BLOCK1 elements  */
static int TotalNElems;                 /* total number of elements */

/* ////////////////////////////////////////////////////////////////////////// */
/* Finite element error data */

static double *FEErrors;
static double *FEErrorsLink1;           /* LINK1 finite element errors */
static double *FEErrorsLink2;           /* LINK2 finite element errors */
static double *FEErrorsLink3;           /* LINK3 finite element errors */
static double *FEErrorsLink4;           /* LINK4 finite element errors */
static double *FEErrorsLink5;           /* LINK5 finite element errors */
static double *FEErrorsTriang1;         /* TRIANG1 finite element errors */
static double *FEErrorsTriang2;         /* TRIANG2 finite element errors */
static double *FEErrorsTriang3;         /* TRIANG3 finite element errors */
static double *FEErrorsTriang4;         /* TRIANG4 finite element errors */
static double *FEErrorsTriang5;         /* TRIANG5 finite element errors */
static double *FEErrorsQuad1;           /* QUAD1 finite element errors */
static double *FEErrorsQuad3;           /* QUAD3 finite element errors */
static double *FEErrorsTetrah1;         /* TETRAH1 finite element errors */
static double *FEErrorsBlock1;          /* BLOCK1 finite element errors */


/* ////////////////////////////////////////////////////////////////////////// */

static int LineNumber;                  /* current line number */

static char AllCompKeywordsSet;         /* whether compulsory keywords set */
static char *FullPathName;              /* io-file full pathname */
static char line[E_LINE_MAX + 1];       /* file line */

static FILE *fp;                        /* io-file pointer */
