/* ////////////////////////////////////////////////////////////////////////// */
/*                                                                            */
/*                           Mathematical Functions                           */
/*                                Header File                                 */
/*                                                                            */
/* ////////////////////////////////////////////////////////////////////////// */


static int PivotFactorise(int n, double **A, int *pivot);
static int SetPivot(int k, int n, double **A, int *pivot);
static int ReOrder(int n, double *b, int *pivot);
static int Factorise(int n, double **A);

static void SetPivotMultFactors(int k, int n, double **A, int *pivot);
static void SubtractPivotRow(int k, int n, double **A, int *pivot);
static void SetMultFactors(int k, int n, double **A);
static void SubtractRow(int k, int n, double **A);

static void PivotForwardSubstitute(int n, double **LU, double *b, int *pivot);
static void PivotBackSubstitute(int n, double **LU, double *b, int *pivot);
static void ForwardSubstitute(int n, double **LU, double *b);
static void BackSubstitute(int n, double **LU, double *b);


#define PIVOT_MIN  (1000.0*DBL_MIN)

