/* File: 3D.H  */





               /* to get the right element  */
               /*   of a co-ordinate vector   */
#define XDIR 0
#define YDIR 1
#define ZDIR 2


      /******************************/
      /*                            */
      /*      Type declarations     */
      /*                            */
      /******************************/


typedef double j_3Dvector[3];
typedef double j_3Drot_matrix[3][3];





      /******************************/
      /*                            */
      /*      Global variables      */
      /*                            */
      /******************************/


#ifdef  JJJ_MAIN
#define X_MAIN
#endif
#ifndef JJJ_MAIN
#define X_MAIN  extern
#endif

    /* rotation matrix of the central projection */
    /*     and its inverse matrix                */
X_MAIN j_3Drot_matrix G_cpm,G_cpim;
//X_MAIN double **G_cpm,**G_cpim;


    /* distance between the Target and the Centre points */
X_MAIN double G_dTC;

    /* aspect ratio for the screen   */
X_MAIN double G_pixel_ratio;

    /* origin of the screen system, usually the middle of the window */
X_MAIN double G_Xscrorigin,G_Yscrorigin;

    /* vector of the Target point    */
X_MAIN j_3Dvector G_Target;

    /* vector of the Center point    */
X_MAIN j_3Dvector G_Center;

    /* the camera Twisting angle     */
X_MAIN double G_Twist;

    /* the Azimuth and the Elevation angle              */
    /* of the Center point from the Target as an origin */
X_MAIN double G_Azim,G_Elev;

    /* scaling factor for the screen image and its initial value  */
X_MAIN double G_scale,G_initscale;






      /******************************/
      /*                            */
      /*    Function declarations   */
      /*                            */
      /******************************/



void j_3Dworld_to_screen(j_3Dvector screen,j_3Dvector world);
void p_3Dworld_to_screen(double *result,double *world);
void j_3Dvec_mult_matrix(j_3Dvector a,j_3Dvector b,j_3Drot_matrix M);
void j_3Dinverse_rot_matrix(j_3Drot_matrix InvM,j_3Drot_matrix M);
void j_3Dmatrix_mult(j_3Drot_matrix C,j_3Drot_matrix A,j_3Drot_matrix B);
void j_3Dfill_rot_matrix(j_3Drot_matrix M, double angle, short axis);
void j_3Dspherical_coords(double *Dist,double *Azim,double *Elev,j_3Dvector cpoint,j_3Dvector tpoint);
void j_3Dcalc_rot_matrix(void);
void j_3Drecalc_rot_matrix(void);

double  j_offset(double dx, double dy);




      /******************************/
      /*                            */
      /*     Macros to accelerate   */
      /*                            */
      /******************************/


#define M_Add_vec(result,a,b)\
      ((result)[XDIR] = (a)[XDIR] + (b)[XDIR],\
       (result)[YDIR] = (a)[YDIR] + (b)[YDIR],\
       (result)[ZDIR] = (a)[ZDIR] + (b)[ZDIR])

#define M_Subtr_vec(result,a,b)\
      ((result)[XDIR] = (a)[XDIR] - (b)[XDIR],\
       (result)[YDIR] = (a)[YDIR] - (b)[YDIR],\
       (result)[ZDIR] = (a)[ZDIR] - (b)[ZDIR])

#define M_Dot_product(a,b)\
       ((a)[XDIR] * (b)[XDIR] + (a)[YDIR] * (b)[YDIR] + (a)[ZDIR] * (b)[ZDIR])

#define M_Length(v) sqrt((double) M_Dot_product(v,v))




#define M_Vec_dot_matrix(c,a,b)\
      (c)[XDIR] = (a)[XDIR] * *(b)   + (a)[YDIR] * *(b+3) + (a)[ZDIR] * *(b+6),\
      (c)[YDIR] = (a)[XDIR] * *(b+1) + (a)[YDIR] * *(b+4) + (a)[ZDIR] * *(b+7),\
      (c)[ZDIR] = (a)[XDIR] * *(b+2) + (a)[YDIR] * *(b+5) + (a)[ZDIR] * *(b+8)


#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif





/* End Of File: 3D.H  */