/*************************************************

   E_plot, the mdf viewer
   developped for the SECT Research Group

   original code by Janos Szivery 1997
   adaptation/maintenance by Jelle Muylle 1999

   connectivity graph / advanced hidden line by
   		Peter Ivanyi 1999

 *************************************************/

#include <windows.h>
#include <commdlg.h>
#include <commctrl.h>
#include <wingdi.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <math.h>

#define JJJ_MAIN
#define VERSION_NO	"2.52"

#define __E_MSWIN32__

#include "j_3d.h"
#include "eps.h"

/* eps.h contains e_lib.h */

#include "e_plot.h"

#define MoveTo(a,b,c) MoveToEx(a,b,c,NULL)
#define SetViewportOrg(a,b,c) SetViewportOrgEx(a,b,c,NULL)
#define SetWindowExt(a,b,c) SetWindowExtEx(a,b,c,NULL)
#define SetViewportExt(a,b,c) SetViewportExtEx(a,b,c,NULL)


int PASCAL      WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow)
{
    WNDCLASS        wndclass;
    MSG             msg;

    if (!hPrevInstance)
    {
	wndclass.style = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc = j_main_wndproc;
	wndclass.cbClsExtra = 0;
	wndclass.cbWndExtra = 0;
	wndclass.hInstance = hInstance;
	wndclass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(E_ICON));
	wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = CreateSolidBrush(RGB(0x00, 0x00, 0x00));
	wndclass.lpszMenuName = NULL;
	wndclass.lpszClassName = szAppName;
	RegisterClass(&wndclass);
    }

    G_hInst = hInstance;

    x_screen_size = GetSystemMetrics(SM_CXSCREEN);
    y_screen_size = GetSystemMetrics(SM_CYSCREEN);

    G_main_hwnd = CreateWindow(szAppName, szEnWindowTitle,
			       WS_OVERLAPPEDWINDOW,
			       x_screen_size / 6, y_screen_size / 6,
			       x_screen_size * 4 / 6, y_screen_size * 4 / 6,
			       NULL, NULL, hInstance, NULL);

    ShowWindow(G_main_hwnd, nCmdShow);
    UpdateWindow(G_main_hwnd);

    while (GetMessage(&msg, NULL, 0, 0))
    {
	TranslateMessage(&msg);
	DispatchMessage(&msg);
    }

    return (0);
}				/* end of main()  */







long FAR PASCAL _export j_main_wndproc(HWND hwnd, UINT message, UINT wParam, LONG lParam)
{
    HDC             hdc, MemDC, hdcMeta, hdcInfo, hdcRef;
    HBITMAP         OldBM;
    HBRUSH          holdbrush;
    PAINTSTRUCT     ps;

    static HMENU    hMenu, hMenuPopup;
    static WORD     wSelection = IDM_P_AZIM_ELEV;
    static BOOL     wOpenFile = FALSE;

    static HGLOBAL  hResource;
    static HMETAFILE hmfl;
    static POINTS   ptBeg, ptEnd;
    static RECT     rect;
    static long     iWidthMM, iHeightMM, iWidthPels, iHeightPels;

    static int      xdifpix, ydifpix;
    static BOOL     w_fCapturing = FALSE;
    static FARPROC  lpfnAboutEplotDlgProc;
    static FARPROC  lpfnSpSelDlgProc;
    static FARPROC  lpfnZoomToDlgProc;
    static FARPROC  lpfnGIDlgProc;
    static unsigned long nHorzRes, nColors;
    unsigned int    nPlanes, nBitsPixel;
    static char     scr_intro[20];
    PRINTDLG        pd = {0};
    char            debugmessage[200];
    char            filen[MAXFILENAME];
    char            filetitlen[MAXFILETITLE];
    TEXTMETRIC      tm;
    int             chh;
    static char     szBuffer[100];
    int 			fnMapModeOld;
    static BOOL		AHl_once;
    int					i;

    switch (message)
    {
	case WM_CREATE:
	    hMenu = LoadMenu(G_hInst, MAKEINTRESOURCE(MAIN_MENU));
	    SetMenu(hwnd, hMenu);
	    lpfnAboutEplotDlgProc = MakeProcInstance((FARPROC) AboutEplotDlgProc, G_hInst);
	    lpfnSpSelDlgProc = MakeProcInstance((FARPROC) SpSelDlgProc, G_hInst);
	    lpfnZoomToDlgProc = MakeProcInstance((FARPROC) ZoomToDlgProc, G_hInst);
	    lpfnGIDlgProc = MakeProcInstance((FARPROC) GIDlgProc, G_hInst);
	    strcpy(G_filetitle, "");
	    j_DoCaption(hwnd, G_filetitle);

	    hdcInfo = CreateIC("DISPLAY", NULL, NULL, NULL);
	    nHorzRes = GetDeviceCaps(hdcInfo, HORZRES);
	    nPlanes = GetDeviceCaps(hdcInfo, PLANES);
	    nBitsPixel = GetDeviceCaps(hdcInfo, BITSPIXEL);
	    nColors = 1 << (nPlanes * nBitsPixel);
	    DeleteDC(hdcInfo);

       for (i=0;i<16;i++)
       	wSubdomColours[i]=RGB(subdomcolors[i][0],subdomcolors[i][1],subdomcolors[i][2]);

/*	    wSubdomColours[0] = SD_No1;
	    wSubdomColours[1] = SD_No2;
	    wSubdomColours[2] = SD_No3;
	    wSubdomColours[3] = SD_No4;
	    wSubdomColours[4] = SD_No5;
	    wSubdomColours[5] = SD_No6;
	    wSubdomColours[6] = SD_No7;
	    wSubdomColours[7] = SD_No8;
	    wSubdomColours[8] = SKY_BLUE;
	    wSubdomColours[9] = YELLOW;
	    wSubdomColours[10] = BLACK;
	    wSubdomColours[11] = LIGHT_GRAY;
	    wSubdomColours[12] = MIDDLE_GRAY;
	    wSubdomColours[13] = GREEN;
	    wSubdomColours[14] = GREEN;
	    wSubdomColours[15] = GREEN;          */
	    wSubdomBWColours[0] = SD_BW_No1;
	    wSubdomBWColours[1] = SD_BW_No2;
	    wSubdomBWColours[2] = SD_BW_No3;
	    wSubdomBWColours[3] = SD_BW_No4;
	    wSubdomBWColours[4] = SD_BW_No5;
	    wSubdomBWColours[5] = SD_BW_No6;
	    wSubdomBWColours[6] = SD_BW_No7;
	    wSubdomBWColours[7] = SD_BW_No8;
	    wSubdomBWColours[8] = SD_BW_No1;
	    wSubdomBWColours[9] = SD_BW_No2;
	    wSubdomBWColours[10] = SD_BW_No3;
	    wSubdomBWColours[11] = SD_BW_No4;
	    wSubdomBWColours[12] = SD_BW_No5;
	    wSubdomBWColours[13] = SD_BW_No6;
	    wSubdomBWColours[14] = SD_BW_No7;
	    wSubdomBWColours[15] = SD_BW_No8;
        wSubdom4Col[0] = SD_4COL_1;
        wSubdom4Col[1] = SD_4COL_2;
        wSubdom4Col[2] = SD_4COL_3;
        wSubdom4Col[3] = SD_4COL_4;
        wSubdom4Col[4] = SD_4COL_5;
        wSubdom4Col[5] = SD_4COL_6;
	    return (0);

	case WM_SIZE:
	    w_xmclient_size = LOWORD(lParam);
	    w_ymclient_size = HIWORD(lParam);
	    G_Xscrorigin = w_xmclient_size / 2;
	    G_Yscrorigin = w_ymclient_size / 2;
	    return (0);

	case WM_PAINT:
	    hdc = BeginPaint(hwnd, &ps);
	    if (wOpenFile == TRUE)
	    {
		MemDC = CreateCompatibleDC(hdc);
		OldBM = (HBITMAP) SelectObject(MemDC, CreateCompatibleBitmap(hdc, w_xmclient_size, w_ymclient_size));
		switch (wPlotSelect)
		{
		    case IDM_PO_MESHPARAM:
		    case IDM_PO_STRESS:
		    case IDM_PO_ERROR:
			holdbrush = (HBRUSH) SelectObject(MemDC, GetStockObject(DKGRAY_BRUSH));
			PatBlt(MemDC, 0, 0, w_xmclient_size, w_ymclient_size, PATCOPY);
			SelectObject(MemDC, holdbrush);
			break;
		    case IDM_PO_SUBDOMAIN:
			if ((w_iBW_subdomains) || (wPrintPrev))
			    BitBlt(MemDC, 0, 0, w_xmclient_size, w_ymclient_size, NULL, 0, 0, WHITENESS);
			else
			    BitBlt(MemDC, 0, 0, w_xmclient_size, w_ymclient_size, NULL, 0, 0, BLACKNESS);
			break;
		    default:
			if ((w_iBW_subdomains) || (wPrintPrev))
			    BitBlt(MemDC, 0, 0, w_xmclient_size, w_ymclient_size, NULL, 0, 0, WHITENESS);
			else
			    BitBlt(MemDC, 0, 0, w_xmclient_size, w_ymclient_size, NULL, 0, 0, BLACKNESS);
			break;
		}
		if (wPrintPrev)
		{
		    j_paint_screen_elems(MemDC, TRUE);
		    wPrintPrev = FALSE;
		}
        else
			j_paint_screen_elems(MemDC, FALSE);
		if (wDisplScale)
		    j_drawscale(MemDC);

		SetViewportOrg(MemDC, 0, 0);
		BitBlt(hdc, 0, 0, w_xmclient_size, w_ymclient_size, MemDC, 0, 0, SRCCOPY);
		DeleteObject(SelectObject(MemDC, OldBM));
		DeleteDC(MemDC);
	    }
	    else
	    {
		BitBlt(hdc, 0, 0, w_xmclient_size, w_ymclient_size, NULL, 0, 0, BLACKNESS);
		SetTextColor(hdc, WHITE);
		SetBkColor(hdc, BLACK);
		GetTextMetrics(hdc, &tm);
		chh = tm.tmHeight + tm.tmExternalLeading;
		TextOut(hdc, 20, 20, szBuffer, sprintf(szBuffer, "SECT Research Group"));
		TextOut(hdc, 20, 20 + 1 * chh, szBuffer, sprintf(szBuffer, "Heriot-Watt University Edinburgh"));
		TextOut(hdc, 20, 20 + 3 * chh, szBuffer, sprintf(szBuffer, "E_Plot32 Win32 viewer for E_library files"));
        TextOut(hdc, 20, 20 + 4 * chh, szBuffer, sprintf(szBuffer, "v%s %s %s", VERSION_NO, __DATE__, __TIME__));
	    }
	    EndPaint(hwnd, &ps);
	    return (0);

	case WM_HELP:
	    if (!WinHelp(hwnd, "E_PLOT32.HLP", HELP_INDEX, 0))
		MessageBox(GetFocus(), "Unable to activate help", szAppName, MB_SYSTEMMODAL | MB_OK | MB_ICONHAND);
	    return (0);
	case WM_COMMAND:
	    switch (wParam)
	    {
		case IDM_F_OPEN:
		    j_FileInitialize(hwnd);
            G_file[0]='\0';
            G_filetitle[0]='\0';
		    if (!j_FileOpenDlg(hwnd, G_file, G_filetitle))
            	{
            	if (CommDlgExtendedError()==FNERR_INVALIDFILENAME)
                	w_OkMsgBox("invalid filename");
				w_OkMsgBox("Please select a file first!");
                }
		    else
		    {
			strncpy(filen, G_file, strlen(G_file) - 4);
			filen[strlen(G_file) - 4] = '\0';
			strncpy(filetitlen, G_filetitle, strlen(G_filetitle) - 4);
			filetitlen[strlen(G_filetitle) - 4] = '\0';
			strcpy(G_file, filen);
			strcpy(G_filetitle, filetitlen);

			if (e_GetMeshData(&fem1, G_file))
			{
			    j_DoCaption(hwnd, G_filetitle);
			    wOpenFile = TRUE;
			    EnableMenuItem(hMenu, IDM_F_OPEN, MF_GRAYED);
			    EnableMenuItem(hMenu, IDM_F_CLOSE, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_F_PRINT, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_F_PSU, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_F_PPREV, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_PO_PLAINMESH, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_PO_SUBDOMAIN, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_PO_MESHPARAM, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_PO_STRESS, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_PO_ERROR, MF_ENABLED);
			    CheckMenuItem(hMenu, IDM_PO_PLAINMESH, MF_CHECKED);
			    EnableMenuItem(hMenu, IDM_P_AZIM_ELEV, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_P_TCDIST_SCALE, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_P_SCRORIGIN, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_P_TARGETCOORDS, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_P_TARGETELEV, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_P_NICE_VIEW, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_P_PLAN_VIEW, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_P_HID_VIEW, MF_ENABLED);
                EnableMenuItem(hMenu, IDM_P_ADV_HID_VIEW, MF_ENABLED);
                EnableMenuItem(hMenu, IDM_P_ZOOM_TO, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_P_GRAPHICSINFO, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_D_ELEM_NO, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_D_POINT_NO, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_D_TILE_ELEMS, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_D_TILE_LINKS, MF_ENABLED);
			    CheckMenuItem(hMenu, IDM_D_ELEM_NO, MF_UNCHECKED);
			    CheckMenuItem(hMenu, IDM_D_POINT_NO, MF_UNCHECKED);
                EnableMenuItem(hMenu, IDM_D_CLIP, MF_ENABLED);
			    EnableMenuItem(hMenu, IDM_D_SAVE_IMAGE, MF_ENABLED);
			    wPlotSelect = IDM_PO_PLAINMESH;
			    wDisplElemNo = wDisplPointNo = wTileElems = wTileLinks = wDisplScale
                			 = wHidden = wPrintPrev = wClipPlane = wAdvHidden = FALSE;
			    w_Element_Size_percent = 100.00;
			    w_Link_Size_percent = 100.00;
                AHl_once=FALSE;
			    InvalidateRect(hwnd, NULL, FALSE);
                setup_polygons(fem1, &polygons, &Npoly);
			    j_init_perspective();
			}
			else
			{
			    w_OkMsgBox("Could not read in the file: %s", G_file);
			}

		    }
		    return (0);
		case IDM_F_CLOSE:
		    strcpy(G_filetitle, "");
		    j_DoCaption(hwnd, G_filetitle);
		    wOpenFile = FALSE;
		    EnableMenuItem(hMenu, IDM_F_OPEN, MF_ENABLED);
		    EnableMenuItem(hMenu, IDM_F_CLOSE, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_F_PRINT, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_F_PSU, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_F_PPREV, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_P_AZIM_ELEV, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_P_TCDIST_SCALE, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_P_SCRORIGIN, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_P_TARGETCOORDS, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_P_TARGETELEV, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_P_ZETAADJUST, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_P_NICE_VIEW, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_P_PLAN_VIEW, MF_GRAYED);
		    CheckMenuItem(hMenu, IDM_P_HID_VIEW, MF_UNCHECKED);
		    EnableMenuItem(hMenu, IDM_P_HID_VIEW, MF_GRAYED);
            CheckMenuItem(hMenu, IDM_P_ADV_HID_VIEW, MF_UNCHECKED);
		    EnableMenuItem(hMenu, IDM_P_ADV_HID_VIEW, MF_GRAYED);
            EnableMenuItem(hMenu, IDM_P_ZOOM_TO, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_P_GRAPHICSINFO, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_D_ELEM_NO, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_D_POINT_NO, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_D_SAVE_IMAGE, MF_GRAYED);
		    CheckMenuItem(hMenu, IDM_D_DISPLSCALE, MF_UNCHECKED);
		    EnableMenuItem(hMenu, IDM_D_DISPLSCALE, MF_GRAYED);
		    CheckMenuItem(hMenu, IDM_D_TILE_ELEMS, MF_UNCHECKED);
		    EnableMenuItem(hMenu, IDM_D_TILE_ELEMS, MF_GRAYED);
		    CheckMenuItem(hMenu, IDM_D_TILE_LINKS, MF_UNCHECKED);
		    EnableMenuItem(hMenu, IDM_D_TILE_LINKS, MF_GRAYED);
            CheckMenuItem(hMenu, IDM_D_CLIP, MF_UNCHECKED);
		    EnableMenuItem(hMenu, IDM_D_CLIP, MF_GRAYED);
		    wDisplScale = FALSE;
		    InvalidateRect(hwnd, NULL, FALSE);
		    e_FreeMeshData(fem1);

		    if (wPlotSelect == IDM_PO_SUBDOMAIN)
		    {
			hMenuPopup = GetSubMenu(hMenu, NUM_PLOT_OPTION_POPUP);
            DeleteMenu(hMenuPopup, IDM_POO_4COL, MF_BYCOMMAND);
			DeleteMenu(hMenuPopup, IDM_POO_SD_BW, MF_BYCOMMAND);
			DeleteMenu(hMenuPopup, IDM_POO_SB, MF_BYCOMMAND);
			DrawMenuBar(hwnd);
		    }
		    if (wPlotSelect == IDM_PO_STRESS)
		    {
			hMenuPopup = GetSubMenu(hMenu, NUM_PLOT_OPTION_POPUP);
			DeleteMenu(hMenuPopup, IDM_POO_XXSTRESS, MF_BYCOMMAND);
			DeleteMenu(hMenuPopup, IDM_POO_YYSTRESS, MF_BYCOMMAND);
			DeleteMenu(hMenuPopup, IDM_POO_XYSTRESS, MF_BYCOMMAND);
			DeleteMenu(hMenuPopup, IDM_POO_SB, MF_BYCOMMAND);
			DeleteMenu(hMenuPopup, IDM_POO_SP_SEL, MF_BYCOMMAND);
			DrawMenuBar(hwnd);
			if (wSelection == IDM_P_STRESSCOL)
			{
			    CheckMenuItem(hMenu, wSelection, MF_UNCHECKED);
			    wSelection = IDM_P_AZIM_ELEV;
			    CheckMenuItem(hMenu, wSelection, MF_CHECKED);
			}
			EnableMenuItem(hMenu, IDM_P_STRESSCOL, MF_GRAYED);
		    }
		    if (wPlotSelect == IDM_PO_MESHPARAM)
		    {
			hMenuPopup = GetSubMenu(hMenu, NUM_PLOT_OPTION_POPUP);
			DeleteMenu(hMenuPopup, IDM_POO_SB, MF_BYCOMMAND);
			DrawMenuBar(hwnd);
		    }
		    if (wPlotSelect == IDM_PO_ERROR)
		    {
			hMenuPopup = GetSubMenu(hMenu, NUM_PLOT_OPTION_POPUP);
			DeleteMenu(hMenuPopup, IDM_POO_SB, MF_BYCOMMAND);
			DrawMenuBar(hwnd);
		    }
		    CheckMenuItem(hMenu, wPlotSelect, MF_UNCHECKED);
		    CheckMenuItem(hMenu, IDM_PO_PLAINMESH, MF_CHECKED);
		    EnableMenuItem(hMenu, IDM_PO_PLAINMESH, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_PO_SUBDOMAIN, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_PO_MESHPARAM, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_PO_STRESS, MF_GRAYED);
		    EnableMenuItem(hMenu, IDM_PO_ERROR, MF_GRAYED);

		    return (0);
		case IDM_F_PRINT:
		    if (j_print_page(hwnd))
			MessageBox(hwnd, "Could not print page!", szAppName, MB_OK | MB_ICONEXCLAMATION);
		    return (0);
		case IDM_F_PSU:
		    pd.lStructSize = sizeof(pd);
		    pd.hwndOwner = hwnd;
		    pd.hDevMode = hDevMode;
		    pd.hDevNames = hDevNames;
		    pd.Flags = PD_PRINTSETUP;
		    if (PrintDlg(&pd))
		    {
			hDevMode = pd.hDevMode;
			hDevNames = pd.hDevNames;
		    }
		    return 0;
		case IDM_F_EXIT:
		    SendMessage(hwnd, WM_CLOSE, 0, 0L);
		    return (0);
		case IDM_F_ABOUT:
                    sprintf(szBuffer, "SECT Research Group\nHeriot-Watt University Edinburgh\n\nE_Plot32 v%s Win32 version\nviewer for E_library files", VERSION_NO);
		    MessageBox(G_main_hwnd, szBuffer, szAppName, MB_OK | MB_ICONINFORMATION);
		    return (0);
		case IDM_F_PPREV:
		    wPrintPrev = TRUE;
		    InvalidateRect(hwnd, NULL, FALSE);
		    return (0);
		case IDM_H_CONT:
		    if (!WinHelp(hwnd, "E_PLOT32.HLP", HELP_INDEX, 0))
			MessageBox(GetFocus(), "Unable to activate help", szAppName, MB_SYSTEMMODAL | MB_OK | MB_ICONHAND);
		    return (0);
		case IDM_H_SEARCH:
		    if (!WinHelp(hwnd, "E_PLOT32.HLP", HELP_PARTIALKEY, (DWORD) (LPSTR) ""))
			MessageBox(GetFocus(), "Unable to activate help", szAppName, MB_SYSTEMMODAL | MB_OK | MB_ICONHAND);
		    return (0);
		case IDM_H_HOW:
		    if (!WinHelp(hwnd, NULL, HELP_HELPONHELP, 0))
			MessageBox(GetFocus(), "Unable to activate help", szAppName, MB_SYSTEMMODAL | MB_OK | MB_ICONHAND);
		    return (0);
        case IDM_H_DEBUG:
        	w_OkMsgBox("Graphics Options\nTarget (%1.5f,%1.5f,%1.5f)\nTwist %1.5f\nAzimut %1.5f\nElevation %1.5f\ndTC %1.5f\nScale %1.5f",
            				G_Target[0], G_Target[1], G_Target[2],
                            G_Twist, G_Azim, G_Elev,
                            G_dTC, G_scale);
            return (0);

		case IDM_D_ELEM_NO:
		    if (wDisplElemNo)
		    {
			CheckMenuItem(hMenu, IDM_D_ELEM_NO, MF_UNCHECKED);
			wDisplElemNo = FALSE;
		    }
		    else
		    {
			CheckMenuItem(hMenu, IDM_D_ELEM_NO, MF_CHECKED);
			wDisplElemNo = TRUE;
		    }
		    InvalidateRect(hwnd, NULL, FALSE);
		    return (0);
		case IDM_D_POINT_NO:
		    if (wDisplPointNo)
		    {
			CheckMenuItem(hMenu, IDM_D_POINT_NO, MF_UNCHECKED);
			wDisplPointNo = FALSE;
		    }
		    else
		    {
			CheckMenuItem(hMenu, IDM_D_POINT_NO, MF_CHECKED);
			wDisplPointNo = TRUE;
		    }
		    InvalidateRect(hwnd, NULL, FALSE);
		    return (0);
		case IDM_D_TILE_ELEMS:
		    if (wTileElems)
		    {
			CheckMenuItem(hMenu, wParam, MF_UNCHECKED);
			wTileElems = FALSE;
			w_Element_Size_percent = 100.00;
		    }
		    else
		    {
			CheckMenuItem(hMenu, wParam, MF_CHECKED);
			wTileElems = TRUE;
			w_Element_Size_percent = 80.00;
		    }
		    InvalidateRect(hwnd, NULL, FALSE);
		    return (0);
		case IDM_D_TILE_LINKS:
		    if (wTileLinks)
		    {
			CheckMenuItem(hMenu, wParam, MF_UNCHECKED);
			wTileLinks = FALSE;
			w_Link_Size_percent = 100.00;
		    }
		    else
		    {
			CheckMenuItem(hMenu, wParam, MF_CHECKED);
			wTileLinks = TRUE;
			w_Link_Size_percent = 80.00;
		    }
		    InvalidateRect(hwnd, NULL, FALSE);
		    return (0);
		case IDM_D_DISPLSCALE:
		    if (wDisplScale)
		    {
			CheckMenuItem(hMenu, IDM_D_DISPLSCALE, MF_UNCHECKED);
			wDisplScale = FALSE;
		    }
		    else
		    {
			CheckMenuItem(hMenu, IDM_D_DISPLSCALE, MF_CHECKED);
			wDisplScale = TRUE;
		    }
		    InvalidateRect(hwnd, NULL, FALSE);
		    return (0);
        case IDM_D_CLIP:
		    if (wClipPlane)
		    {
				CheckMenuItem(hMenu, IDM_D_CLIP, MF_UNCHECKED);
				wClipPlane = FALSE;
		    }
		    else
		    {
				CheckMenuItem(hMenu, IDM_D_CLIP, MF_CHECKED);
				wClipPlane = TRUE;
		    }
		    InvalidateRect(hwnd, NULL, FALSE);
		    return (0);
		case IDM_D_SAVE_IMAGE:
		    ofn.lStructSize = sizeof(OPENFILENAME);
		    ofn.hwndOwner = hwnd;
		    ofn.lpstrFilter = szEmfFilter[0];
		    ofn.lpstrFile = G_filetitle;
		    ofn.lpstrFileTitle = G_filetitle;
		    ofn.lpstrInitialDir = (LPSTR) NULL;
		    ofn.Flags = OFN_OVERWRITEPROMPT;
		    ofn.lpstrTitle = "E-Plot - Image Save As";
		    ofn.lpstrDefExt = "emf";

		    if (GetSaveFileName(&ofn))
		    {
                hdcRef = GetDC(hwnd);
                if ((strcmp(ofn.lpstrFileTitle+strlen(ofn.lpstrFileTitle)-4, ".emf")==0)||
                    (strcmp(ofn.lpstrFileTitle+strlen(ofn.lpstrFileTitle)-4, ".EMF")==0)  )
				{
                	iWidthMM = GetDeviceCaps(hdcRef, HORZSIZE);
					iHeightMM = GetDeviceCaps(hdcRef, VERTSIZE);
					iWidthPels = GetDeviceCaps(hdcRef, HORZRES);
					iHeightPels = GetDeviceCaps(hdcRef, VERTRES);

					GetClientRect(hwnd, &rect);
					rect.left = (rect.left * iWidthMM * 100) / iWidthPels;
					rect.top = (rect.top * iHeightMM * 100) / iHeightPels;
					rect.right = (rect.right * iWidthMM * 100) / iWidthPels;
					rect.bottom = (rect.bottom * iHeightMM * 100) / iHeightPels;

					/* hdcMeta = CreateEnhMetaFile(hdcRef, ofn.lpstrFile, &rect, "E_plot32\0exported picture\0\0"); */
					hdcMeta = CreateEnhMetaFile(hdcRef, ofn.lpstrFile, NULL, "E_plot32\0exported picture\0\0");
					G_pixel_ratio = 1.00;
                	fnMapModeOld = SetMapMode(hdcMeta, MM_LOENGLISH);
					j_paint_screen_elems(hdcMeta, TRUE);
					if (wDisplScale)
			    		j_drawscale(hdcMeta);
                	SetMapMode(hdcMeta, fnMapModeOld);
					G_pixel_ratio = -1.00;
					DeleteEnhMetaFile(CloseEnhMetaFile(hdcMeta));
					ReleaseDC(hwnd, hdcRef);
                    MessageBeep(0);
					w_OkMsgBox("The image has been saved to the file:\n%s", ofn.lpstrFileTitle);
                }
                else if ((strcmp(ofn.lpstrFileTitle+strlen(ofn.lpstrFileTitle)-4, ".wmf")==0)||
                		 (strcmp(ofn.lpstrFileTitle+strlen(ofn.lpstrFileTitle)-4, ".WMF")==0)  )
				{
                	G_pixel_ratio = 1.00;
                    hdcMeta = CreateMetaFile(ofn.lpstrFile);
                    j_paint_screen_elems(hdcMeta, TRUE);
					if (wDisplScale)
			    		j_drawscale(hdcMeta);
					DeleteMetaFile(CloseMetaFile(hdcMeta));
                    G_pixel_ratio = -1.00;
					MessageBeep(0);
					w_OkMsgBox("The image has been saved to the file:\n%s", ofn.lpstrFileTitle);
                }
                else
                {
                 	MessageBeep(0);
                    w_OkMsgBox("Don't know how to save in *%s format!",
                    		   ofn.lpstrFileTitle+strlen(ofn.lpstrFileTitle)-4);
                }
		    }
		    return (0);

		case IDM_P_AZIM_ELEV:
		case IDM_P_TCDIST_SCALE:
		case IDM_P_SCRORIGIN:
		case IDM_P_TARGETCOORDS:
		case IDM_P_TARGETELEV:
		case IDM_P_STRESSCOL:
		case IDM_P_ZETAADJUST:
		    CheckMenuItem(hMenu, wSelection, MF_UNCHECKED);
		    wSelection = wParam;
		    CheckMenuItem(hMenu, wSelection, MF_CHECKED);
		    return (0);
		case IDM_P_PLAN_VIEW:
            G_Xscrorigin = w_xmclient_size / 2;
	    	G_Yscrorigin = w_ymclient_size / 2;
			G_Target[XDIR] = w_dGlobCoordL + (w_dGlobCoordR - w_dGlobCoordL) / 2.00;
		    G_Target[YDIR] = w_dGlobCoordB + (w_dGlobCoordT - w_dGlobCoordB) / 2.00;
		    G_Target[ZDIR] = w_dGlobCoordD + (w_dGlobCoordU - w_dGlobCoordD) / 2.00;
		    G_Twist = 0.00;
		    G_Azim = 0.00;
		    G_Elev = M_PI / 2.00;
		    j_3Drecalc_rot_matrix();
		    G_dTC = w_maxsize * 20000.00;
		    G_scale = min((double) w_xmclient_size, (double) w_ymclient_size) * 0.90 / w_maxsize;
		    InvalidateRect(hwnd, NULL, TRUE);
		    break;
		case IDM_P_NICE_VIEW:
		    G_Xscrorigin = w_xmclient_size / 2;
	    	G_Yscrorigin = w_ymclient_size / 2;
			G_Target[XDIR] = w_dGlobCoordL + (w_dGlobCoordR - w_dGlobCoordL) / 2.00;
		    G_Target[YDIR] = w_dGlobCoordB + (w_dGlobCoordT - w_dGlobCoordB) / 2.00;
		    G_Target[ZDIR] = w_dGlobCoordD + (w_dGlobCoordU - w_dGlobCoordD) / 2.00;
		    G_Twist = 0.00;
		    G_Azim = INIT_AZIMUTH * M_PI / 180.00;
		    G_Elev = INIT_ELEVATION * M_PI / 180.00;
		    j_3Drecalc_rot_matrix();
		    G_scale = min((double) w_xmclient_size, (double) w_ymclient_size) * 0.80 / w_maxsize;
		    G_dTC = w_maxsize * 2.00;
		    InvalidateRect(hwnd, NULL, TRUE);
		    break;
		case IDM_P_HID_VIEW:
		    if (wHidden)
		    {
			CheckMenuItem(hMenu, wParam, MF_UNCHECKED);
			wHidden = FALSE;
		    }
		    else
		    {
				CheckMenuItem(hMenu, wParam, MF_CHECKED);
				wHidden = TRUE;
                if (wAdvHidden)
                {
                	CheckMenuItem(hMenu, IDM_P_ADV_HID_VIEW, MF_UNCHECKED);
                  wAdvHidden=FALSE;
                }
		    }
		    InvalidateRect(hwnd, NULL, FALSE);
		    return (0);
		    break;
        case IDM_P_ADV_HID_VIEW:
		    if (wAdvHidden)
		    {
				CheckMenuItem(hMenu, wParam, MF_UNCHECKED);
				wAdvHidden = FALSE;
		    }
		    else
		    {
				CheckMenuItem(hMenu, wParam, MF_CHECKED);
				wAdvHidden = TRUE;
                if (!AHl_once)
            	{
            		setup_hidden_line1(Npoly,polygons);
                	AHl_once=TRUE;
                }
            	if (wHidden)
               {
                	CheckMenuItem(hMenu, IDM_P_HID_VIEW, MF_UNCHECKED);
                  wHidden=FALSE;
               }
		    }
		    InvalidateRect(hwnd, NULL, FALSE);
		    return (0);
		    break;
        case IDM_P_ZOOM_TO:
		    DialogBox(G_hInst, MAKEINTRESOURCE(IDD_ZOOMTO), hwnd, lpfnZoomToDlgProc);
		    return (0);
        case IDM_P_GRAPHICSINFO:
		    DialogBox(G_hInst, MAKEINTRESOURCE(IDD_GRAPHICS_INFO), hwnd, lpfnGIDlgProc);
		    return (0);
		case IDM_PO_PLAINMESH:
		case IDM_PO_SUBDOMAIN:
		case IDM_PO_MESHPARAM:
		case IDM_PO_STRESS:
		case IDM_PO_ERROR:
		    if (wParam != wPlotSelect)
		    {
			switch (wParam)
			{
			    case IDM_PO_PLAINMESH:
					j_OK = TRUE;
					hMenuPopup = GetSubMenu(hMenu, NUM_PLOT_OPTION_POPUP);
					DeleteMenu(hMenuPopup, IDM_POO_SB, MF_BYCOMMAND);
                	DeleteMenu(hMenuPopup, IDM_POO_4COL, MF_BYCOMMAND);
                    CheckMenuItem(hMenu, IDM_D_DISPLSCALE, MF_UNCHECKED);
					EnableMenuItem(hMenu, IDM_D_DISPLSCALE, MF_GRAYED);
					wDisplScale = FALSE;
					EnableMenuItem(hMenu, IDM_P_ZETAADJUST, MF_GRAYED);
					if (wSelection == IDM_P_ZETAADJUST)
					{
				    	CheckMenuItem(hMenu, wSelection, MF_UNCHECKED);
				    	wSelection = IDM_P_AZIM_ELEV;
				    	CheckMenuItem(hMenu, wSelection, MF_CHECKED);
					}
				break;
			    case IDM_PO_SUBDOMAIN:
				j_OK = e_GetDecompData(fem1, G_file);
				if (j_OK)
				{
                    wSD4Cols=e_alloc_i_vect(fem1->Decomp.NSubDoms);
                    wSDGrDeg=e_alloc_i_vect(fem1->Decomp.NSubDoms);
                    wSDGraph=e_alloc_cont_i_matr(fem1->Decomp.NSubDoms, fem1->Decomp.NSubDoms);
                    wSDGrRef=e_alloc_cont_i_matr(fem1->Decomp.NSubDoms, fem1->Decomp.NSubDoms);
                    Create_Subdomain_Graph(fem1, wSDGrDeg, wSDGraph, wSDGrRef);
                    j_Det4Cols(wSD4Cols, wSDGraph, fem1->Decomp.NSubDoms);
                    e_free(wSDGrDeg);
                    e_free_cont_i_matr(fem1->Decomp.NSubDoms, wSDGraph);
					e_free_cont_i_matr(fem1->Decomp.NSubDoms, wSDGrRef);
				    CheckMenuItem(hMenu, IDM_D_DISPLSCALE, MF_UNCHECKED);
				    EnableMenuItem(hMenu, IDM_D_DISPLSCALE, MF_GRAYED);
				    wDisplScale = FALSE;
				    EnableMenuItem(hMenu, IDM_P_ZETAADJUST, MF_GRAYED);
				    hMenuPopup = GetSubMenu(hMenu, NUM_PLOT_OPTION_POPUP);
                    AppendMenu(hMenuPopup, MF_STRING | MF_ENABLED, IDM_POO_4COL, "&4 Colour SubDomains");
				    AppendMenu(hMenuPopup, MF_STRING | MF_ENABLED, IDM_POO_SD_BW, "Black and &White SubDomains");
				    if (wPlotSelect == IDM_PO_PLAINMESH)
					AppendMenu(hMenuPopup, MF_STRING | MF_ENABLED, IDM_POO_SB, "Show &Borders");
				    CheckMenuItem(hMenu, IDM_POO_SB, MF_CHECKED);
				    DrawMenuBar(hwnd);
				    w_iBW_subdomains = FALSE;
				    w_iSB = FALSE;
                    w4Col = FALSE;
				    if (wSelection == IDM_P_ZETAADJUST)
				    {
					CheckMenuItem(hMenu, wSelection, MF_UNCHECKED);
					wSelection = IDM_P_AZIM_ELEV;
					CheckMenuItem(hMenu, wSelection, MF_CHECKED);
				    }
				}
				break;
			    case IDM_PO_MESHPARAM:
				j_OK = e_GetMeshParams(fem1, G_file);
				if (j_OK)
				{
				    if (!fem1->MeshParam.ElemMeshParamsSet)
				    {
					e_FreeMeshParams(fem1);
					j_OK = FALSE;
					e_GeneralWarning("Please specify element mesh parameters");
					break;
				    }
				    w_maxmeshparam = j_getmaxmeshparam();
				    w_maxsidelength = j_getmaxsidelength(polygons,Npoly);
				    CheckMenuItem(hMenu, IDM_D_DISPLSCALE, MF_UNCHECKED);
				    EnableMenuItem(hMenu, IDM_D_DISPLSCALE, MF_ENABLED);
				    wDisplScale = FALSE;
				    EnableMenuItem(hMenu, IDM_P_ZETAADJUST, MF_ENABLED);
				    hMenuPopup = GetSubMenu(hMenu, NUM_PLOT_OPTION_POPUP);
				    if (wPlotSelect == IDM_PO_PLAINMESH)
						AppendMenu(hMenuPopup, MF_STRING | MF_ENABLED, IDM_POO_SB, "Show &Borders");
				    CheckMenuItem(hMenu, IDM_POO_SB, MF_CHECKED);
				    DrawMenuBar(hwnd);
				    w_iSB = FALSE;
				}
				break;
			    case IDM_PO_ERROR:
				j_OK = e_GetFEErrors(fem1, G_file);
				if (j_OK)
				{
				    w_maxerror = j_getmaxerror();
				    CheckMenuItem(hMenu, IDM_D_DISPLSCALE, MF_UNCHECKED);
				    EnableMenuItem(hMenu, IDM_D_DISPLSCALE, MF_ENABLED);
				    wDisplScale = FALSE;
				    EnableMenuItem(hMenu, IDM_P_ZETAADJUST, MF_ENABLED);
				    hMenuPopup = GetSubMenu(hMenu, NUM_PLOT_OPTION_POPUP);
				    if (wPlotSelect == IDM_PO_PLAINMESH)
					AppendMenu(hMenuPopup, MF_STRING | MF_ENABLED, IDM_POO_SB, "Show &Borders");
				    CheckMenuItem(hMenu, IDM_POO_SB, MF_CHECKED);
				    DrawMenuBar(hwnd);
				    w_iSB = FALSE;
				}
				break;
			    case IDM_PO_STRESS:
				j_OK = e_GetStresses(fem1, G_file);
				if (j_OK)
				{
				    j_getmaxstresses();
				    CheckMenuItem(hMenu, IDM_D_DISPLSCALE, MF_UNCHECKED);
				    EnableMenuItem(hMenu, IDM_D_DISPLSCALE, MF_ENABLED);
				    wDisplScale = FALSE;
				    hMenuPopup = GetSubMenu(hMenu, NUM_PLOT_OPTION_POPUP);
				    AppendMenu(hMenuPopup, MF_STRING | MF_ENABLED | MF_CHECKED, IDM_POO_XXSTRESS, "Sigma &X");
				    AppendMenu(hMenuPopup, MF_STRING | MF_ENABLED, IDM_POO_YYSTRESS, "Sigma &Y");
				    AppendMenu(hMenuPopup, MF_STRING | MF_ENABLED, IDM_POO_XYSTRESS, "Ta&u XY");
				    AppendMenu(hMenuPopup, MF_STRING | MF_ENABLED, IDM_POO_SP_SEL, "Se&lect StressPoints");
				    w_iWhichStress = IDM_POO_XXSTRESS;
				    j_setup_stresspoints();
				    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG2])
						w_iWhichLayer = 0;
				    EnableMenuItem(hMenu, IDM_P_STRESSCOL, MF_ENABLED);
				    w_maxStress_percent = 100.00;
				    EnableMenuItem(hMenu, IDM_P_ZETAADJUST, MF_ENABLED);
				    if (wPlotSelect == IDM_PO_PLAINMESH)
						AppendMenu(hMenuPopup, MF_STRING | MF_ENABLED, IDM_POO_SB, "Show &Borders");
				    CheckMenuItem(hMenu, IDM_POO_SB, MF_CHECKED);
				    DrawMenuBar(hwnd);
				    w_iSB = FALSE;
				}
				break;
			}
			if (j_OK)
			{
			    switch (wPlotSelect)
			    {
				case IDM_PO_SUBDOMAIN:
				    e_FreeDecompData(fem1);
                    e_free(wSD4Cols);
				    hMenuPopup = GetSubMenu(hMenu, NUM_PLOT_OPTION_POPUP);
                    DeleteMenu(hMenuPopup, IDM_POO_4COL, MF_BYCOMMAND);
				    DeleteMenu(hMenuPopup, IDM_POO_SD_BW, MF_BYCOMMAND);
				    DrawMenuBar(hwnd);
                    w_iBW_subdomains = FALSE;
				    break;
				case IDM_PO_MESHPARAM:
				    e_FreeMeshParams(fem1);
				    hMenuPopup = GetSubMenu(hMenu, NUM_PLOT_OPTION_POPUP);
				    DrawMenuBar(hwnd);
				    break;
				case IDM_PO_ERROR:
				    e_FreeFEErrors(fem1);
				    hMenuPopup = GetSubMenu(hMenu, NUM_PLOT_OPTION_POPUP);
				    DrawMenuBar(hwnd);
				    break;
				case IDM_PO_STRESS:
				    e_FreeStresses(fem1);
				    hMenuPopup = GetSubMenu(hMenu, NUM_PLOT_OPTION_POPUP);
				    DeleteMenu(hMenuPopup, IDM_POO_XXSTRESS, MF_BYCOMMAND);
				    DeleteMenu(hMenuPopup, IDM_POO_YYSTRESS, MF_BYCOMMAND);
				    DeleteMenu(hMenuPopup, IDM_POO_XYSTRESS, MF_BYCOMMAND);
				    DeleteMenu(hMenuPopup, IDM_POO_SP_SEL, MF_BYCOMMAND);
				    DrawMenuBar(hwnd);
				    EnableMenuItem(hMenu, IDM_P_STRESSCOL, MF_GRAYED);
				    if (wSelection == IDM_P_STRESSCOL)
				    {
					CheckMenuItem(hMenu, wSelection, MF_UNCHECKED);
					wSelection = IDM_P_AZIM_ELEV;
					CheckMenuItem(hMenu, wSelection, MF_CHECKED);
				    }
				    break;
			    }
			    CheckMenuItem(hMenu, wPlotSelect, MF_UNCHECKED);
			    wPlotSelect = wParam;
			    CheckMenuItem(hMenu, wPlotSelect, MF_CHECKED);
			    InvalidateRect(hwnd, NULL, FALSE);
			}

		    }
		    return (0);
		case IDM_POO_SP_SEL:
		    DialogBox(G_hInst, MAKEINTRESOURCE(IDD_SP_SEL), hwnd, lpfnSpSelDlgProc);
		    return (0);
		case IDM_POO_XXSTRESS:
		case IDM_POO_YYSTRESS:
		case IDM_POO_XYSTRESS:
		    if (wParam != w_iWhichStress)
		    {
			CheckMenuItem(hMenu, w_iWhichStress, MF_UNCHECKED);
			w_iWhichStress = wParam;
			CheckMenuItem(hMenu, w_iWhichStress, MF_CHECKED);
			InvalidateRect(hwnd, NULL, FALSE);
		    }
		    return (0);
		case IDM_POO_SD_BW:
		    if (w_iBW_subdomains)
		    {
			CheckMenuItem(hMenu, wParam, MF_UNCHECKED);
			w_iBW_subdomains = FALSE;
		    }
		    else
		    {
			CheckMenuItem(hMenu, wParam, MF_CHECKED);
			w_iBW_subdomains = TRUE;
		    }
		    InvalidateRect(hwnd, NULL, FALSE);
		    return (0);
		case IDM_POO_SB:
		    if (w_iSB)
		    {
			CheckMenuItem(hMenu, wParam, MF_CHECKED);
			w_iSB = FALSE;
		    }
		    else
		    {
			CheckMenuItem(hMenu, wParam, MF_UNCHECKED);
			w_iSB = TRUE;
		    }
		    InvalidateRect(hwnd, NULL, FALSE);
		    return (0);
		case IDM_POO_4COL:
        	if (w4Col)
            {
            	CheckMenuItem(hMenu, wParam, MF_UNCHECKED);
                w4Col=FALSE;
            }
            else
            {
            	CheckMenuItem(hMenu, wParam, MF_CHECKED);
                w4Col=TRUE;
            }
		    InvalidateRect(hwnd, NULL, FALSE);
		    return (0);

	    }
	    break;



	case WM_LBUTTONDOWN:
	    if (!wOpenFile)
		return (0);
	    if (!w_fCapturing)
	    {
		w_fCapturing = TRUE;
		SetCapture(hwnd);
		switch (wSelection)
		{
		    case IDM_P_AZIM_ELEV:
		    case IDM_P_TCDIST_SCALE:
		    case IDM_P_SCRORIGIN:
		    case IDM_P_TARGETCOORDS:
			SetCursor(LoadCursor(NULL, IDC_SIZE));
			break;

		    case IDM_P_TARGETELEV:
		    case IDM_P_STRESSCOL:
		    case IDM_P_ZETAADJUST:
			SetCursor(LoadCursor(NULL, IDC_SIZENS));
			break;

		}
		ptBeg = MAKEPOINTS(lParam);
	    }
	    return 0;

	case WM_MOUSEMOVE:
	    if (w_fCapturing)
	    {
		ptEnd = MAKEPOINTS(lParam);
		hdc = GetDC(hwnd);

		xdifpix = ptEnd.x - ptBeg.x;
		ydifpix = ptEnd.y - ptBeg.y;
		switch (wSelection)
		{
		    case IDM_P_AZIM_ELEV:
			G_Azim -= (double) xdifpix *j3D_AZIMUTH_INCREMENT / 180.00 * M_PI;
			G_Elev += (double) ydifpix *j3D_ELEVATION_INCREMENT / 180.00 * M_PI;
			j_3Drecalc_rot_matrix();
			break;
		    case IDM_P_TCDIST_SCALE:
			G_dTC *= 1.00 + (double) xdifpix *j3D_DISTANCE_MULTIPLIER / 100.00;
			G_scale *= 1.00 - (double) ydifpix *j3D_SCALEFACT_MULTIPLIER / 100.00;
			break;
		    case IDM_P_SCRORIGIN:
			G_Xscrorigin += xdifpix;
			G_Yscrorigin += ydifpix;
			break;
		    case IDM_P_TARGETCOORDS:
			G_Target[XDIR] -= (double) xdifpix / 10.00 * 0.05 * (w_dGlobCoordR - w_dGlobCoordL);
			G_Target[YDIR] += (double) ydifpix / 10.00 * 0.05 * (w_dGlobCoordT - w_dGlobCoordB);
			break;
		    case IDM_P_TARGETELEV:
			G_Target[ZDIR] -= (double) ydifpix / 10.00 * 0.05 * (w_dGlobCoordU - w_dGlobCoordD);
			break;
		    case IDM_P_STRESSCOL:
			w_maxStress_percent -= (double) ydifpix *j3D_STRESSCOL_PC_INCREMENT;
			if (w_maxStress_percent > 100.00)
			    w_maxStress_percent = 100.00;
			if (w_maxStress_percent < 1.00)
			    w_maxStress_percent = 1.00;
			break;
		    case IDM_P_ZETAADJUST:
			wZeta -= (double) ydifpix *j3D_ZETA_INCREMENT;
			if (wZeta > 2.00)
			    wZeta = 2.00;
			if (wZeta < 0.00)
			    wZeta = 0.00;
			break;
		}
		if (wSelection == IDM_P_STRESSCOL || wSelection == IDM_P_ZETAADJUST)
		{
		    holdbrush = (HBRUSH) SelectObject(hdc, GetStockObject(DKGRAY_BRUSH));
		    PatBlt(hdc, 0, 0, w_xmclient_size, w_ymclient_size, PATCOPY);
		    SelectObject(hdc, holdbrush);
		}
		else
		    PatBlt(hdc, 0, 0, w_xmclient_size, w_ymclient_size, BLACKNESS);
		if (wSelection == IDM_P_STRESSCOL)
		    j_drawscale(hdc);
		else
		{
		    if (wSelection == IDM_P_ZETAADJUST)
			j_drawZetascale(hdc);
		    else
			j_paintsimple_3Dfigure(hdc, wSelection);
		}

		ReleaseDC(hwnd, hdc);
		ptBeg.x = ptEnd.x;
		ptBeg.y = ptEnd.y;
	    }
	    return 0;

	case WM_LBUTTONUP:
	    if (w_fCapturing)
	    {
		w_fCapturing = FALSE;
		InvalidateRect(hwnd, NULL, FALSE);
		SetCursor(LoadCursor(NULL, IDC_ARROW));
		ReleaseCapture();
	    }
	    return 0;

	case WM_CLOSE:
	    if (IDCANCEL == w_OkCancelStopMsgBox("Are you sure you want to quit?"))
		return (0);
	    else
		break;
	case WM_DESTROY:
	    PostQuitMessage(0);
	    return (0);
    }				/* switch -message- */

    return DefWindowProc(hwnd, message, wParam, lParam);

}				/* end of window procedure j_main_wndproc()  */











void            j_init_perspective(void)

{
    register        i;
    /* calculate extreme nodes for stress window display  */
    w_dGlobCoordB = fem1->MeshPointCoords[0][YDIR];
    w_dGlobCoordT = fem1->MeshPointCoords[0][YDIR];
    w_dGlobCoordL = fem1->MeshPointCoords[0][XDIR];
    w_dGlobCoordR = fem1->MeshPointCoords[0][XDIR];
    w_dGlobCoordU = fem1->MeshPointCoords[0][ZDIR];
    w_dGlobCoordD = fem1->MeshPointCoords[0][ZDIR];
    for (i = 1; i < fem1->NMeshPoints; i++)
    {
	if (w_dGlobCoordT < fem1->MeshPointCoords[i][YDIR])
	    w_dGlobCoordT = fem1->MeshPointCoords[i][YDIR];
	if (w_dGlobCoordB > fem1->MeshPointCoords[i][YDIR])
	    w_dGlobCoordB = fem1->MeshPointCoords[i][YDIR];
	if (w_dGlobCoordR < fem1->MeshPointCoords[i][XDIR])
	    w_dGlobCoordR = fem1->MeshPointCoords[i][XDIR];
	if (w_dGlobCoordL > fem1->MeshPointCoords[i][XDIR])
	    w_dGlobCoordL = fem1->MeshPointCoords[i][XDIR];
	if (w_dGlobCoordU < fem1->MeshPointCoords[i][ZDIR])
	    w_dGlobCoordU = fem1->MeshPointCoords[i][ZDIR];
	if (w_dGlobCoordD > fem1->MeshPointCoords[i][ZDIR])
	    w_dGlobCoordD = fem1->MeshPointCoords[i][ZDIR];
    }



    G_Target[XDIR] = w_dGlobCoordL + (w_dGlobCoordR - w_dGlobCoordL) / 2.00;
    G_Target[YDIR] = w_dGlobCoordB + (w_dGlobCoordT - w_dGlobCoordB) / 2.00;
    G_Target[ZDIR] = w_dGlobCoordD + (w_dGlobCoordU - w_dGlobCoordD) / 2.00;;
    G_Twist = 0.00;
    G_Azim = INIT_AZIMUTH * M_PI / 180.00;
    G_Elev = INIT_ELEVATION * M_PI / 180.00;

    j_3Drecalc_rot_matrix();

    w_maxsize = max((w_dGlobCoordR - w_dGlobCoordL), (w_dGlobCoordT - w_dGlobCoordB));
    w_maxsize = max(w_maxsize, (w_dGlobCoordU - w_dGlobCoordD));
    G_scale = G_initscale = ((double) y_screen_size) / 2.00 / w_maxsize;
    G_dTC = 2.00 * w_maxsize;
    G_pixel_ratio = -1.00;

    OO[XDIR] = 0.00;
    OO[YDIR] = 0.00;
    OO[ZDIR] = 0.00;
    OX[XDIR] = w_maxsize / 2.00;
    OX[YDIR] = 0.00;
    OX[ZDIR] = 0.00;
    OY[XDIR] = 0.00;
    OY[YDIR] = w_maxsize / 2.00;
    OY[ZDIR] = 0.00;
    OZ[XDIR] = 0.00;
    OZ[YDIR] = 0.00;
    OZ[ZDIR] = w_maxsize / 2.00;


    wZeta = INIT_ZETA;
    w_displmag = INIT_DISP_MAGN;



}				/* end of function init_perspective()  */


int             w_OkMsgBox(char *szFmt,...)

{
    char            temp_buf[1024];
    va_list        *pArg;

    va_start(pArg, szFmt);
    vsprintf(temp_buf, szFmt, pArg);
    return (MessageBox(G_main_hwnd, temp_buf, szAppName, MB_OK | MB_ICONEXCLAMATION));

}


int             w_OkCancelStopMsgBox(char *szFmt,...)

{
    char            temp_buf[1024];
    va_list        *pArg;

    va_start(pArg, szFmt);
    vsprintf(temp_buf, szFmt, pArg);
    return (MessageBox(G_main_hwnd, temp_buf, szAppName, MB_OKCANCEL | MB_ICONSTOP));

}



int             w_OkCancelMsgBox(char *szFmt,...)

{
    char            temp_buf[1024];
    va_list        *pArg;

    va_start(pArg, szFmt);
    vsprintf(temp_buf, szFmt, pArg);
    return (MessageBox(G_main_hwnd, temp_buf, szAppName, MB_OKCANCEL | MB_ICONEXCLAMATION));

}




int             w_OkStopMsgBox(char *szFmt,...)

{
    char            temp_buf[1024];
    va_list        *pArg;

    va_start(pArg, szFmt);
    vsprintf(temp_buf, szFmt, pArg);
    return (MessageBox(G_main_hwnd, temp_buf, szAppName, MB_OK | MB_ICONSTOP));

}





/********************************************************************/
/* direct printing facility implemented by Jelle                    */
/********************************************************************/

HDC             GetCurrentPrinterDC(void)
{
    HDC             phdc = NULL;

    if (hDevNames)
    {
	LPDEVNAMES      lpdn = (LPDEVNAMES) GlobalLock(hDevNames);
	LPDEVMODE       lpdm = NULL;

	if (hDevMode)
	    lpdm = (LPDEVMODE) GlobalLock(hDevMode);

	phdc = CreateDC((LPSTR) lpdn + lpdn->wDriverOffset,
			(LPSTR) lpdn + lpdn->wDeviceOffset,
			(LPSTR) lpdn + lpdn->wOutputOffset,
			lpdm);
    }
    else
    {
	PRINTDLG        pd = {0};

	if (hDevMode)
	    GlobalFree(hDevMode);

	pd.lStructSize = sizeof(pd);
	pd.hwndOwner = NULL;
	pd.Flags = PD_RETURNDEFAULT | PD_RETURNDC;

	if (PrintDlg(&pd))
	{
	    hDevMode = pd.hDevMode;
	    hDevNames = pd.hDevNames;
	    phdc = pd.hDC;
	}
    }

    return phdc;
}

BOOL FAR PASCAL _export AbortProc(HDC hdcPrn, short nCode)
{
    MSG             msg;

    while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
    {
	TranslateMessage(&msg);
	DispatchMessage(&msg);
    }
    return TRUE;
}

BOOL            j_print_page(HWND hwnd)
{
    static char     szMessage[] = "E-plot is Printing";
    BOOL            bError = FALSE;
    FARPROC         lpfnAbortProc;
    HDC             hdcMem;
    HDC             hdcPrn;
    short           xPage, yPage;
    double          oldscale = G_scale;
    double          oldinitscale = G_initscale;
    double          oldxsrc = G_Xscrorigin;
    double          oldysrc = G_Yscrorigin;
    int             offset, size;


    if (NULL == (hdcPrn = GetCurrentPrinterDC()))
	return TRUE;

    xPage = GetDeviceCaps(hdcPrn, HORZRES);
    yPage = GetDeviceCaps(hdcPrn, VERTRES);

    //hdcMem = CreateCompatibleDC(hdcPrn);

    EnableWindow(hwnd, FALSE);

    lpfnAbortProc = MakeProcInstance((FARPROC) AbortProc, G_hInst);
    Escape(hdcPrn, SETABORTPROC, 0, (LPSTR) lpfnAbortProc, NULL);

    if (Escape(hdcPrn, STARTDOC, sizeof szMessage - 1, szMessage, NULL) > 0)
    {
	G_Xscrorigin = xPage / 2;
	G_Yscrorigin = yPage / 2;
	if (((double) w_xmclient_size / (double) y_screen_size) > ((double) xPage / (double) yPage))
	{
	    G_scale = G_scale * (double) xPage / (double) w_xmclient_size;
	    G_initscale = G_initscale * (double) xPage / (double) w_xmclient_size;
	    offset = (int) ((double) w_ymclient_size * (double) xPage / (double) w_xmclient_size);
	    offset = (yPage - offset);
	    if (offset % 2 == 1)
		offset += 1;
	    offset = offset / 2;
	    size = (int) ((double) w_ymclient_size * (double) xPage / (double) w_xmclient_size);
	    //BitBlt(hdcMem, 0, 0, xPage, yPage, NULL, 0, 0, WHITENESS);
	    Rectangle(hdcPrn, 0, offset, xPage, offset + size);
	    //j_paintwindow_3Dfigure(hdcPrn, TRUE);
	    j_paint_screen_elems(hdcPrn, TRUE);
	    //SetViewportOrg(hdcMem, 0, 0);
	    //BitBlt(hdcPrn, 0, offset, xPage, size,
		     //hdcMem, 0, 0, SRCCOPY);
	}
	else
	{
	    G_scale = G_scale * (double) yPage / (double) w_ymclient_size;
	    G_initscale = G_initscale * (double) yPage / (double) w_ymclient_size;
	    offset = (int) ((double) w_xmclient_size * (double) yPage / (double) w_ymclient_size);
	    offset = (xPage - offset);
	    if (offset % 2 == 1)
		offset += 1;
	    offset = offset / 2;
	    size = (int) ((double) w_xmclient_size * (double) yPage / (double) w_ymclient_size);
	    //BitBlt(hdcMem, 0, 0, xPage, yPage, NULL, 0, 0, WHITENESS);
	    Rectangle(hdcPrn, offset, 0, offset + size, yPage);
	    //j_paintwindow_3Dfigure(hdcPrn, TRUE);
	    j_paint_screen_elems(hdcPrn, TRUE);
	    //SetViewportOrg(hdcMem, 0, 0);
	    //BitBlt(hdcPrn, offset, 0, size, yPage,
		     //hdcMem, 0, 0, SRCCOPY);
	}
	G_scale = oldscale;
	G_initscale = oldinitscale;
	G_Xscrorigin = oldxsrc;
	G_Yscrorigin = oldysrc;
	if (Escape(hdcPrn, NEWFRAME, 0, NULL, NULL) > 0)
	    Escape(hdcPrn, ENDDOC, 0, NULL, NULL);
	else
	    bError = TRUE;
    }
    else
	bError = TRUE;

    if (!bError)
	Escape(hdcPrn, ENDDOC, 0, NULL, NULL);

    FreeProcInstance(lpfnAbortProc);
    EnableWindow(hwnd, TRUE);
    //DeleteDC(hdcMem);
    DeleteDC(hdcPrn);

    return bError;
}

/********************************************************************/

void            j_paint_screen_elems(HDC hdc, int wmfexp)
{
    int             isubdom;
    double          dmeshparam, derror, dstress, dmaxstress;
    int             ste_index, pos_r_max, pos_g_max, pos_b_max, neg_r_max,
                    neg_g_max, neg_b_max;
    int             r, g, b;
    HPEN            hgp, hop;
    HBRUSH          hgb, hob;
    POINT           triang[3], tetrah[4], quad[4];
    j_3Dvector      vnode1, vnode2, vnode3, tri_cent;
    j_3Dvector      mnode1, mnode2, mnode3;
    j_3Dvector      scrvnode1, scrvnode2, scrvnode3, scrtri_cent;
    DWORD           elem_colour;
    HBRUSH          hcolbrush, holdbrush;
    LOGBRUSH		lgbr;
    short           nLength;
    char            szBuffer[80];
    double          col;
    int            	p, i, e, s, node;
    register        n;
	double			oldG_scale;
    double			minlength;

    int 			*order;

    lgbr.lbStyle=BS_SOLID;
    lgbr.lbHatch=0;

/*    if (wmfexp)
    {
		oldG_scale=G_scale;
        minlength=j_getminsidelength();
        if (minlength>1e-6)
        {
        	G_scale*=100/minlength;
        }
        else
        {
        	G_scale*=100;
        }
        j_3Drecalc_rot_matrix;
    } */

/*    if (wmfexp)
    {
    	G_scale=oldG_scale;
        j_3Drecalc_rot_matrix;
    } */

    j_do_projection(polygons,Npoly);
    order=e_alloc_i_vect(Npoly);

    if (wAdvHidden)
    {
    	setup_hidden_line2(Npoly,polygons);
		setup_proj_center(G_Azim, G_Elev, G_dTC, G_Target);
		if (!sort_objects(order, Npoly, polygons, 0))
	    	if (!sort_objects(order, Npoly, polygons, 1))
	    	{
	    		e_GeneralWarning("advanced sorting failed");
				for (p=0;p<Npoly;p++)
	    	    	order[p]=p;
	    	}
    }
    else
    {
    	for (p=0;p<Npoly;p++)
	    	order[p]=p;
    	if (wHidden)
	    	j_sort_polygons(order,polygons,Npoly);
    }

    if (wDisplElemNo)
    {
        if (wmfexp)
        {
            SetTextColor(hdc, BLACK);
            SetBkColor(hdc, WHITE);
        }
        else
        {
            SetTextColor(hdc, SKY_BLUE);
            SetBkColor(hdc, BLACK);
        }
    }

    for (e = 0; e < Npoly; e++)
    {
        p=order[e];

        if (!polygons[p].vis)
            continue;
		if (wClipPlane)
            if (polygons[p].z>0.0)
            	continue;
        if ((polygons[p].elem_type == E_ELEM_TYPE_LINK1) ||
            (polygons[p].elem_type == E_ELEM_TYPE_LINK2) ||
            (polygons[p].elem_type == E_ELEM_TYPE_LINK3) ||
            (polygons[p].elem_type == E_ELEM_TYPE_LINK4) ||
            (polygons[p].elem_type == E_ELEM_TYPE_LINK5))
    	{
            if (wPlotSelect == IDM_PO_SUBDOMAIN)
            {
                    if (polygons[p].elem_type == E_ELEM_TYPE_LINK1)
                        isubdom = fem1->Decomp.SubDomsLink1[polygons[p].mesh_index];
                    else if (polygons[p].elem_type == E_ELEM_TYPE_LINK2)
                        isubdom = fem1->Decomp.SubDomsLink2[polygons[p].mesh_index];
                    else if (polygons[p].elem_type == E_ELEM_TYPE_LINK3)
                        isubdom = fem1->Decomp.SubDomsLink3[polygons[p].mesh_index];
                    else if (polygons[p].elem_type == E_ELEM_TYPE_LINK4)
                        isubdom = fem1->Decomp.SubDomsLink4[polygons[p].mesh_index];
                    else if (polygons[p].elem_type == E_ELEM_TYPE_LINK5)
                        isubdom = fem1->Decomp.SubDomsLink5[polygons[p].mesh_index];

                    if (w_iBW_subdomains)
                        elem_colour = wSubdomBWColours[(isubdom - 1)%MAX_ASSUMED_SUBDOMS_FOR_COLOURS];
                    else
                    	if (w4Col)
                            elem_colour = wSubdom4Col[wSD4Cols[isubdom-1]];
                        else
                        	elem_colour = wSubdomColours[(isubdom - 1)%MAX_ASSUMED_SUBDOMS_FOR_COLOURS];
                    hgp = CreatePen(PS_SOLID, 2, elem_colour);
                }
                else if (wPlotSelect == IDM_PO_MESHPARAM)
                {
                    if (polygons[p].elem_type == E_ELEM_TYPE_LINK1)
                        dmeshparam = fem1->MeshParam.ElemMeshParamsLink1[polygons[p].mesh_index];
                    else if (polygons[p].elem_type == E_ELEM_TYPE_LINK2)
                        dmeshparam = fem1->MeshParam.ElemMeshParamsLink2[polygons[p].mesh_index];
                    else if (polygons[p].elem_type == E_ELEM_TYPE_LINK3)
                        dmeshparam = fem1->MeshParam.ElemMeshParamsLink3[polygons[p].mesh_index];
                    else if (polygons[p].elem_type == E_ELEM_TYPE_LINK4)
                        dmeshparam = fem1->MeshParam.ElemMeshParamsLink4[polygons[p].mesh_index];
                    else if (polygons[p].elem_type == E_ELEM_TYPE_LINK5)
                        dmeshparam = fem1->MeshParam.ElemMeshParamsLink5[polygons[p].mesh_index];

                    if (dmeshparam / polygons[p].avsl <= 1.00)
                    {
                        col = j_col_scale(1.00 - (dmeshparam / polygons[p].avsl), wZeta);
                        r = (int) ((double) MP_R_MAX * col);
                        g = (int) ((double) MP_G_MAX * col);
                        b = (int) ((double) MP_B_MAX * col);
                    }
                    else
                    {
                        r = (int) ((double) 0x00);
                        g = (int) ((double) 0x00);
                        b = (int) ((double) 0x00);
                    }
                    elem_colour = RGB(r, g, b);
                    hgp = CreatePen(PS_SOLID, 2, elem_colour);
                }
                else if (wPlotSelect == IDM_PO_ERROR)
                {
                    if (polygons[p].elem_type == E_ELEM_TYPE_LINK1)
                        derror = fem1->FEError.FEErrorsLink1[polygons[p].mesh_index];
                    else if (polygons[p].elem_type == E_ELEM_TYPE_LINK2)
                        derror = fem1->FEError.FEErrorsLink2[polygons[p].mesh_index];
                    else if (polygons[p].elem_type == E_ELEM_TYPE_LINK3)
                        derror = fem1->FEError.FEErrorsLink3[polygons[p].mesh_index];
                    else if (polygons[p].elem_type == E_ELEM_TYPE_LINK4)
                        derror = fem1->FEError.FEErrorsLink4[polygons[p].mesh_index];
                    else if (polygons[p].elem_type == E_ELEM_TYPE_LINK5)
                        derror = fem1->FEError.FEErrorsLink5[polygons[p].mesh_index];

                    if (derror <= w_maxerror)
                    {
                        col = j_col_scale(derror / w_maxerror, wZeta);
                        r = (int) ((double) ER_R_MAX * col);
                        g = (int) ((double) ER_G_MAX * col);
                        b = (int) ((double) ER_B_MAX * col);
                    }
                    else
                    {
                        r = ER_R_MAX;
                        g = ER_G_MAX;
                        b = ER_B_MAX;
                    }
                    elem_colour = RGB(r, g, b);
                    hgp = CreatePen(PS_SOLID, 2, elem_colour);
                }
                else if (wPlotSelect == IDM_PO_STRESS)
                {
                    switch (w_iWhichStress)
                    {
                        case IDM_POO_XXSTRESS:
                            ste_index = E_SIGMA_X;
                            dmaxstress = w_maxXstress;
                            pos_r_max = STE_XX_POS_R_MAX;
                            pos_g_max = STE_XX_POS_G_MAX;
                            pos_b_max = STE_XX_POS_B_MAX;
                            neg_r_max = STE_XX_NEG_R_MAX;
                            neg_g_max = STE_XX_NEG_G_MAX;
                            neg_b_max = STE_XX_NEG_B_MAX;
                            break;
                        case IDM_POO_YYSTRESS:
                            ste_index = E_SIGMA_Y;
                            dmaxstress = w_maxYstress;
                            pos_r_max = STE_YY_POS_R_MAX;
                            pos_g_max = STE_YY_POS_G_MAX;
                            pos_b_max = STE_YY_POS_B_MAX;
                            neg_r_max = STE_YY_NEG_R_MAX;
                            neg_g_max = STE_YY_NEG_G_MAX;
                            neg_b_max = STE_YY_NEG_B_MAX;
                            break;
                        case IDM_POO_XYSTRESS:
                            ste_index = E_TAU_XY;
                            dmaxstress = w_maxXYstress;
                            pos_r_max = STE_XY_POS_R_MAX;
                            pos_g_max = STE_XY_POS_G_MAX;
                            pos_b_max = STE_XY_POS_B_MAX;
                            neg_r_max = STE_XY_NEG_R_MAX;
                            neg_g_max = STE_XY_NEG_G_MAX;
                            neg_b_max = STE_XY_NEG_B_MAX;
                            break;
                    }
                    if (polygons[p].elem_type == E_ELEM_TYPE_LINK1)
                        dstress = fem1->Stresses.StressesLink1[polygons[p].mesh_index][w_iWhichStressPoint[E_ELEM_TYPE_LINK1]][ste_index];
                    else if (polygons[p].elem_type == E_ELEM_TYPE_LINK2)
                        dstress = fem1->Stresses.StressesLink2[polygons[p].mesh_index][w_iWhichStressPoint[E_ELEM_TYPE_LINK2]][ste_index];
                    else if (polygons[p].elem_type == E_ELEM_TYPE_LINK3)
                        dstress = fem1->Stresses.StressesLink3[polygons[p].mesh_index][w_iWhichStressPoint[E_ELEM_TYPE_LINK3]][ste_index];
                    else if (polygons[p].elem_type == E_ELEM_TYPE_LINK4)
                        dstress = fem1->Stresses.StressesLink4[polygons[p].mesh_index][w_iWhichStressPoint[E_ELEM_TYPE_LINK4]][ste_index];
                    else if (polygons[p].elem_type == E_ELEM_TYPE_LINK5)
                        dstress = fem1->Stresses.StressesLink5[polygons[p].mesh_index][w_iWhichStressPoint[E_ELEM_TYPE_LINK5]][ste_index];

                    if (dmaxstress!=0.00)
                		dstress /= dmaxstress * w_maxStress_percent / 100.00;
                    if (dstress >= 0.00)
                        if (dstress <= 1.00)
                        {
                            col = j_col_scale(dstress, wZeta);
                            r = (int) ((double) pos_r_max * col);
                            g = (int) ((double) pos_g_max * col);
                            b = (int) ((double) pos_b_max * col);
                        }
                        else
                        {
                            r = pos_r_max;
                            g = pos_g_max;
                            b = pos_b_max;
                        }
                    else if (dstress >= -1.00)
                    {
                        col = j_col_scale(fabs(dstress), wZeta);
                        r = (int) ((double) neg_r_max * col);
                        g = (int) ((double) neg_g_max * col);
                        b = (int) ((double) neg_b_max * col);
                    }
                    else
                    {
                        r = neg_r_max;
                        g = neg_g_max;
                        b = neg_b_max;
                    }
                    elem_colour = RGB(r, g, b);
                    hgp = CreatePen(PS_SOLID, 2, elem_colour);
                }
                else            /* if(wPlotSelect == IDM_PO_PLAINMESH) */
                {
                    if (wTileElems)
                    {
                        if (polygons[p].elem_type == E_ELEM_TYPE_LINK1)
                            hgp = CreatePen(PS_SOLID, 2, YELLOW);
                        else if (polygons[p].elem_type == E_ELEM_TYPE_LINK2)
                            hgp = CreatePen(PS_SOLID, 2, SKY_BLUE);
                        else if (polygons[p].elem_type == E_ELEM_TYPE_LINK3)
                            hgp = CreatePen(PS_SOLID, 2, RGB(255, 0, 0));
                        else if (polygons[p].elem_type == E_ELEM_TYPE_LINK4)
                            hgp = CreatePen(PS_SOLID, 2, RGB(0, 0, 255));
                        else if (polygons[p].elem_type == E_ELEM_TYPE_LINK5)
                            hgp = CreatePen(PS_SOLID, 2, GREEN);
                    }
                    else
                        hgp = CreatePen(PS_SOLID, 2, YELLOW);
                }
            hop=SelectObject(hdc, hgp);
            MoveTo(hdc, (short)(polygons[p].screen_coords[0][0]),(short)(polygons[p].screen_coords[0][1]));
            LineTo(hdc, (short)(polygons[p].screen_coords[1][0]),(short)(polygons[p].screen_coords[1][1]));
            SelectObject(hdc, hop);
            DeleteObject(hgp);
            if (wDisplElemNo)
            {
                SetTextAlign(hdc, TA_CENTER | TA_BASELINE);
                nLength = sprintf(szBuffer, "%d", polygons[p].mesh_index + 1);
                TextOut(hdc,
                	(short)((polygons[p].screen_coords[0][0]+polygons[p].screen_coords[1][0])/2.0),
		    		(short)((polygons[p].screen_coords[0][1]+polygons[p].screen_coords[1][1])/2.0),
                    szBuffer, nLength);
            }
        }
        else if ((polygons[p].elem_type == E_ELEM_TYPE_TRIANG1) ||
                 (polygons[p].elem_type == E_ELEM_TYPE_TRIANG2) ||
                 (polygons[p].elem_type == E_ELEM_TYPE_TRIANG3) ||
                 (polygons[p].elem_type == E_ELEM_TYPE_TRIANG4) ||
                 (polygons[p].elem_type == E_ELEM_TYPE_TRIANG5) ||
                 (polygons[p].elem_type == E_ELEM_TYPE_TETRAH1))
        {
            if (wPlotSelect == IDM_PO_PLAINMESH)
            {
                if ((!wHidden)&&(!wAdvHidden))
                {
                    hgb = (HBRUSH) GetStockObject(HOLLOW_BRUSH);
                    hob = SelectObject(hdc, hgb);
                }
                else
                {
                    if ((wmfexp)||(wPrintPrev))
						hgb = CreateSolidBrush(WHITE);
                    else
                    	hgb = CreateSolidBrush(BLACK);
                    hob = SelectObject(hdc, hgb);
                }
            }
            else if (wPlotSelect == IDM_PO_SUBDOMAIN)
            {
                if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG1)
                    isubdom = fem1->Decomp.SubDomsTriang1[polygons[p].mesh_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG2)
                    isubdom = fem1->Decomp.SubDomsTriang2[polygons[p].mesh_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG3)
                    isubdom = fem1->Decomp.SubDomsTriang3[polygons[p].mesh_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG4)
                    isubdom = fem1->Decomp.SubDomsTriang4[polygons[p].mesh_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG5)
                    isubdom = fem1->Decomp.SubDomsTriang5[polygons[p].mesh_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TETRAH1)
                    isubdom = fem1->Decomp.SubDomsTetrah1[polygons[p].mesh_index];

                if (w_iBW_subdomains)
                    elem_colour = wSubdomBWColours[(isubdom - 1)%MAX_ASSUMED_SUBDOMS_FOR_COLOURS];
                else
                    if (w4Col)
                            elem_colour = wSubdom4Col[wSD4Cols[isubdom-1]];
                        else
                        	elem_colour = wSubdomColours[(isubdom - 1)%MAX_ASSUMED_SUBDOMS_FOR_COLOURS];
                hgb = CreateSolidBrush(elem_colour);
                hob = SelectObject(hdc, hgb);
            }
            else if (wPlotSelect == IDM_PO_MESHPARAM)
            {
                if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG1)
                    dmeshparam = fem1->MeshParam.ElemMeshParamsTriang1[polygons[p].mesh_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG2)
                    dmeshparam = fem1->MeshParam.ElemMeshParamsTriang2[polygons[p].mesh_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG3)
                    dmeshparam = fem1->MeshParam.ElemMeshParamsTriang3[polygons[p].mesh_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG4)
                    dmeshparam = fem1->MeshParam.ElemMeshParamsTriang4[polygons[p].mesh_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG5)
                    dmeshparam = fem1->MeshParam.ElemMeshParamsTriang5[polygons[p].mesh_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TETRAH1)
                    dmeshparam = fem1->MeshParam.ElemMeshParamsTetrah1[polygons[p].mesh_index];
                if (dmeshparam / polygons[p].avsl <= 1.00)
                {
                    col = j_col_scale(1.00 - (dmeshparam / polygons[p].avsl), wZeta);
                    r = (int) ((double) MP_R_MAX * col);
                    g = (int) ((double) MP_G_MAX * col);
                    b = (int) ((double) MP_B_MAX * col);
                }
                else
                {
                    r = (int) ((double) 0x00);
                    g = (int) ((double) 0x00);
                    b = (int) ((double) 0x00);
                }
                elem_colour = RGB(r, g, b);
                hgb = CreateSolidBrush(elem_colour);
                hob = SelectObject(hdc, hgb);
            }
            else if (wPlotSelect == IDM_PO_ERROR)
            {
                if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG1)
                    derror = fem1->FEError.FEErrorsTriang1[polygons[p].mesh_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG2)
                    derror = fem1->FEError.FEErrorsTriang2[polygons[p].mesh_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG3)
                    derror = fem1->FEError.FEErrorsTriang3[polygons[p].mesh_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG4)
                    derror = fem1->FEError.FEErrorsTriang4[polygons[p].mesh_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG5)
                    derror = fem1->FEError.FEErrorsTriang5[polygons[p].mesh_index];

                if (derror <= w_maxerror)
                {
                    col = j_col_scale(derror / w_maxerror, wZeta);
                    r = (int) ((double) ER_R_MAX * col);
                    g = (int) ((double) ER_G_MAX * col);
                    b = (int) ((double) ER_B_MAX * col);
                }
                else
                {
                    r = ER_R_MAX;
                    g = ER_G_MAX;
                    b = ER_B_MAX;
                }
                elem_colour = RGB(r, g, b);
                hgb = CreateSolidBrush(elem_colour);
                hob = SelectObject(hdc, hgb);
            }
            else if (wPlotSelect == IDM_PO_STRESS)
            {
                switch (w_iWhichStress)
                {
                    case IDM_POO_XXSTRESS:
                        ste_index = E_SIGMA_X;
                        dmaxstress = w_maxXstress;
                        pos_r_max = STE_XX_POS_R_MAX;
                        pos_g_max = STE_XX_POS_G_MAX;
                        pos_b_max = STE_XX_POS_B_MAX;
                        neg_r_max = STE_XX_NEG_R_MAX;
                        neg_g_max = STE_XX_NEG_G_MAX;
                        neg_b_max = STE_XX_NEG_B_MAX;
                        break;
                    case IDM_POO_YYSTRESS:
                        ste_index = E_SIGMA_Y;
                        dmaxstress = w_maxYstress;
                        pos_r_max = STE_YY_POS_R_MAX;
                        pos_g_max = STE_YY_POS_G_MAX;
                        pos_b_max = STE_YY_POS_B_MAX;
                        neg_r_max = STE_YY_NEG_R_MAX;
                        neg_g_max = STE_YY_NEG_G_MAX;
                        neg_b_max = STE_YY_NEG_B_MAX;
                        break;
                    case IDM_POO_XYSTRESS:
                        ste_index = E_TAU_XY;
                        dmaxstress = w_maxXYstress;
                        pos_r_max = STE_XY_POS_R_MAX;
                        pos_g_max = STE_XY_POS_G_MAX;
                        pos_b_max = STE_XY_POS_B_MAX;
                        neg_r_max = STE_XY_NEG_R_MAX;
                        neg_g_max = STE_XY_NEG_G_MAX;
                        neg_b_max = STE_XY_NEG_B_MAX;
                        break;
                }
                if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG1)
                    dstress = fem1->Stresses.StressesTriang1[polygons[p].mesh_index][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG1]][ste_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG2)
                    dstress = fem1->Stresses.StressesTriang2[polygons[p].mesh_index][w_iWhichLayer][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG2]][ste_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG3)
                    dstress = fem1->Stresses.StressesTriang3[polygons[p].mesh_index][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG3]][ste_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG4)
                    dstress = fem1->Stresses.StressesTriang4[polygons[p].mesh_index][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG4]][ste_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_TRIANG5)
                    dstress = fem1->Stresses.StressesTriang5[polygons[p].mesh_index][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG5]][ste_index];

                if (dmaxstress!=0.00)
                	dstress /= dmaxstress * w_maxStress_percent / 100.00;
                if (dstress >= 0.00)
                    if (dstress <= 1.00)
                    {
                        col = j_col_scale(dstress, wZeta);
                        r = (int) ((double) pos_r_max * col);
                        g = (int) ((double) pos_g_max * col);
                        b = (int) ((double) pos_b_max * col);
                    }
                    else
                    {
                        r = pos_r_max;
                        g = pos_g_max;
                        b = pos_b_max;
                    }
                else if (dstress >= -1.00)
                {
                    col = j_col_scale(fabs(dstress), wZeta);
                    r = (int) ((double) neg_r_max * col);
                    g = (int) ((double) neg_g_max * col);
                    b = (int) ((double) neg_b_max * col);
                }
                else
                {
                    r = neg_r_max;
                    g = neg_g_max;
                    b = neg_b_max;
                }
                elem_colour = RGB(r, g, b);
                hgb = CreateSolidBrush(elem_colour);
                hob = SelectObject(hdc, hgb);
            }

            switch (wPlotSelect)
            {
                case IDM_PO_SUBDOMAIN:
                    if ((w_iBW_subdomains) || (wmfexp))
                        hgp = CreatePen(PS_SOLID, 1, BLACK);
                    else if (w_iSB)
                        hgp = CreatePen(PS_SOLID, 1, elem_colour);
                    else
                        hgp = CreatePen(PS_SOLID, 1, WHITE);
                    break;
                case IDM_PO_PLAINMESH:
                    if (wmfexp)
                        hgp = CreatePen(PS_SOLID, 1, BLACK);
                    else
                        hgp = CreatePen(PS_SOLID, 1, YELLOW);
                    break;
                case IDM_PO_MESHPARAM:
                case IDM_PO_STRESS:
                case IDM_PO_ERROR:
                    if (w_iSB)
                        hgp = CreatePen(PS_SOLID, 1, elem_colour);
                    else
                        hgp = CreatePen(PS_SOLID, 1, WHITE);
                    break;

            }
            hop = SelectObject(hdc, hgp);
            for (s=0;s<3;s++)
            {
            	triang[s].x = (short)(polygons[p].screen_coords[s][0]);
            	triang[s].y = (short)(polygons[p].screen_coords[s][1]);
            }
            Polygon(hdc, triang, 3);
            SelectObject(hdc, hob);
            DeleteObject(hgb);
            SelectObject(hdc, hop);
            DeleteObject(hgp);
            if (wDisplElemNo)
            {
                SetTextAlign(hdc, TA_CENTER | TA_BASELINE);
                nLength = sprintf(szBuffer, "%d", polygons[p].mesh_index + 1);
                TextOut(hdc, (triang[0].x + triang[1].x + triang[2].x) / 3.0, (triang[0].y + triang[1].y + triang[2].y) / 3.0, szBuffer, nLength);
            }
        }
        else if ((polygons[p].elem_type == E_ELEM_TYPE_QUAD1)||
        	     (polygons[p].elem_type == E_ELEM_TYPE_BLOCK1) )
        {
            if (wPlotSelect == IDM_PO_PLAINMESH)
            {
                if ((!wHidden)&&(!wAdvHidden))
                {
                    hgb = (HBRUSH) GetStockObject(HOLLOW_BRUSH);
                    hob = SelectObject(hdc, hgb);
                }
                else
                {
					if ((wmfexp)||(wPrintPrev))
						hgb = CreateSolidBrush(WHITE);
                    else
                    	hgb = CreateSolidBrush(BLACK);
                    hob = SelectObject(hdc, hgb);
                }
            }
            else if (wPlotSelect == IDM_PO_SUBDOMAIN)
            {
                if (polygons[p].elem_type == E_ELEM_TYPE_QUAD1)
                	isubdom = fem1->Decomp.SubDomsQuad1[polygons[p].mesh_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_BLOCK1)
                    isubdom = fem1->Decomp.SubDomsBlock1[polygons[p].mesh_index];

                if (w_iBW_subdomains)
                    elem_colour = wSubdomBWColours[(isubdom - 1)%MAX_ASSUMED_SUBDOMS_FOR_COLOURS];
                else
                    if (w4Col)
                            elem_colour = wSubdom4Col[wSD4Cols[isubdom-1]];
                        else
                        	elem_colour = wSubdomColours[(isubdom - 1)%MAX_ASSUMED_SUBDOMS_FOR_COLOURS];
                hgb = CreateSolidBrush(elem_colour);
                hob = SelectObject(hdc, hgb);
            }
            else if (wPlotSelect == IDM_PO_MESHPARAM)
            {
                if (polygons[p].elem_type == E_ELEM_TYPE_QUAD1)
					dmeshparam = fem1->MeshParam.ElemMeshParamsQuad1[polygons[p].mesh_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_BLOCK1)
                	dmeshparam = fem1->MeshParam.ElemMeshParamsBlock1[polygons[p].mesh_index];

                if (dmeshparam / polygons[p].avsl <= 1.00)
                {
                    col = j_col_scale(1.00 - (dmeshparam / polygons[p].avsl), wZeta);
                    r = (int) ((double) MP_R_MAX * col);
                    g = (int) ((double) MP_G_MAX * col);
                    b = (int) ((double) MP_B_MAX * col);
                }
                else
                {
                    r = (int) ((double) 0x00);
                    g = (int) ((double) 0x00);
                    b = (int) ((double) 0x00);
                }
                elem_colour = RGB(r, g, b);
                hgb = CreateSolidBrush(elem_colour);
                hob = SelectObject(hdc, hgb);
            }
            else if (wPlotSelect == IDM_PO_ERROR)
            {
                if (polygons[p].elem_type == E_ELEM_TYPE_QUAD1)
                	derror = fem1->FEError.FEErrorsQuad1[polygons[p].mesh_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_BLOCK1)
                	derror = fem1->FEError.FEErrorsBlock1[polygons[p].mesh_index];

                if (derror <= w_maxerror)
                {
                    col = j_col_scale(derror / w_maxerror, wZeta);
                    r = (int) ((double) ER_R_MAX * col);
                    g = (int) ((double) ER_G_MAX * col);
                    b = (int) ((double) ER_B_MAX * col);
                }
                else
                {
                    r = ER_R_MAX;
                    g = ER_G_MAX;
                    b = ER_B_MAX;
                }
                elem_colour = RGB(r, g, b);
                hgb = CreateSolidBrush(elem_colour);
                hob = SelectObject(hdc, hgb);
            }
            else if (wPlotSelect == IDM_PO_STRESS)
            {
                switch (w_iWhichStress)
                {
                    case IDM_POO_XXSTRESS:
                        ste_index = E_SIGMA_X;
                        dmaxstress = w_maxXstress;
                        pos_r_max = STE_XX_POS_R_MAX;
                        pos_g_max = STE_XX_POS_G_MAX;
                        pos_b_max = STE_XX_POS_B_MAX;
                        neg_r_max = STE_XX_NEG_R_MAX;
                        neg_g_max = STE_XX_NEG_G_MAX;
                        neg_b_max = STE_XX_NEG_B_MAX;
                        break;
                    case IDM_POO_YYSTRESS:
                        ste_index = E_SIGMA_Y;
                        dmaxstress = w_maxYstress;
                        pos_r_max = STE_YY_POS_R_MAX;
                        pos_g_max = STE_YY_POS_G_MAX;
                        pos_b_max = STE_YY_POS_B_MAX;
                        neg_r_max = STE_YY_NEG_R_MAX;
                        neg_g_max = STE_YY_NEG_G_MAX;
                        neg_b_max = STE_YY_NEG_B_MAX;
                        break;
                    case IDM_POO_XYSTRESS:
                        ste_index = E_TAU_XY;
                        dmaxstress = w_maxXYstress;
                        pos_r_max = STE_XY_POS_R_MAX;
                        pos_g_max = STE_XY_POS_G_MAX;
                        pos_b_max = STE_XY_POS_B_MAX;
                        neg_r_max = STE_XY_NEG_R_MAX;
                        neg_g_max = STE_XY_NEG_G_MAX;
                        neg_b_max = STE_XY_NEG_B_MAX;
                        break;
                }

                if (polygons[p].elem_type == E_ELEM_TYPE_QUAD1)
					dstress = fem1->Stresses.StressesQuad1[polygons[p].mesh_index][w_iWhichStressPoint[E_ELEM_TYPE_QUAD1]][ste_index];
                else if (polygons[p].elem_type == E_ELEM_TYPE_BLOCK1)
					dstress = fem1->Stresses.StressesBlock1[polygons[p].mesh_index][w_iWhichStressPoint[E_ELEM_TYPE_BLOCK1]][ste_index];

                if (dmaxstress!=0.00)
                	dstress /= dmaxstress * w_maxStress_percent / 100.00;

                if (dstress >= 0.00)
                    if (dstress <= 1.00)
                    {
                        col = j_col_scale(dstress, wZeta);
                        r = (int) ((double) pos_r_max * col);
                        g = (int) ((double) pos_g_max * col);
                        b = (int) ((double) pos_b_max * col);
                    }
                    else
                    {
                        r = pos_r_max;
                        g = pos_g_max;
                        b = pos_b_max;
                    }
                else if (dstress >= -1.00)
                {
                    col = j_col_scale(fabs(dstress), wZeta);
                    r = (int) ((double) neg_r_max * col);
                    g = (int) ((double) neg_g_max * col);
                    b = (int) ((double) neg_b_max * col);
                }
                else
                {
                    r = neg_r_max;
                    g = neg_g_max;
                    b = neg_b_max;
                }
                elem_colour = RGB(r, g, b);
                hgb = CreateSolidBrush(elem_colour);
                hob = SelectObject(hdc, hgb);
            }
            switch (wPlotSelect)
            {
                case IDM_PO_SUBDOMAIN:
                    if (w_iBW_subdomains)
                        hgp = CreatePen(PS_SOLID, 1, BLACK);
                    else if (w_iSB)
                        hgp = CreatePen(PS_SOLID, 1, elem_colour);
                    else
                        hgp = CreatePen(PS_SOLID, 1, WHITE);
                    break;
                case IDM_PO_PLAINMESH:
                    if (wmfexp)
                        hgp = CreatePen(PS_SOLID, 1, BLACK);
                    else
                        hgp = CreatePen(PS_SOLID, 1, YELLOW);
                    break;
                case IDM_PO_MESHPARAM:
                case IDM_PO_STRESS:
                case IDM_PO_ERROR:
                    if (w_iSB)
                        hgp = CreatePen(PS_SOLID, 1, elem_colour);
                    else
                        hgp = CreatePen(PS_SOLID, 1, WHITE);
                    break;
            }
            hop = SelectObject(hdc, hgp);
            for (s=0;s<4;s++)
        	{
            	quad[s].x = (short)(polygons[p].screen_coords[s][0]);
                quad[s].y = (short)(polygons[p].screen_coords[s][1]);
            }
            Polygon(hdc, quad, 4);
            SelectObject(hdc, hob);
            DeleteObject(hgb);
            SelectObject(hdc, hop);
            DeleteObject(hgp);
            if (wDisplElemNo)
            {
                SetTextAlign(hdc, TA_CENTER | TA_BASELINE);
                nLength = sprintf(szBuffer, "%d", polygons[p].mesh_index + 1);
                TextOut(hdc, (quad[0].x + quad[1].x + quad[2].x + quad[3].x) / 4.0, (quad[0].y + quad[1].y + quad[2].y + quad[3].y) / 4.0, szBuffer, nLength);
            }
        }
    }

    if (wDisplPointNo)
    {
        if (wmfexp)
        {
            SetTextColor(hdc, BLACK);
            SetBkColor(hdc, WHITE);
        }
        else
        {
            SetTextColor(hdc, SPRING_GREEN);
            SetBkColor(hdc, BLACK);
        }
        SetTextAlign(hdc, TA_RIGHT | TA_BOTTOM);
        for (i = 0; i < fem1->NMeshPoints; i++)
        {
            for (n = 0; n < 3; n++)
                tri_cent[n] = fem1->MeshPointCoords[i][n];
            j_3Dworld_to_screen(scrtri_cent, tri_cent);
            nLength = sprintf(szBuffer, "%d", i + 1);
            TextOut(hdc, scrtri_cent[XDIR], scrtri_cent[YDIR], szBuffer, nLength);
        }

        /* for TRIANG2 elements we need the midside Nodes too */
        if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG2])
        {
            int            *NodeUsed;

            NodeUsed = e_alloc_i_vect(fem1->NNodes);
            for (i = 0; i < fem1->NElemsTriang2; i++)
            {
                node = fem1->NodesTriang2[i][0] - 1;
                vnode1[XDIR] = fem1->MeshPointCoords[node][XDIR];
                vnode1[YDIR] = fem1->MeshPointCoords[node][YDIR];
                vnode1[ZDIR] = fem1->MeshPointCoords[node][ZDIR];

                node = fem1->NodesTriang2[i][1] - 1;
                vnode2[XDIR] = fem1->MeshPointCoords[node][XDIR];
                vnode2[YDIR] = fem1->MeshPointCoords[node][YDIR];
                vnode2[ZDIR] = fem1->MeshPointCoords[node][ZDIR];

                node = fem1->NodesTriang2[i][2] - 1;
                vnode3[XDIR] = fem1->MeshPointCoords[node][XDIR];
                vnode3[YDIR] = fem1->MeshPointCoords[node][YDIR];
                vnode3[ZDIR] = fem1->MeshPointCoords[node][ZDIR];

                for (n = 0; n < 3; n++)
                {
                    mnode1[n] = (vnode1[n] + vnode2[n]) / 2.00;
                    mnode2[n] = (vnode2[n] + vnode3[n]) / 2.00;
                    mnode3[n] = (vnode3[n] + vnode1[n]) / 2.00;
                }
                j_3Dworld_to_screen(scrvnode1, mnode1);
                j_3Dworld_to_screen(scrvnode2, mnode2);
                j_3Dworld_to_screen(scrvnode3, mnode3);

                node = fem1->NodesTriang2[i][3] - 1;
                if (!NodeUsed[node])
                {
                    nLength = sprintf(szBuffer, "%d", node + 1);
                    TextOut(hdc, scrvnode1[XDIR], scrvnode1[YDIR], szBuffer, nLength);
                    NodeUsed[node] = TRUE;
                }
                node = fem1->NodesTriang2[i][4] - 1;
                if (!NodeUsed[node])
                {
                    nLength = sprintf(szBuffer, "%d", node + 1);
                    TextOut(hdc, scrvnode2[XDIR], scrvnode2[YDIR], szBuffer, nLength);
                    NodeUsed[node] = TRUE;
                }
                node = fem1->NodesTriang2[i][5] - 1;
                if (!NodeUsed[node])
                {
                    nLength = sprintf(szBuffer, "%d", node + 1);
                    TextOut(hdc, scrvnode3[XDIR], scrvnode3[YDIR], szBuffer, nLength);
                    NodeUsed[node] = TRUE;
                }
            }
        }
    }
}         /* end of j_paint_screen_elems */


void	j_Det4Cols(int *wSD4Cols, int **wSDGraph, int nsd)
{
    int i,j,s,c,passed;
    FILE *fp;
	for(i=0;i<nsd;i++)
    	wSD4Cols[i]=-1;
    for(i=0;i<nsd;i++)
    {
        passed=FALSE;
		c=-1;
        while (!passed)
        {
            passed=TRUE;
            c++;
			for (j=0;j<nsd;j++)
            {
            	if (j>i)
                {
                    for (s=0;s<wSDGrDeg[i];s++)
                    	if (wSDGraph[i][s]==j+1)
                        	break;
                    if (s!=wSDGrDeg[i])
            			if (wSD4Cols[j]==c)
                        	passed=FALSE;
                }
                else if (j<i)
                {
                    for (s=0;s<wSDGrDeg[j];s++)
                    	if (wSDGraph[j][s]==i+1)
                        	break;
                    if (s!=wSDGrDeg[j])
            			if (wSD4Cols[j]==c)
                        	passed=FALSE;
                }
                if (!passed)
                	break;
            }
        }
        wSD4Cols[i]=c%6;
    }
}



double	j_getavsl(j_3Dvector node1, j_3Dvector node2)
{
 	double dx,dy,dz;

    dx=node1[XDIR]-node2[XDIR];
    dy=node1[YDIR]-node2[YDIR];
    dz=node1[ZDIR]-node2[ZDIR];

    return sqrt(pow(dx,2)+pow(dy,2)+pow(dz,2));

}

int j_do_projection(POLYGON *polygons, int NPoly)
{
    /* this function converts the 3D coords in the polygons to
       projected 2D coords */
       
    int     	p;	    	/* polygon index */
    int     	v;	    	/* vertex index */
    int     	d;  	    	/* dimension index */
    double  	centr[3];
    double  	worldnode[3];
    double  	screen_centr[3];
    double  	avsl;	    	/* average side length */
    
    for (p=0;p<NPoly;p++)
    {
    	for (d=0;d<3;d++)
	{
	    centr[d]=0;
	    for (v=0;v<polygons[p].no_vertices;v++)
	    	centr[d]+=polygons[p].world_coords[v][d];
	    centr[d]/=(double)polygons[p].no_vertices;
    	}
	polygons[p].vis=FALSE;
	for (v=0;v<polygons[p].no_vertices;v++)
	{
	    for (d=0;d<3;d++)
	    	if ((polygons[p].elem_type==E_ELEM_TYPE_LINK1)||
		    (polygons[p].elem_type==E_ELEM_TYPE_LINK2)||
		    (polygons[p].elem_type==E_ELEM_TYPE_LINK3)||
		    (polygons[p].elem_type==E_ELEM_TYPE_LINK4)||
		    (polygons[p].elem_type==E_ELEM_TYPE_LINK5)  )
		    worldnode[d]=centr[d]+(polygons[p].world_coords[v][d]-centr[d])*w_Link_Size_percent/100.00;
		else
		    worldnode[d]=centr[d]+(polygons[p].world_coords[v][d]-centr[d])*w_Element_Size_percent/100.00;
	    j_3Dworld_to_screen(polygons[p].screen_coords[v],worldnode);
	    if (((short)polygons[p].screen_coords[v][0]>0)||
	        ((short)polygons[p].screen_coords[v][0]<w_xmclient_size)||
		((short)polygons[p].screen_coords[v][1]>0)||
	        ((short)polygons[p].screen_coords[v][1]<w_ymclient_size)  )
		polygons[p].vis=TRUE;
    	}
	j_3Dworld_to_screen(screen_centr,centr);
	polygons[p].z=screen_centr[2];
	avsl=0.0;
	for (v=0;v<polygons[p].no_vertices;v++)
	    avsl+=j_getavsl(polygons[p].world_coords[v],polygons[p].world_coords[(v+1)%polygons[p].no_vertices]);
	avsl/=polygons[p].no_vertices;
	polygons[p].avsl=avsl;
    }
}

void j_sort_polygons(int *order,POLYGON *polygons,int Npoly)
{
    /** pg is the polygons temporarily made global **/
    pg=polygons;
    
    qsort((void *)order, Npoly, sizeof(int), j_compare_polygons);
    return;
}

int j_compare_polygons(const void *i, const void *j)
{
    /** pg is the polygons temporarily made global **/
    int *ii,*jj; 
    
    ii=(int *)i;
    jj=(int *)j;
    
    if (pg[*ii].z > pg[*jj].z)
    	return (1);
    if (pg[*ii].z < pg[*jj].z)
    	return (-1);
    return (0);
}

/********************************************************************/



void            j_drawscale(HDC hdc)
{
    register        i;
    HPEN            op;
    int             bxt, byt, bxe, bye, bxtext, bymaxside;
    int             base_length;
    double          nucol, nupix, di_line, col;
    int             r, g, b;
    char            szBuffer[80];
    short           nLength;

    int             midco;
    double          dmaxstress;
    int             pos_r_max, pos_g_max, pos_b_max, neg_r_max, neg_g_max,
                    neg_b_max;


    base_length = x_screen_size / 50;

    bxt = base_length / 2;
    bxe = base_length * 2;
    byt = base_length;
    bye = byt + y_screen_size / 2;
    bxtext = base_length * 5 / 2;


    op = (HPEN) SelectObject(hdc, CreatePen(PS_SOLID, 1, WHITE));
    MoveTo(hdc, bxt, byt);
    LineTo(hdc, bxtext, byt);

    MoveTo(hdc, bxe, byt);
    LineTo(hdc, bxe, bye);

    MoveTo(hdc, bxtext, bye);
    LineTo(hdc, bxt, bye);
    LineTo(hdc, bxt, byt);
    DeleteObject(SelectObject(hdc, op));


    midco = (bye - 1 + byt + 1) / 2;

    for (i = byt + 1; i < bye; i++)
    {
	if (wPlotSelect == IDM_PO_MESHPARAM)
	{
	    nucol = (double) (bye - byt - 1);
	    nupix = nucol / w_maxmeshparam * w_maxsidelength;
	    di_line = (double) (bye - 1 - i) / nupix;
	    if (di_line > 1.00)
	    {
		r = (int) ((double) 0x00);
		g = (int) ((double) 0x00);
		b = (int) ((double) 0x00);
	    }
	    else
	    {
		col = j_col_scale(1.00 - di_line, wZeta);
		r = (int) ((double) MP_R_MAX * col);
		g = (int) ((double) MP_G_MAX * col);
		b = (int) ((double) MP_B_MAX * col);
	    }
	}
	if (wPlotSelect == IDM_PO_STRESS)
	{
	    nucol = (double) (bye - byt - 1) / 2.00;
	    di_line = (double) (midco - i) / (nucol * w_maxStress_percent / 100.00);
	    switch (w_iWhichStress)
	    {
		case IDM_POO_XXSTRESS:
		    dmaxstress = w_maxXstress;
		    pos_r_max = STE_XX_POS_R_MAX;
		    pos_g_max = STE_XX_POS_G_MAX;
		    pos_b_max = STE_XX_POS_B_MAX;
		    neg_r_max = STE_XX_NEG_R_MAX;
		    neg_g_max = STE_XX_NEG_G_MAX;
		    neg_b_max = STE_XX_NEG_B_MAX;
		    break;
		case IDM_POO_YYSTRESS:
		    dmaxstress = w_maxYstress;
		    pos_r_max = STE_YY_POS_R_MAX;
		    pos_g_max = STE_YY_POS_G_MAX;
		    pos_b_max = STE_YY_POS_B_MAX;
		    neg_r_max = STE_YY_NEG_R_MAX;
		    neg_g_max = STE_YY_NEG_G_MAX;
		    neg_b_max = STE_YY_NEG_B_MAX;
		    break;
		case IDM_POO_XYSTRESS:
		    dmaxstress = w_maxXYstress;
		    pos_r_max = STE_XY_POS_R_MAX;
		    pos_g_max = STE_XY_POS_G_MAX;
		    pos_b_max = STE_XY_POS_B_MAX;
		    neg_r_max = STE_XY_NEG_R_MAX;
		    neg_g_max = STE_XY_NEG_G_MAX;
		    neg_b_max = STE_XY_NEG_B_MAX;
		    break;
	    }
	    if (di_line >= 0.00)
		if (di_line <= 1.00)
		{
		    double          col;

		    col = j_col_scale(di_line, wZeta);
		    r = (int) ((double) pos_r_max * col);
		    g = (int) ((double) pos_g_max * col);
		    b = (int) ((double) pos_b_max * col);
		}
		else
		{
		    r = pos_r_max;
		    g = pos_g_max;
		    b = pos_b_max;
		}
	    else if (di_line >= -1.00)
	    {
		double          col;

		col = j_col_scale(fabs(di_line), wZeta);
		r = (int) ((double) neg_r_max * col);
		g = (int) ((double) neg_g_max * col);
		b = (int) ((double) neg_b_max * col);
	    }
	    else
	    {
		r = neg_r_max;
		g = neg_g_max;
		b = neg_b_max;
	    }

	}			/* if -  IDM_PO_STRESS  */


	op = (HPEN) SelectObject(hdc, CreatePen(PS_SOLID, 1, RGB(r, g, b)));

	MoveTo(hdc, bxt + 1, i);
	LineTo(hdc, bxe, i);
	DeleteObject(SelectObject(hdc, op));
    }

    SetTextColor(hdc, WHITE);
    SetBkMode(hdc, TRANSPARENT);
    SetTextAlign(hdc, TA_LEFT | TA_BASELINE);

    if (wPlotSelect == IDM_PO_MESHPARAM)
    {
	nLength = sprintf(szBuffer, "%f", 0.00);
	TextOut(hdc, bxtext, bye, szBuffer, nLength);
	nLength = sprintf(szBuffer, "%f", w_maxmeshparam);
	TextOut(hdc, bxtext, byt, szBuffer, nLength);

	bymaxside = bye - (int) (nucol * w_maxsidelength / w_maxmeshparam);
	op = (HPEN) SelectObject(hdc, CreatePen(PS_SOLID, 1, WHITE));
	MoveTo(hdc, bxt, bymaxside);
	LineTo(hdc, bxtext, bymaxside);
	DeleteObject(SelectObject(hdc, op));
	nLength = sprintf(szBuffer, "%f", w_maxsidelength);
	TextOut(hdc, bxtext, bymaxside, szBuffer, nLength);

    }
    if (wPlotSelect == IDM_PO_STRESS)
    {
	nLength = sprintf(szBuffer, "%f", -1.00 * dmaxstress);
	TextOut(hdc, bxtext, bye, szBuffer, nLength);
	nLength = sprintf(szBuffer, "%f", dmaxstress);
	TextOut(hdc, bxtext, byt, szBuffer, nLength);

	op = (HPEN) SelectObject(hdc, CreatePen(PS_SOLID, 1, WHITE));
	MoveTo(hdc, bxt, midco);
	LineTo(hdc, bxtext, midco);
	DeleteObject(SelectObject(hdc, op));
	nLength = sprintf(szBuffer, "%f", 0.00);
	TextOut(hdc, bxtext, midco, szBuffer, nLength);

	bymaxside = midco - (int) (nucol * w_maxStress_percent / 100.00);
	op = (HPEN) SelectObject(hdc, CreatePen(PS_SOLID, 1, WHITE));
	MoveTo(hdc, bxt, bymaxside);
	LineTo(hdc, bxtext, bymaxside);
	DeleteObject(SelectObject(hdc, op));
	SetTextColor(hdc, YELLOW);
	nLength = sprintf(szBuffer, "%f", dmaxstress * w_maxStress_percent / 100.00);
	TextOut(hdc, bxtext, bymaxside, szBuffer, nLength);

	bymaxside = midco + (int) (nucol * w_maxStress_percent / 100.00);
	op = (HPEN) SelectObject(hdc, CreatePen(PS_SOLID, 1, WHITE));
	MoveTo(hdc, bxt, bymaxside);
	LineTo(hdc, bxtext, bymaxside);
	DeleteObject(SelectObject(hdc, op));
	nLength = sprintf(szBuffer, "%f", -1.00 * dmaxstress * w_maxStress_percent / 100.00);
	TextOut(hdc, bxtext, bymaxside, szBuffer, nLength);




	SetTextColor(hdc, RED);
	nLength = sprintf(szBuffer, "%.0f%%", w_maxStress_percent);
	TextOut(hdc, bxt, bye + base_length, szBuffer, nLength);
    }


}				/* end of function j_drawscale()   */



















void            j_drawZetascale(HDC hdc)
{
    register        i;
    HPEN            op;
    int             bxt, byt, bxe, bye, bxtext, bxoffset, bymaxside;
    int             base_length;
    double          nucol, nupix, di_line, col;
    int             r, g, b, ro, go, bo;
    char            szBuffer[80];
    short           nLength;

    int             midco;
    int             pos_r_max, pos_g_max, pos_b_max, neg_r_max, neg_g_max,
                    neg_b_max;

    HDC             MemDC, MemDC1;
    HBITMAP         OldBM, OldBM1;

    base_length = x_screen_size / 50;

    bxt = base_length / 2;
    bxe = base_length * 2;
    byt = base_length;
    bye = byt + y_screen_size / 2;
    bxtext = base_length * 5 / 2;
    bxoffset = base_length * 5;

    op = (HPEN) SelectObject(hdc, CreatePen(PS_SOLID, 1, WHITE));
    MoveTo(hdc, bxt, byt);
    LineTo(hdc, bxtext, byt);

    MoveTo(hdc, bxe, byt);
    LineTo(hdc, bxe, bye);

    MoveTo(hdc, bxtext, bye);
    LineTo(hdc, bxt, bye);
    LineTo(hdc, bxt, byt);


    MoveTo(hdc, bxoffset + bxt, byt);
    LineTo(hdc, bxoffset + bxtext, byt);

    MoveTo(hdc, bxoffset + bxe, byt);
    LineTo(hdc, bxoffset + bxe, bye);

    MoveTo(hdc, bxoffset + bxtext, bye);
    LineTo(hdc, bxoffset + bxt, bye);
    LineTo(hdc, bxoffset + bxt, byt);

    DeleteObject(SelectObject(hdc, op));


    midco = (bye - 1 + byt + 1) / 2;

    MemDC = CreateCompatibleDC(hdc);
    OldBM = (HBITMAP) SelectObject(MemDC, CreateCompatibleBitmap(hdc, bxe - bxt - 1, bye - byt - 1));
    MemDC1 = CreateCompatibleDC(hdc);
    OldBM1 = (HBITMAP) SelectObject(MemDC1, CreateCompatibleBitmap(hdc, bxe - bxt - 1, bye - byt - 1));

    for (i = byt + 1; i < bye; i++)
    {
	if (wPlotSelect == IDM_PO_MESHPARAM)
	{
	    nucol = (double) (bye - byt - 1);
	    nupix = nucol / w_maxmeshparam * w_maxsidelength;
	    di_line = (double) (bye - 1 - i) / nupix;
	    if (di_line > 1.00)
	    {
		r = (int) ((double) 0x00);
		g = (int) ((double) 0x00);
		b = (int) ((double) 0x00);
	    }
	    else
	    {
		col = j_col_scale(1.00 - di_line, wZeta);
		r = (int) ((double) MP_R_MAX * col);
		g = (int) ((double) MP_G_MAX * col);
		b = (int) ((double) MP_B_MAX * col);
	    }
	}
	if (wPlotSelect == IDM_PO_STRESS)
	{
	    nucol = (double) (bye - byt - 1) / 2.00;
	    di_line = (double) (midco - i) / (nucol * w_maxStress_percent / 100.00);
	    switch (w_iWhichStress)
	    {
		case IDM_POO_XXSTRESS:
		    pos_r_max = STE_XX_POS_R_MAX;
		    pos_g_max = STE_XX_POS_G_MAX;
		    pos_b_max = STE_XX_POS_B_MAX;
		    neg_r_max = STE_XX_NEG_R_MAX;
		    neg_g_max = STE_XX_NEG_G_MAX;
		    neg_b_max = STE_XX_NEG_B_MAX;
		    break;
		case IDM_POO_YYSTRESS:
		    pos_r_max = STE_YY_POS_R_MAX;
		    pos_g_max = STE_YY_POS_G_MAX;
		    pos_b_max = STE_YY_POS_B_MAX;
		    neg_r_max = STE_YY_NEG_R_MAX;
		    neg_g_max = STE_YY_NEG_G_MAX;
		    neg_b_max = STE_YY_NEG_B_MAX;
		    break;
		case IDM_POO_XYSTRESS:
		    pos_r_max = STE_XY_POS_R_MAX;
		    pos_g_max = STE_XY_POS_G_MAX;
		    pos_b_max = STE_XY_POS_B_MAX;
		    neg_r_max = STE_XY_NEG_R_MAX;
		    neg_g_max = STE_XY_NEG_G_MAX;
		    neg_b_max = STE_XY_NEG_B_MAX;
		    break;
	    }
	    if (di_line >= 0.00)
		if (di_line <= 1.00)
		{
		    double          col;

		    col = j_col_scale(di_line, wZeta);
		    r = (int) ((double) pos_r_max * col);
		    g = (int) ((double) pos_g_max * col);
		    b = (int) ((double) pos_b_max * col);
		    col = j_col_scale(di_line, INIT_ZETA);
		    ro = (int) ((double) pos_r_max * col);
		    go = (int) ((double) pos_g_max * col);
		    bo = (int) ((double) pos_b_max * col);
		}
		else
		{
		    r = ro = pos_r_max;
		    g = go = pos_g_max;
		    b = bo = pos_b_max;
		}
	    else if (di_line >= -1.00)
	    {
		double          col;

		col = j_col_scale(fabs(di_line), wZeta);
		r = (int) ((double) neg_r_max * col);
		g = (int) ((double) neg_g_max * col);
		b = (int) ((double) neg_b_max * col);
		col = j_col_scale(fabs(di_line), INIT_ZETA);
		ro = (int) ((double) neg_r_max * col);
		go = (int) ((double) neg_g_max * col);
		bo = (int) ((double) neg_b_max * col);
	    }
	    else
	    {
		r = ro = neg_r_max;
		g = go = neg_g_max;
		b = bo = neg_b_max;
	    }

	}			/* if -  IDM_PO_STRESS  */

	op = (HPEN) SelectObject(MemDC, CreatePen(PS_SOLID, 1, RGB(r, g, b)));
	MoveTo(MemDC, 0, i - byt - 1);
	LineTo(MemDC, bxe - bxt - 1, i - byt - 1);
	DeleteObject(SelectObject(MemDC, op));

	op = (HPEN) SelectObject(MemDC1, CreatePen(PS_SOLID, 1, RGB(ro, go, bo)));
	MoveTo(MemDC1, 0, i - byt - 1);
	LineTo(MemDC1, bxe - bxt - 1, i - byt - 1);
	DeleteObject(SelectObject(MemDC1, op));
    }

    BitBlt(hdc, bxt + 1, byt + 1, bxe - bxt - 1, bye - byt - 1, MemDC, 0, 0, SRCCOPY);
    DeleteObject(SelectObject(MemDC, OldBM));
    DeleteDC(MemDC);
    BitBlt(hdc, bxoffset + bxt + 1, byt + 1, bxe - bxt - 1, bye - byt - 1, MemDC1, 0, 0, SRCCOPY);
    DeleteObject(SelectObject(MemDC1, OldBM1));
    DeleteDC(MemDC1);


    SetBkMode(hdc, TRANSPARENT);
    SetTextAlign(hdc, TA_LEFT | TA_BASELINE);

    if (wPlotSelect == IDM_PO_STRESS)
    {
	op = (HPEN) SelectObject(hdc, CreatePen(PS_SOLID, 1, WHITE));
	MoveTo(hdc, bxt, midco);
	LineTo(hdc, bxtext, midco);
	MoveTo(hdc, bxoffset + bxt, midco);
	LineTo(hdc, bxoffset + bxtext, midco);

	bymaxside = midco - (int) (nucol * w_maxStress_percent / 100.00);
	MoveTo(hdc, bxt, bymaxside);
	LineTo(hdc, bxtext, bymaxside);
	MoveTo(hdc, bxoffset + bxt, bymaxside);
	LineTo(hdc, bxoffset + bxtext, bymaxside);

	bymaxside = midco + (int) (nucol * w_maxStress_percent / 100.00);
	MoveTo(hdc, bxt, bymaxside);
	LineTo(hdc, bxtext, bymaxside);
	MoveTo(hdc, bxoffset + bxt, bymaxside);
	LineTo(hdc, bxoffset + bxtext, bymaxside);

	DeleteObject(SelectObject(hdc, op));
    }

    SetTextColor(hdc, RED);
    nLength = sprintf(szBuffer, "%5.2f", wZeta);
    TextOut(hdc, bxt, bye + base_length, szBuffer, nLength);
    nLength = sprintf(szBuffer, "%5.2f", INIT_ZETA);
    TextOut(hdc, bxoffset + bxt, bye + base_length, szBuffer, nLength);


}				/* end of function j_drawZetascale()   */





double          j_col_scale(double x, double zeta)

{
    double          d_col;

    x = fabs(x);
    d_col = (x + zeta * (sqrt(x) - x));

    return (d_col);
}				/* end of function j_col_str()  */




void			j_draw_segment(HDC hdc, j_3Dvector vf, j_3Dvector vt)
{
    j_3Dvector		tnode;
    HPEN			hOldPen, hColPen;

    MoveTo(hdc, (int)vf[XDIR], (int)vf[YDIR]);
    if (vf[ZDIR]<=0)
		if (vt[ZDIR]<=0)
        {
    		hOldPen = SelectObject(hdc, CreatePen(PS_SOLID, 0, RGB(0x00, 0xFF, 0x00)));
            LineTo(hdc, (int) vt[XDIR], (int) vt[YDIR]);
            DeleteObject(SelectObject(hdc, hOldPen));
        }
        else
        {
            tnode[XDIR]=vf[XDIR]+(vt[XDIR]-vf[XDIR])*(0-vf[ZDIR])/(vt[ZDIR]-vf[ZDIR]);
            tnode[YDIR]=vf[YDIR]+(vt[YDIR]-vf[YDIR])*(0-vf[ZDIR])/(vt[ZDIR]-vf[ZDIR]);
            hOldPen = SelectObject(hdc, CreatePen(PS_SOLID, 0, RGB(0x00, 0xFF, 0x00)));
            LineTo(hdc, (int)tnode[XDIR], (int)tnode[YDIR]);
            DeleteObject(SelectObject(hdc, CreatePen(PS_SOLID, 0, RGB(0x00, 0x00, 0xFF))));
            LineTo(hdc, (int)vt[XDIR], (int)vt[YDIR]);
            DeleteObject(SelectObject(hdc, hOldPen)) ;
		}
    else
    	if (vt[ZDIR]>0)
        {
			hOldPen = SelectObject(hdc, CreatePen(PS_SOLID, 0, RGB(0x00, 0x00, 0xFF)));
            LineTo(hdc, (int)vt[XDIR], (int)vt[YDIR]);
            DeleteObject(SelectObject(hdc, hOldPen));
        }
        else
        {
            tnode[XDIR]=vf[XDIR]+(vt[XDIR]-vf[XDIR])*(0-vf[ZDIR])/(vt[ZDIR]-vf[ZDIR]);
            tnode[YDIR]=vf[YDIR]+(vt[YDIR]-vf[YDIR])*(0-vf[ZDIR])/(vt[ZDIR]-vf[ZDIR]);
            hOldPen = SelectObject(hdc, CreatePen(PS_SOLID, 0, RGB(0x00, 0x00, 0xFF)));
            LineTo(hdc, (int)tnode[XDIR], (int)tnode[YDIR]);
            DeleteObject(SelectObject(hdc, CreatePen(PS_SOLID, 0, RGB(0x00, 0xFF, 0x00))));
            LineTo(hdc, (int)vt[XDIR], (int)vt[YDIR]);
            DeleteObject(SelectObject(hdc, hOldPen));
		}
	return;
}



void            j_paintsimple_3Dfigure(HDC hdc, WORD wSelection)

{
    HPEN            hOldPen, hColPen, hCo2Pen;
    TEXTMETRIC      tm;
    short           cxChar, cyChar, nLength;
    char            szBuffer[80];
    int             T_length;

    j_3Dvector      qnode1, qnode2, qnode3, qnode4;
    j_3Dvector      lnode1, lnode2, lnode3, lnode4;
    j_3Dvector      qnode5, qnode6, qnode7, qnode8;
    j_3Dvector      lnode5, lnode6, lnode7, lnode8;
    j_3Dvector      qTarget, lTarget;
    //j_3Dvector qnodedm1, qnodedm2, qnodedm3, qnodedm4;
    //j_3Dvector lnodedm1, lnodedm2, lnodedm3, lnodedm4;
    j_3Dvector      qcnode1, qcnode2, qcnode3, qcnode4;
    j_3Dvector      lcnode1, lcnode2, lcnode3, lcnode4;
    j_3Dvector      qcnode5, qcnode6, qcnode7, qcnode8;
    j_3Dvector      lcnode5, lcnode6, lcnode7, lcnode8;


    GetTextMetrics(hdc, &tm);
    cxChar = tm.tmAveCharWidth;
    cyChar = tm.tmHeight + tm.tmExternalLeading;
    SetTextColor(hdc, RGB(0x00, 0x00, 0xFF));
    SetBkColor(hdc, RGB(0x00, 0x00, 0x00));


    switch (wSelection)
    {
	case IDM_P_AZIM_ELEV:
	    nLength = sprintf(szBuffer, "Position of the projection centre in global spherical system:");
	    TextOut(hdc, cxChar / 2, cxChar / 2, szBuffer, nLength);
	    nLength = sprintf(szBuffer, "Azimuth angle: %4d", (int) (G_Azim / M_PI * 180.00));
	    TextOut(hdc, cxChar / 2, cxChar / 2 + cyChar, szBuffer, nLength);
	    nLength = sprintf(szBuffer, "Elevation angle: %4d", (int) (G_Elev / M_PI * 180.00));
	    TextOut(hdc, cxChar / 2, cxChar / 2 + 2 * cyChar, szBuffer, nLength);
	    nLength = sprintf(szBuffer, "Distance: %6.2f", G_dTC);
	    TextOut(hdc, cxChar / 2, cxChar / 2 + 3 * cyChar, szBuffer, nLength);
	    break;
	case IDM_P_TCDIST_SCALE:
	    nLength = sprintf(szBuffer, "Distance of the perspective: %6.2f", G_dTC);
	    TextOut(hdc, cxChar / 2, cxChar / 2, szBuffer, nLength);
	    nLength = sprintf(szBuffer, "Image magnification: %6.2f", G_scale / G_initscale);
	    TextOut(hdc, cxChar / 2, cxChar / 2 + cyChar, szBuffer, nLength);
	    break;
	case IDM_P_TARGETCOORDS:
	case IDM_P_TARGETELEV:

	    nLength = sprintf(szBuffer, "Principal Target (or `look-at') point");
	    TextOut(hdc, cxChar / 2, cxChar / 2, szBuffer, nLength);
	    nLength = sprintf(szBuffer, "  co-ordinates: (%6.2f,%6.2f,%6.2f)", G_Target[XDIR], G_Target[YDIR], G_Target[ZDIR]);
	    TextOut(hdc, cxChar / 2, cxChar / 2 + cyChar, szBuffer, nLength);

	    qcnode1[XDIR] = G_Target[XDIR] - (w_dGlobCoordR - w_dGlobCoordL);
	    qcnode1[YDIR] = G_Target[YDIR];
	    qcnode1[ZDIR] = 0.00;
	    qcnode2[XDIR] = G_Target[XDIR] + (w_dGlobCoordR - w_dGlobCoordL);
	    qcnode2[YDIR] = G_Target[YDIR];
	    qcnode2[ZDIR] = 0.00;
	    qcnode3[XDIR] = G_Target[XDIR];
	    qcnode3[YDIR] = G_Target[YDIR] - (w_dGlobCoordT - w_dGlobCoordB);
	    qcnode3[ZDIR] = 0.00;
	    qcnode4[XDIR] = G_Target[XDIR];
	    qcnode4[YDIR] = G_Target[YDIR] + (w_dGlobCoordT - w_dGlobCoordB);
	    qcnode4[ZDIR] = 0.00;
	    qcnode5[XDIR] = G_Target[XDIR] - (w_dGlobCoordR - w_dGlobCoordL);
	    qcnode5[YDIR] = G_Target[YDIR];
	    qcnode5[ZDIR] = G_Target[ZDIR];
	    qcnode6[XDIR] = G_Target[XDIR] + (w_dGlobCoordR - w_dGlobCoordL);
	    qcnode6[YDIR] = G_Target[YDIR];
	    qcnode6[ZDIR] = G_Target[ZDIR];
	    qcnode7[XDIR] = G_Target[XDIR];
	    qcnode7[YDIR] = G_Target[YDIR] - (w_dGlobCoordT - w_dGlobCoordB);
	    qcnode7[ZDIR] = G_Target[ZDIR];
	    qcnode8[XDIR] = G_Target[XDIR];
	    qcnode8[YDIR] = G_Target[YDIR] + (w_dGlobCoordT - w_dGlobCoordB);
	    qcnode8[ZDIR] = G_Target[ZDIR];
	    j_3Dworld_to_screen(lcnode1, qcnode1);
	    j_3Dworld_to_screen(lcnode2, qcnode2);
	    j_3Dworld_to_screen(lcnode3, qcnode3);
	    j_3Dworld_to_screen(lcnode4, qcnode4);
	    j_3Dworld_to_screen(lcnode5, qcnode5);
	    j_3Dworld_to_screen(lcnode6, qcnode6);
	    j_3Dworld_to_screen(lcnode7, qcnode7);
	    j_3Dworld_to_screen(lcnode8, qcnode8);

	    hColPen = CreatePen(PS_SOLID, 0, YELLOW);
	    hOldPen = SelectObject(hdc, hColPen);
	    MoveTo(hdc, (int) lcnode1[XDIR], (int) lcnode1[YDIR]);
	    LineTo(hdc, (int) lcnode2[XDIR], (int) lcnode2[YDIR]);
	    MoveTo(hdc, (int) lcnode3[XDIR], (int) lcnode3[YDIR]);
	    LineTo(hdc, (int) lcnode4[XDIR], (int) lcnode4[YDIR]);
	    MoveTo(hdc, (int) lcnode5[XDIR], (int) lcnode5[YDIR]);
	    LineTo(hdc, (int) lcnode6[XDIR], (int) lcnode6[YDIR]);
	    MoveTo(hdc, (int) lcnode7[XDIR], (int) lcnode7[YDIR]);
	    LineTo(hdc, (int) lcnode8[XDIR], (int) lcnode8[YDIR]);
	    SelectObject(hdc, hOldPen);
	    DeleteObject(hColPen);

	default:
	    break;
    }

    qnode1[XDIR] = w_dGlobCoordL;
    qnode1[YDIR] = w_dGlobCoordB;
    qnode1[ZDIR] = w_dGlobCoordD;
    qnode2[XDIR] = w_dGlobCoordR;
    qnode2[YDIR] = w_dGlobCoordB;
    qnode2[ZDIR] = w_dGlobCoordD;
    qnode3[XDIR] = w_dGlobCoordR;
    qnode3[YDIR] = w_dGlobCoordT;
    qnode3[ZDIR] = w_dGlobCoordD;
    qnode4[XDIR] = w_dGlobCoordL;
    qnode4[YDIR] = w_dGlobCoordT;
    qnode4[ZDIR] = w_dGlobCoordD;
    qnode5[XDIR] = w_dGlobCoordL;
    qnode5[YDIR] = w_dGlobCoordB;
    qnode5[ZDIR] = w_dGlobCoordU;
    qnode6[XDIR] = w_dGlobCoordR;
    qnode6[YDIR] = w_dGlobCoordB;
    qnode6[ZDIR] = w_dGlobCoordU;
    qnode7[XDIR] = w_dGlobCoordR;
    qnode7[YDIR] = w_dGlobCoordT;
    qnode7[ZDIR] = w_dGlobCoordU;
    qnode8[XDIR] = w_dGlobCoordL;
    qnode8[YDIR] = w_dGlobCoordT;
    qnode8[ZDIR] = w_dGlobCoordU;
    qTarget[XDIR] = G_Target[XDIR];
    qTarget[YDIR] = G_Target[YDIR];
    qTarget[ZDIR] = G_Target[ZDIR];
    j_3Dworld_to_screen(lnode1, qnode1);
    j_3Dworld_to_screen(lnode2, qnode2);
    j_3Dworld_to_screen(lnode3, qnode3);
    j_3Dworld_to_screen(lnode4, qnode4);
    j_3Dworld_to_screen(lnode5, qnode5);
    j_3Dworld_to_screen(lnode6, qnode6);
    j_3Dworld_to_screen(lnode7, qnode7);
    j_3Dworld_to_screen(lnode8, qnode8);
    j_3Dworld_to_screen(lTarget, qTarget);
    j_3Dworld_to_screen(SO, OO);
    j_3Dworld_to_screen(SX, OX);
    j_3Dworld_to_screen(SY, OY);
    j_3Dworld_to_screen(SZ, OZ);


	if (!wClipPlane)
    {
	    hColPen = CreatePen(PS_SOLID, 0, RGB(0x00, 0xFF, 0x00));
    	hOldPen = SelectObject(hdc, hColPen);
        MoveTo(hdc, (int) lnode1[XDIR], (int) lnode1[YDIR]);
        LineTo(hdc, (int) lnode2[XDIR], (int) lnode2[YDIR]);
        LineTo(hdc, (int) lnode3[XDIR], (int) lnode3[YDIR]);
    	LineTo(hdc, (int) lnode4[XDIR], (int) lnode4[YDIR]);
    	LineTo(hdc, (int) lnode1[XDIR], (int) lnode1[YDIR]);
    	MoveTo(hdc, (int) lnode5[XDIR], (int) lnode5[YDIR]);
    	LineTo(hdc, (int) lnode6[XDIR], (int) lnode6[YDIR]);
    	LineTo(hdc, (int) lnode7[XDIR], (int) lnode7[YDIR]);
    	LineTo(hdc, (int) lnode8[XDIR], (int) lnode8[YDIR]);
    	LineTo(hdc, (int) lnode5[XDIR], (int) lnode5[YDIR]);
    	MoveTo(hdc, (int) lnode1[XDIR], (int) lnode1[YDIR]);
    	LineTo(hdc, (int) lnode5[XDIR], (int) lnode5[YDIR]);
	    MoveTo(hdc, (int) lnode2[XDIR], (int) lnode2[YDIR]);
	    LineTo(hdc, (int) lnode6[XDIR], (int) lnode6[YDIR]);
	    MoveTo(hdc, (int) lnode3[XDIR], (int) lnode3[YDIR]);
	    LineTo(hdc, (int) lnode7[XDIR], (int) lnode7[YDIR]);
	    MoveTo(hdc, (int) lnode4[XDIR], (int) lnode4[YDIR]);
	    LineTo(hdc, (int) lnode8[XDIR], (int) lnode8[YDIR]);
	    hCo2Pen = CreatePen(PS_SOLID, 0, SKY_BLUE);
    	SelectObject(hdc, hCo2Pen);
    	DeleteObject(hColPen);
    }
    else
    {
        j_draw_segment(hdc, lnode1, lnode2);
        j_draw_segment(hdc, lnode2, lnode3);
        j_draw_segment(hdc, lnode3, lnode4);
        j_draw_segment(hdc, lnode4, lnode1);
        j_draw_segment(hdc, lnode5, lnode6);
        j_draw_segment(hdc, lnode6, lnode7);
		j_draw_segment(hdc, lnode7, lnode8);
        j_draw_segment(hdc, lnode8, lnode5);
        j_draw_segment(hdc, lnode1, lnode5);
        j_draw_segment(hdc, lnode2, lnode6);
        j_draw_segment(hdc, lnode3, lnode7);
        j_draw_segment(hdc, lnode4, lnode8);

        hCo2Pen = CreatePen(PS_SOLID, 0, SKY_BLUE);
		hOldPen = SelectObject(hdc, hCo2Pen);

	}


    T_length = x_screen_size / 50;
    MoveTo(hdc, (int) lTarget[XDIR] - T_length / 2, (int) lTarget[YDIR]);
    LineTo(hdc, (int) lTarget[XDIR] + T_length / 2, (int) lTarget[YDIR]);
    MoveTo(hdc, (int) lTarget[XDIR], (int) lTarget[YDIR]);
    LineTo(hdc, (int) lTarget[XDIR], (int) lTarget[YDIR] + T_length);

    hColPen = CreatePen(PS_SOLID, 0, RGB(0xFF, 0x20, 0x20));
    SelectObject(hdc, hColPen);
    DeleteObject(hCo2Pen);

    //DeleteObject(SelectObject(hdc, CreatePen(PS_SOLID, 0, RGB(0xFF, 0x20, 0x20))));

    MoveTo(hdc, (int) SO[XDIR], (int) SO[YDIR]);
    LineTo(hdc, (int) SX[XDIR], (int) SX[YDIR]);
    MoveTo(hdc, (int) SO[XDIR], (int) SO[YDIR]);
    LineTo(hdc, (int) SY[XDIR], (int) SY[YDIR]);
    MoveTo(hdc, (int) SO[XDIR], (int) SO[YDIR]);
    LineTo(hdc, (int) SZ[XDIR], (int) SZ[YDIR]);

    SelectObject(hdc, hOldPen);
    DeleteObject(hColPen);

}				/* end of function: j_paintsimple_3Dfigure()  */





void            j_setup_stresspoints(void)
{
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG1])
	w_iWhichStressPoint[E_ELEM_TYPE_TRIANG1] = 0;
    else
	w_iWhichStressPoint[E_ELEM_TYPE_TRIANG1] = -1;
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG2])
	w_iWhichStressPoint[E_ELEM_TYPE_TRIANG2] = 0;
    else
	w_iWhichStressPoint[E_ELEM_TYPE_TRIANG2] = -1;
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG3])
	w_iWhichStressPoint[E_ELEM_TYPE_TRIANG3] = 0;
    else
	w_iWhichStressPoint[E_ELEM_TYPE_TRIANG3] = -1;
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG4])
	w_iWhichStressPoint[E_ELEM_TYPE_TRIANG4] = 0;
    else
	w_iWhichStressPoint[E_ELEM_TYPE_TRIANG4] = -1;
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG5])
	w_iWhichStressPoint[E_ELEM_TYPE_TRIANG5] = 0;
    else
	w_iWhichStressPoint[E_ELEM_TYPE_TRIANG5] = -1;
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK1])
	w_iWhichStressPoint[E_ELEM_TYPE_LINK1] = 0;
    else
	w_iWhichStressPoint[E_ELEM_TYPE_LINK1] = -1;
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK2])
	w_iWhichStressPoint[E_ELEM_TYPE_LINK2] = 0;
    else
	w_iWhichStressPoint[E_ELEM_TYPE_LINK2] = -1;
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK3])
	w_iWhichStressPoint[E_ELEM_TYPE_LINK3] = 0;
    else
	w_iWhichStressPoint[E_ELEM_TYPE_LINK3] = -1;
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK4])
	w_iWhichStressPoint[E_ELEM_TYPE_LINK4] = 0;
    else
	w_iWhichStressPoint[E_ELEM_TYPE_LINK4] = -1;
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK5])
	w_iWhichStressPoint[E_ELEM_TYPE_LINK5] = 0;
    else
	w_iWhichStressPoint[E_ELEM_TYPE_LINK5] = -1;
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_QUAD1])
	w_iWhichStressPoint[E_ELEM_TYPE_QUAD1] = 0;
    else
	w_iWhichStressPoint[E_ELEM_TYPE_QUAD1] = -1;
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TETRAH1])
	w_iWhichStressPoint[E_ELEM_TYPE_TETRAH1] = 0;
    else
	w_iWhichStressPoint[E_ELEM_TYPE_TETRAH1] = -1;

    return;
}				/* end j_setup_stresspoints */




void            j_getmaxstresses(void)
{
    register        i;

    w_maxXstress = 0.00;
    w_maxYstress = 0.00;
    w_maxXYstress = 0.00;

    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG1])
    {
	for (i = 0; i < fem1->NElemsTriang1; i++)
	{
	    if (fabs(fem1->Stresses.StressesTriang1[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG1]][E_SIGMA_X]) > w_maxXstress)
		w_maxXstress = fabs(fem1->Stresses.StressesTriang1[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG1]][E_SIGMA_X]);
	    if (fabs(fem1->Stresses.StressesTriang1[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG1]][E_SIGMA_Y]) > w_maxYstress)
		w_maxYstress = fabs(fem1->Stresses.StressesTriang1[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG1]][E_SIGMA_Y]);
	    if (fabs(fem1->Stresses.StressesTriang1[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG1]][E_TAU_XY]) > w_maxXYstress)
		w_maxXYstress = fabs(fem1->Stresses.StressesTriang1[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG1]][E_TAU_XY]);
	}
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG2])
    {
	for (i = 0; i < fem1->NElemsTriang2; i++)
	{
	    if (fabs(fem1->Stresses.StressesTriang2[i][w_iWhichLayer][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG2]][E_SIGMA_X]) > w_maxXstress)
		w_maxXstress = fabs(fem1->Stresses.StressesTriang2[i][w_iWhichLayer][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG2]][E_SIGMA_X]);
	    if (fabs(fem1->Stresses.StressesTriang2[i][w_iWhichLayer][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG2]][E_SIGMA_Y]) > w_maxYstress)
		w_maxYstress = fabs(fem1->Stresses.StressesTriang2[i][w_iWhichLayer][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG2]][E_SIGMA_Y]);
	    if (fabs(fem1->Stresses.StressesTriang2[i][w_iWhichLayer][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG2]][E_TAU_XY]) > w_maxXYstress)
		w_maxXYstress = fabs(fem1->Stresses.StressesTriang2[i][w_iWhichLayer][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG2]][E_TAU_XY]);
	}
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG3])
    {
	for (i = 0; i < fem1->NElemsTriang3; i++)
	{
	    if (fabs(fem1->Stresses.StressesTriang3[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG3]][E_SIGMA_X]) > w_maxXstress)
		w_maxXstress = fabs(fem1->Stresses.StressesTriang3[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG3]][E_SIGMA_X]);
	    if (fabs(fem1->Stresses.StressesTriang3[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG3]][E_SIGMA_Y]) > w_maxYstress)
		w_maxYstress = fabs(fem1->Stresses.StressesTriang3[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG3]][E_SIGMA_Y]);
	    if (fabs(fem1->Stresses.StressesTriang3[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG3]][E_TAU_XY]) > w_maxXYstress)
		w_maxXYstress = fabs(fem1->Stresses.StressesTriang3[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG3]][E_TAU_XY]);
	}
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG4])
    {
	for (i = 0; i < fem1->NElemsTriang4; i++)
	{
	    if (fabs(fem1->Stresses.StressesTriang4[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG4]][E_SIGMA_X]) > w_maxXstress)
		w_maxXstress = fabs(fem1->Stresses.StressesTriang4[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG4]][E_SIGMA_X]);
	    if (fabs(fem1->Stresses.StressesTriang4[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG4]][E_SIGMA_Y]) > w_maxYstress)
		w_maxYstress = fabs(fem1->Stresses.StressesTriang4[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG4]][E_SIGMA_Y]);
	    if (fabs(fem1->Stresses.StressesTriang4[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG4]][E_TAU_XY]) > w_maxXYstress)
		w_maxXYstress = fabs(fem1->Stresses.StressesTriang4[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG4]][E_TAU_XY]);
	}
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG5])
    {
	for (i = 0; i < fem1->NElemsTriang5; i++)
	{
	    if (fabs(fem1->Stresses.StressesTriang5[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG5]][E_SIGMA_X]) > w_maxXstress)
		w_maxXstress = fabs(fem1->Stresses.StressesTriang5[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG5]][E_SIGMA_X]);
	    if (fabs(fem1->Stresses.StressesTriang5[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG5]][E_SIGMA_Y]) > w_maxYstress)
		w_maxYstress = fabs(fem1->Stresses.StressesTriang5[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG5]][E_SIGMA_Y]);
	    if (fabs(fem1->Stresses.StressesTriang5[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG5]][E_TAU_XY]) > w_maxXYstress)
		w_maxXYstress = fabs(fem1->Stresses.StressesTriang5[i][w_iWhichStressPoint[E_ELEM_TYPE_TRIANG5]][E_TAU_XY]);
	}
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK1])
    {
	for (i = 0; i < fem1->NElemsLink1; i++)
	{
	    if (fabs(fem1->Stresses.StressesLink1[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK1]][E_SIGMA_X]) > w_maxXstress)
		w_maxXstress = fabs(fem1->Stresses.StressesLink1[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK1]][E_SIGMA_X]);
	    if (fabs(fem1->Stresses.StressesLink1[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK1]][E_SIGMA_Y]) > w_maxYstress)
		w_maxYstress = fabs(fem1->Stresses.StressesLink1[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK1]][E_SIGMA_Y]);
	    if (fabs(fem1->Stresses.StressesLink1[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK1]][E_TAU_XY]) > w_maxXYstress)
		w_maxXYstress = fabs(fem1->Stresses.StressesLink1[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK1]][E_TAU_XY]);
	}
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK2])
    {
	for (i = 0; i < fem1->NElemsLink2; i++)
	{
	    if (fabs(fem1->Stresses.StressesLink2[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK2]][E_SIGMA_X]) > w_maxXstress)
		w_maxXstress = fabs(fem1->Stresses.StressesLink2[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK2]][E_SIGMA_X]);
	    if (fabs(fem1->Stresses.StressesLink2[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK2]][E_SIGMA_Y]) > w_maxYstress)
		w_maxYstress = fabs(fem1->Stresses.StressesLink2[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK2]][E_SIGMA_Y]);
	    if (fabs(fem1->Stresses.StressesLink2[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK2]][E_TAU_XY]) > w_maxXYstress)
		w_maxXYstress = fabs(fem1->Stresses.StressesLink2[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK2]][E_TAU_XY]);
	}
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK3])
    {
	for (i = 0; i < fem1->NElemsLink3; i++)
	{
	    if (fabs(fem1->Stresses.StressesLink3[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK3]][E_SIGMA_X]) > w_maxXstress)
		w_maxXstress = fabs(fem1->Stresses.StressesLink3[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK3]][E_SIGMA_X]);
	    if (fabs(fem1->Stresses.StressesLink3[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK3]][E_SIGMA_Y]) > w_maxYstress)
		w_maxYstress = fabs(fem1->Stresses.StressesLink3[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK3]][E_SIGMA_Y]);
	    if (fabs(fem1->Stresses.StressesLink3[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK3]][E_TAU_XY]) > w_maxXYstress)
		w_maxXYstress = fabs(fem1->Stresses.StressesLink3[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK3]][E_TAU_XY]);
	}
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK4])
    {
	for (i = 0; i < fem1->NElemsLink4; i++)
	{
	    if (fabs(fem1->Stresses.StressesLink4[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK4]][E_SIGMA_X]) > w_maxXstress)
		w_maxXstress = fabs(fem1->Stresses.StressesLink4[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK4]][E_SIGMA_X]);
	    if (fabs(fem1->Stresses.StressesLink4[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK4]][E_SIGMA_Y]) > w_maxYstress)
		w_maxYstress = fabs(fem1->Stresses.StressesLink4[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK4]][E_SIGMA_Y]);
	    if (fabs(fem1->Stresses.StressesLink4[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK4]][E_TAU_XY]) > w_maxXYstress)
		w_maxXYstress = fabs(fem1->Stresses.StressesLink4[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK4]][E_TAU_XY]);
	}
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK5])
    {
	for (i = 0; i < fem1->NElemsLink5; i++)
	{
	    if (fabs(fem1->Stresses.StressesLink5[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK5]][E_SIGMA_X]) > w_maxXstress)
		w_maxXstress = fabs(fem1->Stresses.StressesLink5[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK5]][E_SIGMA_X]);
	    if (fabs(fem1->Stresses.StressesLink5[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK5]][E_SIGMA_Y]) > w_maxYstress)
		w_maxYstress = fabs(fem1->Stresses.StressesLink5[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK5]][E_SIGMA_Y]);
	    if (fabs(fem1->Stresses.StressesLink5[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK5]][E_TAU_XY]) > w_maxXYstress)
		w_maxXYstress = fabs(fem1->Stresses.StressesLink5[i][w_iWhichStressPoint[E_ELEM_TYPE_LINK5]][E_TAU_XY]);
	}
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_QUAD1])
    {
	for (i = 0; i < fem1->NElemsQuad1; i++)
	{
	    if (fabs(fem1->Stresses.StressesQuad1[i][w_iWhichStressPoint[E_ELEM_TYPE_QUAD1]][E_SIGMA_X]) > w_maxXstress)
		w_maxXstress = fabs(fem1->Stresses.StressesQuad1[i][w_iWhichStressPoint[E_ELEM_TYPE_QUAD1]][E_SIGMA_X]);
	    if (fabs(fem1->Stresses.StressesQuad1[i][w_iWhichStressPoint[E_ELEM_TYPE_QUAD1]][E_SIGMA_Y]) > w_maxYstress)
		w_maxYstress = fabs(fem1->Stresses.StressesQuad1[i][w_iWhichStressPoint[E_ELEM_TYPE_QUAD1]][E_SIGMA_Y]);
	    if (fabs(fem1->Stresses.StressesQuad1[i][w_iWhichStressPoint[E_ELEM_TYPE_QUAD1]][E_TAU_XY]) > w_maxXYstress)
		w_maxXYstress = fabs(fem1->Stresses.StressesQuad1[i][w_iWhichStressPoint[E_ELEM_TYPE_QUAD1]][E_TAU_XY]);
	}
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TETRAH1])
    {
	for (i = 0; i < fem1->NElemsTetrah1; i++)
	{
	    if (fabs(fem1->Stresses.StressesTetrah1[i][w_iWhichStressPoint[E_ELEM_TYPE_TETRAH1]][E_SIGMA_X]) > w_maxXstress)
		w_maxXstress = fabs(fem1->Stresses.StressesTetrah1[i][w_iWhichStressPoint[E_ELEM_TYPE_TETRAH1]][E_SIGMA_X]);
	    if (fabs(fem1->Stresses.StressesTetrah1[i][w_iWhichStressPoint[E_ELEM_TYPE_TETRAH1]][E_SIGMA_Y]) > w_maxYstress)
		w_maxYstress = fabs(fem1->Stresses.StressesTetrah1[i][w_iWhichStressPoint[E_ELEM_TYPE_TETRAH1]][E_SIGMA_Y]);
	    if (fabs(fem1->Stresses.StressesTetrah1[i][w_iWhichStressPoint[E_ELEM_TYPE_TETRAH1]][E_TAU_XY]) > w_maxXYstress)
		w_maxXYstress = fabs(fem1->Stresses.StressesTetrah1[i][w_iWhichStressPoint[E_ELEM_TYPE_TETRAH1]][E_TAU_XY]);
	}
    }

    return;
}				/* end of function j_getmaxstresses() */







double          j_getmaxerror(void)

{
    register        i;
    double          maxerror = 0.00;

    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK1])
    {
	for (i = 0; i < fem1->NElemsLink1; i++)
	    if (fem1->FEError.FEErrorsLink1[i] > maxerror)
		maxerror = fem1->FEError.FEErrorsLink1[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK2])
    {
	for (i = 0; i < fem1->NElemsLink2; i++)
	    if (fem1->FEError.FEErrorsLink2[i] > maxerror)
		maxerror = fem1->FEError.FEErrorsLink2[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK3])
    {
	for (i = 0; i < fem1->NElemsLink3; i++)
	    if (fem1->FEError.FEErrorsLink3[i] > maxerror)
		maxerror = fem1->FEError.FEErrorsLink3[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK4])
    {
	for (i = 0; i < fem1->NElemsLink4; i++)
	    if (fem1->FEError.FEErrorsLink4[i] > maxerror)
		maxerror = fem1->FEError.FEErrorsLink4[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK5])
    {
	for (i = 0; i < fem1->NElemsLink5; i++)
	    if (fem1->FEError.FEErrorsLink5[i] > maxerror)
		maxerror = fem1->FEError.FEErrorsLink5[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG1])
    {
	for (i = 0; i < fem1->NElemsTriang1; i++)
	    if (fem1->FEError.FEErrorsTriang1[i] > maxerror)
		maxerror = fem1->FEError.FEErrorsTriang1[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG2])
    {
	for (i = 0; i < fem1->NElemsTriang2; i++)
	    if (fem1->FEError.FEErrorsTriang2[i] > maxerror)
		maxerror = fem1->FEError.FEErrorsTriang2[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG3])
    {
	for (i = 0; i < fem1->NElemsTriang3; i++)
	    if (fem1->FEError.FEErrorsTriang3[i] > maxerror)
		maxerror = fem1->FEError.FEErrorsTriang3[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG4])
    {
	for (i = 0; i < fem1->NElemsTriang4; i++)
	    if (fem1->FEError.FEErrorsTriang4[i] > maxerror)
		maxerror = fem1->FEError.FEErrorsTriang4[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG5])
    {
	for (i = 0; i < fem1->NElemsTriang5; i++)
	    if (fem1->FEError.FEErrorsTriang5[i] > maxerror)
		maxerror = fem1->FEError.FEErrorsTriang5[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_QUAD1])
    {
	for (i = 0; i < fem1->NElemsQuad1; i++)
	    if (fem1->FEError.FEErrorsQuad1[i] > maxerror)
		maxerror = fem1->FEError.FEErrorsQuad1[i];
    }

    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TETRAH1])
    {
	for (i = 0; i < fem1->NElemsTetrah1; i++)
	    if (fem1->FEError.FEErrorsTetrah1[i] > maxerror)
		maxerror = fem1->FEError.FEErrorsTetrah1[i];
    }


    return (maxerror);
}				/* end of function j_getmaxerror()  */



















double          j_getmaxmeshparam(void)

{
    register        i;
    double          maxmesh = 0.00;

    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK1])
    {
	for (i = 0; i < fem1->NElemsLink1; i++)
	    if (fem1->MeshParam.ElemMeshParamsLink1[i] > maxmesh)
		maxmesh = fem1->MeshParam.ElemMeshParamsLink1[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK2])
    {
	for (i = 0; i < fem1->NElemsLink2; i++)
	    if (fem1->MeshParam.ElemMeshParamsLink2[i] > maxmesh)
		maxmesh = fem1->MeshParam.ElemMeshParamsLink2[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK3])
    {
	for (i = 0; i < fem1->NElemsLink3; i++)
	    if (fem1->MeshParam.ElemMeshParamsLink3[i] > maxmesh)
		maxmesh = fem1->MeshParam.ElemMeshParamsLink3[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK4])
    {
	for (i = 0; i < fem1->NElemsLink4; i++)
	    if (fem1->MeshParam.ElemMeshParamsLink4[i] > maxmesh)
		maxmesh = fem1->MeshParam.ElemMeshParamsLink4[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK5])
    {
	for (i = 0; i < fem1->NElemsLink5; i++)
	    if (fem1->MeshParam.ElemMeshParamsLink5[i] > maxmesh)
		maxmesh = fem1->MeshParam.ElemMeshParamsLink5[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG1])
    {
	for (i = 0; i < fem1->NElemsTriang1; i++)
	    if (fem1->MeshParam.ElemMeshParamsTriang1[i] > maxmesh)
		maxmesh = fem1->MeshParam.ElemMeshParamsTriang1[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG2])
    {
	for (i = 0; i < fem1->NElemsTriang2; i++)
	    if (fem1->MeshParam.ElemMeshParamsTriang2[i] > maxmesh)
		maxmesh = fem1->MeshParam.ElemMeshParamsTriang2[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG3])
    {
	for (i = 0; i < fem1->NElemsTriang3; i++)
	    if (fem1->MeshParam.ElemMeshParamsTriang3[i] > maxmesh)
		maxmesh = fem1->MeshParam.ElemMeshParamsTriang3[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG4])
    {
	for (i = 0; i < fem1->NElemsTriang4; i++)
	    if (fem1->MeshParam.ElemMeshParamsTriang4[i] > maxmesh)
		maxmesh = fem1->MeshParam.ElemMeshParamsTriang4[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG5])
    {
	for (i = 0; i < fem1->NElemsTriang5; i++)
	    if (fem1->MeshParam.ElemMeshParamsTriang5[i] > maxmesh)
		maxmesh = fem1->MeshParam.ElemMeshParamsTriang5[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_QUAD1])
    {
	for (i = 0; i < fem1->NElemsQuad1; i++)
	    if (fem1->MeshParam.ElemMeshParamsQuad1[i] > maxmesh)
		maxmesh = fem1->MeshParam.ElemMeshParamsQuad1[i];
    }
    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TETRAH1])
    {
	for (i = 0; i < fem1->NElemsTetrah1; i++)
	    if (fem1->MeshParam.ElemMeshParamsTetrah1[i] > maxmesh)
		maxmesh = fem1->MeshParam.ElemMeshParamsTetrah1[i];
    }

    return (maxmesh);
}				/* end of function j_getmaxmeshparam()  */













double          j_getmaxsidelength(POLYGON *polygons, int Npoly)

{
    double          maxlength;
    int             i;

    maxlength = 0.0;
    for (i = 0; i < Npoly; i++)
    {
	if ((polygons[i].elem_type != E_ELEM_TYPE_LINK1) &&
	    (polygons[i].elem_type != E_ELEM_TYPE_LINK2) &&
	    (polygons[i].elem_type != E_ELEM_TYPE_LINK3) &&
	    (polygons[i].elem_type != E_ELEM_TYPE_LINK4) &&
	    (polygons[i].elem_type != E_ELEM_TYPE_LINK5))
	{
	    if (polygons[i].avsl > maxlength)
		maxlength = polygons[i].avsl;
	}
    }
    return (maxlength);


}				/* end of function j_getmaxsidelength()  */


double          j_getminsidelength(POLYGON *polygons, int Npoly)

{
    double          minlength;
    int             i;
    double 			length;

    minlength = 1e10;
    for (i = 0; i < Npoly; i++)
    {
		if ((polygons[i].elem_type != E_ELEM_TYPE_LINK1) &&
	    	(polygons[i].elem_type != E_ELEM_TYPE_LINK2) &&
	    	(polygons[i].elem_type != E_ELEM_TYPE_LINK3) &&
	    	(polygons[i].elem_type != E_ELEM_TYPE_LINK4) &&
	    	(polygons[i].elem_type != E_ELEM_TYPE_LINK5))
		{
	    	if (polygons[i].avsl < minlength)
				minlength = polygons[i].avsl;
		}
        else
        {
            length=sqrt(pow(polygons[i].world_coords[0][0]-polygons[i].world_coords[1][0],2)+
                        pow(polygons[i].world_coords[0][1]-polygons[i].world_coords[1][1],2) );
        	if (length < minlength)
				minlength = length;
        }
    }
    return (minlength);


}				/* end of function j_getminsidelength()  */








double          j_getlength(int p1, int p2)

{
    double          length, dx, dy, dz;

    dx = fem1->MeshPointCoords[p2 - 1][XDIR] - fem1->MeshPointCoords[p1 - 1][XDIR];
    dy = fem1->MeshPointCoords[p2 - 1][YDIR] - fem1->MeshPointCoords[p1 - 1][YDIR];
    dz = fem1->MeshPointCoords[p2 - 1][ZDIR] - fem1->MeshPointCoords[p1 - 1][ZDIR];
    length = sqrt(j_sqx(dx) + j_sqx(dy) + j_sqx(dz));

    return (length);
}				/* end of function j_getlength()  */





void            j_FileInitialize(HWND hwnd)

{
    static char    *szFilter[] = {"Mesh Definition Files (*.mdf)", "*.mdf",
	"All Files (*.*)", "*.*",
    ""};

    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = hwnd;
    ofn.hInstance = NULL;
    ofn.lpstrFilter = szFilter[0];
    ofn.lpstrCustomFilter = NULL;
    ofn.nMaxCustFilter = 0;
    ofn.nFilterIndex = 1;
    ofn.lpstrFile = NULL;
    ofn.nMaxFile = _MAX_PATH;
    ofn.lpstrFileTitle = NULL;
    ofn.nMaxFileTitle = _MAX_FNAME + _MAX_EXT;
    ofn.lpstrInitialDir = NULL;
    ofn.lpstrTitle = "E_Plot32 - Mesh Definition File Open";
    ofn.lpstrInitialDir = NULL;
    ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_PATHMUSTEXIST;
    ofn.nFileOffset = 0;
    ofn.nFileExtension = 0;
    ofn.lpstrDefExt = "mdf";
    ofn.lCustData = 0L;
    ofn.lpfnHook = NULL;
    ofn.lpTemplateName = NULL;
}




BOOL            j_FileOpenDlg(HWND hwnd, LPSTR lpstrFileName, LPSTR lpstrTitleName)

{
    ofn.hwndOwner = hwnd;
    ofn.lpstrFile = lpstrFileName;
    ofn.lpstrFileTitle = lpstrTitleName;
    ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_PATHMUSTEXIST;
    return GetOpenFileName(&ofn);
}


char            szCaption[120];


void            j_DoCaption(HWND hwnd, char *szTitleName)
{
    //GetWindowText(hwnd, szCaption, 120);
    strcpy(szCaption, szEnWindowTitle);
    strcat(szCaption, "   -   ");
    strcat(szCaption, (szTitleName[0] ? szTitleName : "(UNTITLED)"));

    SetWindowText(hwnd, szCaption);
}




BOOL            j_FileSaveDlg(HWND hwnd, LPSTR lpstrFileName, LPSTR lpstrTitleName)
{
    static char    *szFilter[] = {"Enhanced Windows Metafile (*.emf)", "*.emf",
	"All Files (*.*)", "*.*",
    ""};
    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = hwnd;
    ofn.lpstrFilter = szFilter[0];
    ofn.lpstrFile = lpstrFileName;
    ofn.nMaxFile = sizeof(lpstrFileName);
    ofn.lpstrFileTitle = lpstrTitleName;
    ofn.nMaxFileTitle = sizeof(lpstrTitleName);
    ofn.lpstrInitialDir = (LPSTR) NULL;
    ofn.Flags = OFN_OVERWRITEPROMPT;
    ofn.lpstrTitle = "E-Plot - Image Save As";
    ofn.lpstrDefExt = "emf";

    return GetSaveFileName(&ofn);
}



BOOL            j_FileSaveImage(HWND hwndEdit, LPSTR lpstrFileName)
{
    HANDLE          hBuffer;
    int             hFile;
    LPSTR           lpstrBuffer;
    WORD            wLength;

    if (-1 == (hFile = _lopen(lpstrFileName, OF_WRITE | OF_SHARE_EXCLUSIVE)))
	if (-1 == (hFile = _lcreat(lpstrFileName, 0)))
	    return FALSE;

    wLength = GetWindowTextLength(hwndEdit);
    hBuffer = (HANDLE) SendMessage(hwndEdit, EM_GETHANDLE, 0, 0L);
    lpstrBuffer = (LPSTR) LocalLock(hBuffer);

    if (wLength != _lwrite(hFile, lpstrBuffer, wLength))
    {
	_lclose(hFile);
	return FALSE;
    }

    _lclose(hFile);
    LocalUnlock(hBuffer);

    return TRUE;
}



BOOL FAR PASCAL _export AboutEplotDlgProc(HWND hDlg, UINT message, UINT wParam, LONG lParam)
{

    switch (message)
    {
	    case WM_INITDIALOG:
	    return (TRUE);
	case WM_COMMAND:
	    switch (wParam)
	    {
		case IDOK:
		    EndDialog(hDlg, 0);
		    return (TRUE);
	    }
	    break;
    }

    return (FALSE);
}				/* end of dialogbox procedure
				   AboutEplotDlgProc()  */


BOOL FAR PASCAL _export GIDlgProc(HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
    register        i;
    char            szBuffer[10];
    char  			lpString[10];
    double          dnewval;
    BOOL            bsucc;

    switch (message)
    {
	case WM_INITDIALOG:
    	sprintf(szBuffer, "%d", (int) (G_Azim / M_PI * 180.00));
        SetDlgItemText(hDlg, IDC_GI_AZIM, szBuffer);
        sprintf(szBuffer, "%d", (int) (G_Elev / M_PI * 180.00));
        SetDlgItemText(hDlg, IDC_GI_ELEV, szBuffer);
		sprintf(szBuffer, "%1.5lf", G_dTC);
        SetDlgItemText(hDlg, IDC_GI_DTC, szBuffer);
		sprintf(szBuffer, "%1.5lf", G_scale);
        SetDlgItemText(hDlg, IDC_GI_SCALE, szBuffer);
        sprintf(szBuffer, "%1.5lf", G_Target[0]);
        SetDlgItemText(hDlg, IDC_GI_TARGETX, szBuffer);
        sprintf(szBuffer, "%1.5lf", G_Target[1]);
        SetDlgItemText(hDlg, IDC_GI_TARGETY, szBuffer);
        sprintf(szBuffer, "%1.5lf", G_Target[2]);
        SetDlgItemText(hDlg, IDC_GI_TARGETZ, szBuffer);
        return (TRUE);
	case WM_COMMAND:
	    switch (wParam)
	    {
			case IDC_GI_APPLY:
				bsucc = GetDlgItemText(hDlg, IDC_GI_AZIM, lpString, 10);
				if (!bsucc)
				{
			    	sprintf(szBuffer, "%d", (int) (G_Azim / M_PI * 180.00));
        			SetDlgItemText(hDlg, IDC_GI_AZIM, szBuffer);
        			w_OkMsgBox("Please specify a valid azimut value!");
			    	return (TRUE);
				}
            	if (sscanf(lpString,"%lf",&dnewval)!=1)
				{
			    	sprintf(szBuffer, "%d", (int) (G_Azim / M_PI * 180.00));
        			SetDlgItemText(hDlg, IDC_GI_AZIM, szBuffer);
        			w_OkMsgBox("Please specify a valid azimut value!");
			    	return (TRUE);
				}
				G_Azim=dnewval*M_PI/180.00;

                bsucc = GetDlgItemText(hDlg, IDC_GI_ELEV, lpString, 10);
				if (!bsucc)
				{
			    	sprintf(szBuffer, "%d", (int) (G_Elev / M_PI * 180.00));
        			SetDlgItemText(hDlg, IDC_GI_ELEV, szBuffer);
        			w_OkMsgBox("Please specify a valid elevation value!");
			    	return (TRUE);
				}
            	if (sscanf(lpString,"%lf",&dnewval)!=1)
				{
			    	sprintf(szBuffer, "%d", (int) (G_Elev / M_PI * 180.00));
        			SetDlgItemText(hDlg, IDC_GI_ELEV, szBuffer);
        			w_OkMsgBox("Please specify a valid elevation value!");
			    	return (TRUE);
				}
				G_Elev=dnewval*M_PI/180.00;

                bsucc = GetDlgItemText(hDlg, IDC_GI_DTC, lpString, 10);
				if (!bsucc)
				{
			    	sprintf(szBuffer, "%1.5lf",G_dTC);
        			SetDlgItemText(hDlg, IDC_GI_DTC, szBuffer);
        			w_OkMsgBox("Please specify a valid target distance value!");
			    	return (TRUE);
				}
            	if (sscanf(lpString,"%lf",&dnewval)!=1)
				{
			    	sprintf(szBuffer, "%1.5lf",G_dTC);
        			SetDlgItemText(hDlg, IDC_GI_DTC, szBuffer);
        			w_OkMsgBox("Please specify a valid target distance value!");
			    	return (TRUE);
				}
				G_dTC=dnewval;

				bsucc = GetDlgItemText(hDlg, IDC_GI_SCALE, lpString, 10);
				if (!bsucc)
				{
			    	sprintf(szBuffer, "%1.5lf",G_scale);
        			SetDlgItemText(hDlg, IDC_GI_SCALE, szBuffer);
        			w_OkMsgBox("Please specify a valid scale value!");
			    	return (TRUE);
				}
            	if (sscanf(lpString,"%lf",&dnewval)!=1)
				{
			    	sprintf(szBuffer, "%1.5lf",G_scale);
        			SetDlgItemText(hDlg, IDC_GI_SCALE, szBuffer);
        			w_OkMsgBox("Please specify a valid scale value!");
			    	return (TRUE);
				}
				G_scale=dnewval;

				bsucc = GetDlgItemText(hDlg, IDC_GI_TARGETX, lpString, 10);
				if (!bsucc)
				{
			    	sprintf(szBuffer, "%1.5lf",G_Target[0]);
        			SetDlgItemText(hDlg, IDC_GI_TARGETX, szBuffer);
        			w_OkMsgBox("Please specify a valid target coordinate value!");
			    	return (TRUE);
				}
            	if (sscanf(lpString,"%lf",&dnewval)!=1)
				{
			    	sprintf(szBuffer, "%1.5lf",G_Target[0]);
        			SetDlgItemText(hDlg, IDC_GI_TARGETX, szBuffer);
        			w_OkMsgBox("Please specify a valid target coordinate value!");
			    	return (TRUE);
				}
				G_Target[0]=dnewval;

				bsucc = GetDlgItemText(hDlg, IDC_GI_TARGETY, lpString, 10);
				if (!bsucc)
				{
			    	sprintf(szBuffer, "%1.5lf",G_Target[1]);
        			SetDlgItemText(hDlg, IDC_GI_TARGETY, szBuffer);
        			w_OkMsgBox("Please specify a valid target coordinate value!");
			    	return (TRUE);
				}
            	if (sscanf(lpString,"%lf",&dnewval)!=1)
				{
			    	sprintf(szBuffer, "%1.5lf",G_Target[1]);
        			SetDlgItemText(hDlg, IDC_GI_TARGETY, szBuffer);
        			w_OkMsgBox("Please specify a valid target coordinate value!");
			    	return (TRUE);
				}
				G_Target[1]=dnewval;

				bsucc = GetDlgItemText(hDlg, IDC_GI_TARGETZ, lpString, 10);
				if (!bsucc)
				{
			    	sprintf(szBuffer, "%1.5lf",G_Target[2]);
        			SetDlgItemText(hDlg, IDC_GI_TARGETZ, szBuffer);
        			w_OkMsgBox("Please specify a valid target coordinate value!");
			    	return (TRUE);
				}
            	if (sscanf(lpString,"%lf",&dnewval)!=1)
				{
			    	sprintf(szBuffer, "%1.5lf",G_Target[2]);
        			SetDlgItemText(hDlg, IDC_GI_TARGETZ, szBuffer);
        			w_OkMsgBox("Please specify a valid target coordinate value!");
			    	return (TRUE);
				}
				G_Target[2]=dnewval;

                j_3Drecalc_rot_matrix();
				InvalidateRect(G_main_hwnd, NULL, TRUE);
                EndDialog(hDlg, 0);
                return (TRUE);
			case IDCANCEL:
		    	EndDialog(hDlg, 0);
		    	return (TRUE);
            case IDC_GI_PLAN:
				sprintf(szBuffer, "-90");
                SetDlgItemText(hDlg, IDC_GI_AZIM, szBuffer);
        		sprintf(szBuffer, "90");
        		SetDlgItemText(hDlg, IDC_GI_ELEV, szBuffer);
				sprintf(szBuffer, "%1.5lf", w_maxsize * 20000.00);
        		SetDlgItemText(hDlg, IDC_GI_DTC, szBuffer);
				sprintf(szBuffer, "%1.5lf", min((double) w_xmclient_size, (double) w_ymclient_size) * 0.90 / w_maxsize);
        		SetDlgItemText(hDlg, IDC_GI_SCALE, szBuffer);
        		sprintf(szBuffer, "%1.5lf", w_dGlobCoordL + (w_dGlobCoordR - w_dGlobCoordL) / 2.00);
        		SetDlgItemText(hDlg, IDC_GI_TARGETX, szBuffer);
        		sprintf(szBuffer, "%1.5lf", w_dGlobCoordB + (w_dGlobCoordT - w_dGlobCoordB) / 2.00);
        		SetDlgItemText(hDlg, IDC_GI_TARGETY, szBuffer);
        		sprintf(szBuffer, "%1.5lf", w_dGlobCoordD + (w_dGlobCoordU - w_dGlobCoordD) / 2.00);
        		SetDlgItemText(hDlg, IDC_GI_TARGETZ, szBuffer);
                return (TRUE);
            case IDC_GI_NICE:
                sprintf(szBuffer, "%d", INIT_AZIMUTH);
                SetDlgItemText(hDlg, IDC_GI_AZIM, szBuffer);
        		sprintf(szBuffer, "%d", INIT_ELEVATION);
        		SetDlgItemText(hDlg, IDC_GI_ELEV, szBuffer);
				sprintf(szBuffer, "%1.5lf", w_maxsize * 2.00);
        		SetDlgItemText(hDlg, IDC_GI_DTC, szBuffer);
				sprintf(szBuffer, "%1.5lf", min((double) w_xmclient_size, (double) w_ymclient_size) * 0.80 / w_maxsize);
        		SetDlgItemText(hDlg, IDC_GI_SCALE, szBuffer);
        		sprintf(szBuffer, "%1.5lf", w_dGlobCoordL + (w_dGlobCoordR - w_dGlobCoordL) / 2.00);
        		SetDlgItemText(hDlg, IDC_GI_TARGETX, szBuffer);
        		sprintf(szBuffer, "%1.5lf", w_dGlobCoordB + (w_dGlobCoordT - w_dGlobCoordB) / 2.00);
        		SetDlgItemText(hDlg, IDC_GI_TARGETY, szBuffer);
        		sprintf(szBuffer, "%1.5lf", w_dGlobCoordD + (w_dGlobCoordU - w_dGlobCoordD) / 2.00);
        		SetDlgItemText(hDlg, IDC_GI_TARGETZ, szBuffer);
                return (TRUE);
	    }
	    break;
    }
    return FALSE;
}


BOOL FAR PASCAL _export SpSelDlgProc(HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
    register        i;
    char            szBuffer[10];
    int             inewsp;
    BOOL            bsucc;

    switch (message)
    {
	case WM_INITDIALOG:

	    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG1])
	    {
		SendDlgItemMessage(hDlg, IDC_UD_TRIANG1, UDM_SETRANGE, 0, (LPARAM) MAKELONG((short) fem1->NStressPointsTriang1, (short) 1));
		sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TRIANG1] + 1);
	    }
	    else
	    {
		strcpy(szBuffer, "N/A");
		SendDlgItemMessage(hDlg, IDC_TRIANG1, EM_SETREADONLY, TRUE, 0);
		ShowWindow(GetDlgItem(hDlg, IDC_UD_TRIANG1), SW_HIDE);
	    }
	    SetDlgItemText(hDlg, IDC_TRIANG1, szBuffer);

	    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG2])
	    {
		SendDlgItemMessage(hDlg, IDC_UD_TRIANG2, UDM_SETRANGE, 0, (LPARAM) MAKELONG((short) fem1->NStressPointsTriang2, (short) 1));
		sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TRIANG2] + 1);
	    }
	    else
	    {
		strcpy(szBuffer, "N/A");
		SendDlgItemMessage(hDlg, IDC_TRIANG2, EM_SETREADONLY, TRUE, 0);
		ShowWindow(GetDlgItem(hDlg, IDC_UD_TRIANG2), SW_HIDE);
	    }
	    SetDlgItemText(hDlg, IDC_TRIANG2, szBuffer);

	    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG3])
	    {
		SendDlgItemMessage(hDlg, IDC_UD_TRIANG3, UDM_SETRANGE, 0, (LPARAM) MAKELONG((short) fem1->NStressPointsTriang3, (short) 1));
		sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TRIANG3] + 1);
	    }
	    else
	    {
		strcpy(szBuffer, "N/A");
		SendDlgItemMessage(hDlg, IDC_TRIANG3, EM_SETREADONLY, TRUE, 0);
		ShowWindow(GetDlgItem(hDlg, IDC_UD_TRIANG3), SW_HIDE);
	    }
	    SetDlgItemText(hDlg, IDC_TRIANG3, szBuffer);

	    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG4])
	    {
		SendDlgItemMessage(hDlg, IDC_UD_TRIANG4, UDM_SETRANGE, 0, (LPARAM) MAKELONG((short) fem1->NStressPointsTriang4, (short) 1));
		sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TRIANG4] + 1);
	    }
	    else
	    {
		strcpy(szBuffer, "N/A");
		SendDlgItemMessage(hDlg, IDC_TRIANG4, EM_SETREADONLY, TRUE, 0);
		ShowWindow(GetDlgItem(hDlg, IDC_UD_TRIANG4), SW_HIDE);
	    }
	    SetDlgItemText(hDlg, IDC_TRIANG4, szBuffer);

	    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG5])
	    {
		SendDlgItemMessage(hDlg, IDC_UD_TRIANG5, UDM_SETRANGE, 0, (LPARAM) MAKELONG((short) fem1->NStressPointsTriang5, (short) 1));
		sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TRIANG5] + 1);
	    }
	    else
	    {
		strcpy(szBuffer, "N/A");
		SendDlgItemMessage(hDlg, IDC_TRIANG5, EM_SETREADONLY, TRUE, 0);
		ShowWindow(GetDlgItem(hDlg, IDC_UD_TRIANG5), SW_HIDE);
	    }
	    SetDlgItemText(hDlg, IDC_TRIANG5, szBuffer);

	    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK1])
	    {
		SendDlgItemMessage(hDlg, IDC_UD_LINK1, UDM_SETRANGE, 0, (LPARAM) MAKELONG((short) fem1->NStressPointsLink1, (short) 1));
		sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_LINK1] + 1);
	    }
	    else
	    {
		strcpy(szBuffer, "N/A");
		SendDlgItemMessage(hDlg, IDC_LINK1, EM_SETREADONLY, TRUE, 0);
		ShowWindow(GetDlgItem(hDlg, IDC_UD_LINK1), SW_HIDE);
	    }
	    SetDlgItemText(hDlg, IDC_LINK1, szBuffer);

	    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK2])
	    {
		SendDlgItemMessage(hDlg, IDC_UD_LINK2, UDM_SETRANGE, 0, (LPARAM) MAKELONG((short) fem1->NStressPointsLink2, (short) 1));
		sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_LINK2] + 1);
	    }
	    else
	    {
		strcpy(szBuffer, "N/A");
		SendDlgItemMessage(hDlg, IDC_LINK2, EM_SETREADONLY, TRUE, 0);
		ShowWindow(GetDlgItem(hDlg, IDC_UD_LINK2), SW_HIDE);
	    }
	    SetDlgItemText(hDlg, IDC_LINK2, szBuffer);

	    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK3])
	    {
		SendDlgItemMessage(hDlg, IDC_UD_LINK3, UDM_SETRANGE, 0, (LPARAM) MAKELONG((short) fem1->NStressPointsLink3, (short) 1));
		sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_LINK3] + 1);
	    }
	    else
	    {
		strcpy(szBuffer, "N/A");
		SendDlgItemMessage(hDlg, IDC_LINK3, EM_SETREADONLY, TRUE, 0);
		ShowWindow(GetDlgItem(hDlg, IDC_UD_LINK3), SW_HIDE);
	    }
	    SetDlgItemText(hDlg, IDC_LINK3, szBuffer);

	    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK4])
	    {
		SendDlgItemMessage(hDlg, IDC_UD_LINK4, UDM_SETRANGE, 0, (LPARAM) MAKELONG((short) fem1->NStressPointsLink4, (short) 1));
		sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_LINK4] + 1);
	    }
	    else
	    {
		strcpy(szBuffer, "N/A");
		SendDlgItemMessage(hDlg, IDC_LINK4, EM_SETREADONLY, TRUE, 0);
		ShowWindow(GetDlgItem(hDlg, IDC_UD_LINK4), SW_HIDE);
	    }
	    SetDlgItemText(hDlg, IDC_LINK4, szBuffer);

	    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK5])
	    {
		SendDlgItemMessage(hDlg, IDC_UD_LINK5, UDM_SETRANGE, 0, (LPARAM) MAKELONG((short) fem1->NStressPointsLink5, (short) 1));
		sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_LINK5] + 1);
	    }
	    else
	    {
		strcpy(szBuffer, "N/A");
		SendDlgItemMessage(hDlg, IDC_LINK5, EM_SETREADONLY, TRUE, 0);
		ShowWindow(GetDlgItem(hDlg, IDC_UD_LINK5), SW_HIDE);
	    }
	    SetDlgItemText(hDlg, IDC_LINK5, szBuffer);

	    if (fem1->KeywordSet[E_KW_NUM_NELEMS_QUAD1])
	    {
		SendDlgItemMessage(hDlg, IDC_UD_QUAD1, UDM_SETRANGE, 0, (LPARAM) MAKELONG((short) fem1->NStressPointsQuad1, (short) 1));
		sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_QUAD1] + 1);
	    }
	    else
	    {
		strcpy(szBuffer, "N/A");
		SendDlgItemMessage(hDlg, IDC_QUAD1, EM_SETREADONLY, TRUE, 0);
		ShowWindow(GetDlgItem(hDlg, IDC_UD_QUAD1), SW_HIDE);
	    }
	    SetDlgItemText(hDlg, IDC_QUAD1, szBuffer);

	    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TETRAH1])
	    {
		SendDlgItemMessage(hDlg, IDC_UD_TETRAH1, UDM_SETRANGE, 0, (LPARAM) MAKELONG((short) fem1->NStressPointsTetrah1, (short) 1));
		sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TETRAH1] + 1);
	    }
	    else
	    {
		strcpy(szBuffer, "N/A");
		SendDlgItemMessage(hDlg, IDC_TETRAH1, EM_SETREADONLY, TRUE, 0);
		ShowWindow(GetDlgItem(hDlg, IDC_UD_TETRAH1), SW_HIDE);
	    }
	    SetDlgItemText(hDlg, IDC_TETRAH1, szBuffer);
	    return (TRUE);
	case WM_COMMAND:
	    switch (wParam)
	    {
		case IDOK:
		    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG1])
		    {
			inewsp = GetDlgItemInt(hDlg, IDC_TRIANG1, &bsucc, TRUE);
			if (!bsucc)
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TRIANG1] + 1);
			    SetDlgItemText(hDlg, IDC_TRIANG1, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			if ((inewsp < 1) || (inewsp > fem1->NStressPointsTriang1))
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TRIANG1] + 1);
			    SetDlgItemText(hDlg, IDC_TRIANG1, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			w_iWhichStressPoint[E_ELEM_TYPE_TRIANG1] = inewsp - 1;
		    }
		    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG2])
		    {
			inewsp = GetDlgItemInt(hDlg, IDC_TRIANG2, &bsucc, TRUE);
			if (!bsucc)
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TRIANG2] + 1);
			    SetDlgItemText(hDlg, IDC_TRIANG2, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			if ((inewsp < 1) || (inewsp > fem1->NStressPointsTriang2))
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TRIANG2] + 1);
			    SetDlgItemText(hDlg, IDC_TRIANG2, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			w_iWhichStressPoint[E_ELEM_TYPE_TRIANG2] = inewsp - 1;
		    }
		    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG3])
		    {
			inewsp = GetDlgItemInt(hDlg, IDC_TRIANG3, &bsucc, TRUE);
			if (!bsucc)
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TRIANG3] + 1);
			    SetDlgItemText(hDlg, IDC_TRIANG3, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			if ((inewsp < 1) || (inewsp > fem1->NStressPointsTriang3))
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TRIANG3] + 1);
			    SetDlgItemText(hDlg, IDC_TRIANG3, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			w_iWhichStressPoint[E_ELEM_TYPE_TRIANG3] = inewsp - 1;
		    }
		    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG4])
		    {
			inewsp = GetDlgItemInt(hDlg, IDC_TRIANG4, &bsucc, TRUE);
			if (!bsucc)
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TRIANG4] + 1);
			    SetDlgItemText(hDlg, IDC_TRIANG4, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			if ((inewsp < 1) || (inewsp > fem1->NStressPointsTriang4))
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TRIANG4] + 1);
			    SetDlgItemText(hDlg, IDC_TRIANG4, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			w_iWhichStressPoint[E_ELEM_TYPE_TRIANG4] = inewsp - 1;
		    }
		    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TRIANG5])
		    {
			inewsp = GetDlgItemInt(hDlg, IDC_TRIANG1, &bsucc, TRUE);
			if (!bsucc)
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TRIANG5] + 1);
			    SetDlgItemText(hDlg, IDC_TRIANG5, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			if ((inewsp < 1) || (inewsp > fem1->NStressPointsTriang5))
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TRIANG5] + 1);
			    SetDlgItemText(hDlg, IDC_TRIANG5, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			w_iWhichStressPoint[E_ELEM_TYPE_TRIANG5] = inewsp - 1;
		    }
		    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK1])
		    {
			inewsp = GetDlgItemInt(hDlg, IDC_LINK1, &bsucc, TRUE);
			if (!bsucc)
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_LINK1] + 1);
			    SetDlgItemText(hDlg, IDC_LINK1, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			if ((inewsp < 1) || (inewsp > fem1->NStressPointsLink1))
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_LINK1] + 1);
			    SetDlgItemText(hDlg, IDC_LINK1, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			w_iWhichStressPoint[E_ELEM_TYPE_LINK1] = inewsp - 1;
		    }
		    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK2])
		    {
			inewsp = GetDlgItemInt(hDlg, IDC_LINK2, &bsucc, TRUE);
			if (!bsucc)
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_LINK2] + 1);
			    SetDlgItemText(hDlg, IDC_LINK2, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			if ((inewsp < 1) || (inewsp > fem1->NStressPointsLink2))
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_LINK2] + 1);
			    SetDlgItemText(hDlg, IDC_LINK2, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			w_iWhichStressPoint[E_ELEM_TYPE_LINK2] = inewsp - 1;
		    }
		    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK3])
		    {
			inewsp = GetDlgItemInt(hDlg, IDC_LINK3, &bsucc, TRUE);
			if (!bsucc)
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_LINK3] + 1);
			    SetDlgItemText(hDlg, IDC_LINK3, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			if ((inewsp < 1) || (inewsp > fem1->NStressPointsLink3))
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_LINK3] + 1);
			    SetDlgItemText(hDlg, IDC_LINK3, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			w_iWhichStressPoint[E_ELEM_TYPE_LINK3] = inewsp - 1;
		    }
		    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK4])
		    {
			inewsp = GetDlgItemInt(hDlg, IDC_LINK4, &bsucc, TRUE);
			if (!bsucc)
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_LINK4] + 1);
			    SetDlgItemText(hDlg, IDC_LINK4, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			if ((inewsp < 1) || (inewsp > fem1->NStressPointsLink4))
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_LINK4] + 1);
			    SetDlgItemText(hDlg, IDC_LINK4, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			w_iWhichStressPoint[E_ELEM_TYPE_LINK4] = inewsp - 1;
		    }
		    if (fem1->KeywordSet[E_KW_NUM_NELEMS_LINK5])
		    {
			inewsp = GetDlgItemInt(hDlg, IDC_LINK5, &bsucc, TRUE);
			if (!bsucc)
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_LINK5] + 1);
			    SetDlgItemText(hDlg, IDC_LINK5, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			if ((inewsp < 1) || (inewsp > fem1->NStressPointsLink5))
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_LINK5] + 1);
			    SetDlgItemText(hDlg, IDC_LINK5, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			w_iWhichStressPoint[E_ELEM_TYPE_LINK5] = inewsp - 1;
		    }
		    if (fem1->KeywordSet[E_KW_NUM_NELEMS_QUAD1])
		    {
			inewsp = GetDlgItemInt(hDlg, IDC_QUAD1, &bsucc, TRUE);
			if (!bsucc)
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_QUAD1] + 1);
			    SetDlgItemText(hDlg, IDC_QUAD1, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			if ((inewsp < 1) || (inewsp > fem1->NStressPointsQuad1))
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_QUAD1] + 1);
			    SetDlgItemText(hDlg, IDC_QUAD1, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			w_iWhichStressPoint[E_ELEM_TYPE_QUAD1] = inewsp - 1;
		    }
		    if (fem1->KeywordSet[E_KW_NUM_NELEMS_TETRAH1])
		    {
			inewsp = GetDlgItemInt(hDlg, IDC_TETRAH1, &bsucc, TRUE);
			if (!bsucc)
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TETRAH1] + 1);
			    SetDlgItemText(hDlg, IDC_TETRAH1, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			if ((inewsp < 1) || (inewsp > fem1->NStressPointsTetrah1))
			{
			    sprintf(szBuffer, "%d", w_iWhichStressPoint[E_ELEM_TYPE_TETRAH1] + 1);
			    SetDlgItemText(hDlg, IDC_TETRAH1, szBuffer);
			    w_OkMsgBox("Please specify a valid stresspoint index!");
			    return (TRUE);
			}
			w_iWhichStressPoint[E_ELEM_TYPE_TETRAH1] = inewsp - 1;
		    }
            InvalidateRect(G_main_hwnd, NULL, TRUE);
		    EndDialog(hDlg, 0);
		    return (TRUE);
		case IDCANCEL:
		    EndDialog(hDlg, 0);
		    return (TRUE);
	    }
	    break;
    }
    return FALSE;
}				/* end of dialogbox procedure SpSelDlgProc()  */



BOOL FAR PASCAL _export ZoomToDlgProc(HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
    register        i;
    char            szBuffer[10];
    BOOL            bsucc;
    int				iztnode;

    switch (message)
    {
	case WM_INITDIALOG:

		SendDlgItemMessage(hDlg, IDC_UD_NODE, UDM_SETRANGE, 0, (LPARAM) MAKELONG((short) fem1->NNodes, (short) 1));
		sprintf(szBuffer, "1");
	    SetDlgItemText(hDlg, IDC_NODE, szBuffer);
	    return (TRUE);

	case WM_COMMAND:
	    switch (wParam)
	    {
		case IDC_ZT_NODE:
            iztnode = GetDlgItemInt(hDlg, IDC_NODE, &bsucc, TRUE);
		    if (!bsucc)
			{
			    sprintf(szBuffer, "1");
			    SetDlgItemText(hDlg, IDC_NODE, szBuffer);
			    w_OkMsgBox("Please specify a valid node index!");
			    return (TRUE);
			}
			if ((iztnode < 1) || (iztnode > fem1->NNodes))
			{
			    sprintf(szBuffer, "1");
			    SetDlgItemText(hDlg, IDC_NODE, szBuffer);
			    w_OkMsgBox("Please specify a valid node index!");
			    return (TRUE);
			}
            j_zoom_to_node(iztnode);
		    EndDialog(hDlg, 0);
		    return (TRUE);
		case IDCANCEL:
		    EndDialog(hDlg, 0);
		    return (TRUE);
	    }
	    break;
    }
    return FALSE;
}				/* end of dialogbox procedure ZoomToDlgProc()  */




void j_zoom_to_node(int n)
{
	G_Xscrorigin = w_xmclient_size / 2;
  	G_Yscrorigin = w_ymclient_size / 2;
	G_Target[XDIR] = fem1->MeshPointCoords[n-1][0];
    G_Target[YDIR] = fem1->MeshPointCoords[n-1][1];
    G_Target[ZDIR] = fem1->MeshPointCoords[n-1][2];
    G_scale *=2;
	InvalidateRect(G_main_hwnd, NULL, TRUE);
}





/* End Of File: E-PLOT.C  */
